#include <stdio.h>
#include <algorithm>
#include <vector>
#include <utility>
#include <iostream>
#include <iomanip>

using std::vector;
using std::cout;
#define pi std::pair<int, int>
#define mp std::make_pair

const int BASE = 1000;

int compare(vector<int> &a, vector<int> &b) {
	int a_size = (int)a.size();
	int b_size = (int)b.size();
	while (a_size > 0 && a_size > b_size) {
		if (a[--a_size]) {
			return 1;
		}
	}

	while (b_size > 0 && b_size > a_size) {
		if (b[--b_size]) {
			return -1;
		}
	}

	// now sizes are equal    
	int a_digit, b_digit;
	for (int i = a_size - 1; i >= 0; --i) {
		a_digit = a[i];
		b_digit = b[i];
		if (a_digit < b_digit) {
			return -1;
		}
		if (a_digit > b_digit) {
			return 1;
		}
	}
	return 0;
}

void inplace_add(vector<int> &a, vector<int> &b) {
	int a_size = (int)a.size();
	int b_size = (int)b.size();
	int i, carry = 0;
	for (i = 0; i < std::max(a_size, b_size) || carry; ++i) {
		if ((int)a.size() <= i) {
			a.push_back(0);
		}
		a[i] += carry + (i < b_size ? b[i] : 0);
		carry = a[i] >= BASE;
		if (carry) {
			a[i] -= BASE;
		}
	}
}

void write_number(vector<int> &a) {
	int size = (int)a.size();
	if (size == 0) {
		cout << '0';
		return;
	}
	else {
		cout << a[size - 1];
		for (int i = size - 2; i >= 0; --i)
			cout << std::setw(4) << std::setfill('0') << a[i];
	}
}

int main() {
	int p;
	scanf("%d", &p);
	vector<int> kek[26];
	vector<pi> lol[26];
	for (int i = 0; i < p; i++) {
		char c, c1, c2;
		scanf("\n%c -> %c", &c, &c1);
		if (c1 >= 'A' && c1 <= 'Z') {
			scanf("%c", &c2);
			lol[c - 'A'].push_back(mp(c1 - 'A', c2 - 'A'));
		} else {
			kek[c1 - 'a'].push_back(c - 'A');
		}
	}
	int n, m, s, t;
	scanf("%d%d%d%d", &n, &m, &s, &t);
	s--, t--;
	vector<int> dp[n][n][26];
	bool azaz[n][n][26];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < 26; k++) {
				azaz[i][j][k] = false;
			}
		}
	}
	for (int i = 0; i < m; i++) {
		int u, v;
		char x;
		scanf("%d%d %c", &u, &v, &x);
		u--, v--;
		x -= 'a';
		for (int j : kek[x]) {
			dp[u][v][j].push_back(1);
			azaz[u][v][j] = 1;
		}
	}
	bool flag = true;
	while (flag) {
		flag = false;
		for (int _ = 0; _ < 26; _++) {
			for (pi pa : lol[_]) {
				for (int i = 0; i < n; i++) {
					for (int j = 0; j < n; j++) {
						for (int k = 0; k < n; k++) {
							//printf("%c %c%c %d %d %d\n", _ + 'A', (char)pa.first + 'A', (char)pa.second + 'A', i, j, k);
							if (azaz[j][i][pa.first] && azaz[i][k][pa.second]) {
								vector<int> enot = dp[j][i][pa.first];
								inplace_add(enot, dp[i][k][pa.second]);
								if (!azaz[j][k][_] || compare(enot, dp[j][k][_]) == -1) {
									flag = true;
									dp[j][k][_] = enot;
									azaz[j][k][_] = true;
								}
							}
						}
					}
				}
			}
		}
	}
	if (azaz[s][t]['S' - 'A']) {
		write_number(dp[s][t]['S' - 'A']);
		//printf("%d", dp[s][t]['S' - 'A'][0]);
	} else {
		printf("NO");
	}
	return 0;
}
