#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <map>
#include<unordered_map>
#include<cmath>
#pragma optimizer("O3")

using namespace std;
unordered_map<int, vector<pair<int, int>>> gr(1e5);//graph
vector<pair<int, int>> unsuccess;//bad edges
vector<pair<int, int>> all;//all adges(out)
vector<int> path;//Euler path
vector<bool> used;
unordered_map<int, int> deg(1e5);// indeg for every vertex
unordered_map<int, bool> reachable(1e5);

void findEuler(int v) {
    reachable[v] = true;
    if (gr.find(v) == gr.end()) {
        return;
    }
    for (auto e: gr[v]) {
        if (!used[e.second - 1]) {
            used[e.second - 1] = true;
            findEuler(e.first);
            path.push_back(e.second);
        }
    }
}

int main() {
    int n, start;
    std::ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> start;
    for (int i = 0; i < n; i++) {
        int f, t, w;
        cin >> f >> t >> w;
        used.push_back(false);
        all.push_back({f, t});
        deg[f] = 0;
        deg[t] = 0;
        if (w == 1) {
            if (gr.find(f) == gr.end()) {
                gr[f] = {};
                reachable[f] = false;

            }
            if (gr.find(t) == gr.end()) {
                gr[t] = {};
                reachable[t] = false;
            }
            gr[f].push_back({t, i + 1});
        } else {
            unsuccess.push_back({f, i + 1});
        }
    }
    //PROVERKA NA PUT'
    int check = 0;
    for (auto i:gr) {
        for (auto u: i.second) {
            deg[u.first]++;
        }
    }
    int tmp1 = 0;
    for (auto i: deg) {
        if (i.second != gr[i.first].size()) {
            check++;
            if (abs(i.second - static_cast<int>(gr[i.first].size())) != 1) {
                cout << "No";
                return 0;
            } else {
                tmp1 += i.second - static_cast<int>(gr[i.first].size());
            }
        }
    }
    if ((check != 0 && check != 2) || tmp1 != 0) {
        cout << "No";
        return 0;
    }
    //KONEC PROVERKI

    findEuler(start);
    reverse(path.begin(), path.end());
    for (auto i: reachable) {
        if (!i.second) {
            cout << "No";
            return 0;
        }
    }
    vector<int> ans;

    int vstav_size = unsuccess.size();
    for (int i = 0; i < unsuccess.size(); i++) {
        if (unsuccess[i].first != start) {
            ans.push_back(unsuccess[i].second);
            vstav_size--;
        }
    }
    bool inserted = false;
    for (int i = 0; i < path.size(); i++) {
        if (all[path[i] - 1].first != start && !inserted && vstav_size > 0) {
            inserted = true;
            for (int j = 0; j < unsuccess.size(); j++) {
                if (unsuccess[j].first == start) {
                    ans.push_back(unsuccess[j].second);
                }
            }
        }
        ans.push_back(path[i]);
    }
    if (path.size() > 0 && all[path[path.size() - 1] - 1].second != start && !inserted && vstav_size > 0) {
        inserted = true;
        for (int j = 0; j < unsuccess.size(); j++) {
            if (unsuccess[j].first == start) {
                ans.push_back(unsuccess[j].second);
            }
        }
    }

    if (ans.size() != n) {
        for(auto i: path)cout<<i<<" ";
        cout << "No";
        return 0;
    }
    if (!inserted && vstav_size > 0) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
    return 0;
}