#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <map>
#include<unordered_map>
#include<cmath>
#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#include <cassert>
#include <cstdio>
#include <algorithm>
#define FAST_ALLOCATOR_MEMORY 1e8
/* Fast allocation */

#ifdef FAST_ALLOCATOR_MEMORY
int allocator_pos = 0;
  char allocator_memory[(int)FAST_ALLOCATOR_MEMORY];
  inline void * operator new ( size_t n ) {
    char *res = allocator_memory + allocator_pos;
    allocator_pos += n;
    assert(allocator_pos <= (int)FAST_ALLOCATOR_MEMORY);
    return (void *)res;
  }
  inline void operator delete ( void * ) noexcept { }
  inline void * operator new [] ( size_t ) { assert(0); }
  inline void operator delete [] ( void * ) { assert(0); }
#endif

/* Fast input-output */

template <class T = int> inline T readInt();
inline double readDouble();
inline int readUInt();
inline int readChar(); // first non-blank character
inline void readWord( char *s );
inline bool readLine( char *s ); // do not save '\n'
inline bool isEof();
inline int getChar();
inline int peekChar();
inline bool seekEof();
inline void skipBlanks();

template <class T> inline void writeInt( T x, char end = 0, int len = -1 );
inline void writeChar( int x );
inline void writeWord( const char *s );
inline void writeDouble( double x, int len = 0 ); // works correct only for |x| < 2^{63}
inline void flush();

static struct buffer_flusher_t {
    ~buffer_flusher_t() {
        flush();
    }
} buffer_flusher;

/* Read */

static const int buf_size = 4096;

static unsigned char buf[buf_size];
static int buf_len = 0, buf_pos = 0;

inline bool isEof() {
    if (buf_pos == buf_len) {
        buf_pos = 0, buf_len = fread(buf, 1, buf_size, stdin);
        if (buf_pos == buf_len)
            return 1;
    }
    return 0;
}

inline int getChar() {
    return isEof() ? -1 : buf[buf_pos++];
}

inline int peekChar() {
    return isEof() ? -1 : buf[buf_pos];
}

inline bool seekEof() {
    int c;
    while ((c = peekChar()) != -1 && c <= 32)
        buf_pos++;
    return c == -1;
}

inline void skipBlanks() {
    while (!isEof() && buf[buf_pos] <= 32U)
        buf_pos++;
}

inline int readChar() {
    int c = getChar();
    while (c != -1 && c <= 32)
        c = getChar();
    return c;
}

inline int readUInt() {
    int c = readChar(), x = 0;
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    return x;
}

template <class T>
inline T readInt() {
    int s = 1, c = readChar();
    T x = 0;
    if (c == '-')
        s = -1, c = getChar();
    else if (c == '+')
        c = getChar();
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    return s == 1 ? x : -x;
}

inline double readDouble() {
    int s = 1, c = readChar();
    double x = 0;
    if (c == '-')
        s = -1, c = getChar();
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    if (c == '.') {
        c = getChar();
        double coef = 1;
        while ('0' <= c && c <= '9')
            x += (c - '0') * (coef *= 1e-1), c = getChar();
    }
    return s == 1 ? x : -x;
}

inline void readWord( char *s ) {
    int c = readChar();
    while (c > 32)
        *s++ = c, c = getChar();
    *s = 0;
}

inline bool readLine( char *s ) {
    int c = getChar();
    while (c != '\n' && c != -1)
        *s++ = c, c = getChar();
    *s = 0;
    return c != -1;
}

/* Write */

static int write_buf_pos = 0;
static char write_buf[buf_size];

inline void writeChar( int x ) {
    if (write_buf_pos == buf_size)
        fwrite(write_buf, 1, buf_size, stdout), write_buf_pos = 0;
    write_buf[write_buf_pos++] = x;
}

inline void flush() {
    if (write_buf_pos) {
        fwrite(write_buf, 1, write_buf_pos, stdout), write_buf_pos = 0;
        fflush(stdout);
    }
}

template <class T>
inline void writeInt( T x, char end, int output_len ) {
    if (x < 0)
        writeChar('-'), x = -x;

    char s[24];
    int n = 0;
    while (x || !n)
        s[n++] = '0' + x % 10, x /= 10;
    while (n < output_len)
        s[n++] = '0';
    while (n--)
        writeChar(s[n]);
    if (end)
        writeChar(end);
}

inline void writeWord( const char *s ) {
    while (*s)
        writeChar(*s++);
}
using namespace std;
unordered_map<int, vector<pair<int, int>>> gr(2*1e5);//graph
vector<pair<int, int>> unsuccess;//bad edges
vector<pair<int, int>> all;//all adges(out)
vector<int> path;//Euler path
bool used[2*(int)1e5];
unordered_map<int, int> deg(2*1e5);// indeg for every vertex

inline void findEuler(int v) {
    if (gr.find(v) == gr.end()) {
        return;
    }
    for (auto e: gr[v]) {
        if (!used[e.second - 1]) {
            used[e.second - 1] = true;
            findEuler(e.first);
            path.push_back(e.second);
        }
    }
}

int main() {
    int n=readUInt(), start=readUInt();
    for (int i = 0; i < n; i++) {
        int f, t, w;
        f=readUInt();
        t=readUInt();
        w=readUInt();
        all.emplace_back(f, t);
        if (w == 1) {
            if (gr.find(f) == gr.end()) {
                gr[f] = {};

                deg[f] = 0;

            }
            if (gr.find(t) == gr.end()) {
                gr[t] = {};

                deg[t] = 0;
            }
            deg[t]++;
            gr[f].push_back({t, i + 1});
        } else {
            unsuccess.emplace_back(f, i + 1);
        }
    }
    //PROVERKA NA PUT'
    int check = 0;

    int tmp1 = 0;
    for (auto i: deg) {
        int szz = gr[i.first].size();
        if (i.second != szz) {
            check++;
            if (abs(i.second - szz) != 1) {
                writeWord("No");
                return 0;
            } else {
                tmp1 += i.second - static_cast<int>(szz);
            }
        }
    }
    if ((check != 0 && check != 2) || tmp1 != 0) {
        writeWord("No");
        return 0;
    }

    //KONEC PROVERKI


    findEuler(start);
    reverse(path.begin(), path.end());
    if (path.size() != all.size()- unsuccess.size()) {
            writeWord("No");
            return 0;
        }

    vector<int> ans;

    int vstav_size = unsuccess.size();
    for (int i = 0; i < unsuccess.size(); i++) {
        if (unsuccess[i].first != start) {
            ans.push_back(unsuccess[i].second);
            vstav_size--;
        }
    }
    bool inserted = false;
    for (int i = 0; i < path.size(); i++) {
        if (!inserted && all[path[i] - 1].first != start && vstav_size > 0) {
            inserted = true;
            for (int j = 0; j < unsuccess.size(); j++) {
                if (unsuccess[j].first == start) {
                    ans.push_back(unsuccess[j].second);
                }
            }
        }
        ans.push_back(path[i]);
    }
    if (!path.empty() && !inserted && all[path.back() - 1].second != start  && vstav_size > 0) {
        inserted = true;
        for (int j = 0; j < unsuccess.size(); j++) {
            if (unsuccess[j].first == start) {
                ans.push_back(unsuccess[j].second);
            }
        }
    }

    if (ans.size() != n) {
        writeWord("No");
        return 0;
    }
    if (!inserted && vstav_size > 0) {
        writeWord("No");
        return 0;
    }
    writeWord("Yes\n");
    for (int i = 0; i < n; i++) {
        writeInt(ans[i], ' ');
    }
    return 0;
}