#include <cstdio>
#include <cassert>
#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <cmath>

#define all(a) a.begin(), a.end()
#define beg() begin()
#define srt(a) sort(all(a))
#define ll long long
#define ld double
#define f first
#define s second
#define io cin.sync_with_stdio(false);cout.sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define EPS 1e-9
#define point pair<ll, ll>

using namespace std;

struct edge {
    int fr, to, i;
};

vector<vector<int>> op(2);
vector<edge> ee;
vector<vector<edge>> g, ag;
vector<int> ans;
vector<bool> used;

void dfs(int v) {
    while(!g[v].empty()) {
        int to = g[v].back().to, ind = g[v].back().i;
        g[v].pop_back();
        dfs(to);
        ans.push_back(ind);
    }
    if(v == 0 || v == 1) {
        for(auto cc: op[v])
            ans.push_back(cc);
        op[v].clear();
    }
}

int main() {
    io;
    int n, c;
    cin >> n >> c;
    if(n > 4) {
        cout << "No";
        return 10;
    }
    map<int, int> num;
    vector<int> val = {c};
    num[c] = 1;
    for(int i = 0; i < n; i++) {
        int a, b, x;
        cin >> a >> b >> x;
        if(num[a] == 0) {
            val.push_back(a);
            num[a] = val.size();
        }
        if(num[b] == 0) {
            val.push_back(b);
            num[b] = val.size();
        }
        if(x == 1) {
            ee.push_back({num[a] - 1, num[b] - 1, i + 1});
        } else {
            if(num[a] != 1) {
                op[0].push_back(i + 1);
            } else {
                op[1].push_back(i + 1);
            }
        }
    }
    used.resize(n + 1);
    g.resize(n + 1);
    ag.resize(n + 1);
    for(auto cu: ee) {
        g[cu.fr].push_back(cu);
        ag[cu.to].push_back(cu);
    }
    int cnt = 0;
    for(int i = 0; i < n; i++) {
        if(g[i].size() != ag[i].size())
            cnt++;
        if(abs((int)g[i].size() - (int)ag[i].size()) > 1) {
            cout << "No";
            return 0;
        }
    }
    if(cnt > 2) {
        cout << "No";
        return 0;
    }
    dfs(num[c] - 1);
    reverse(all(ans));
    for(int i = 0; i < g.size(); i++) {
        if(!g[i].empty()) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    if(!op[0].empty() || !op[1].empty()) {
        cout << "No";
        return 0;
    }
    for(auto i: ans)
        cout << i << " ";
}