#include <iostream>
#include <vector>
#include <utility>
#include <cmath>

int d;
double p;
std::vector<int> c;

double calculateA(int first, int last)
{
	int n = last - first;
	int sumOfCostChanges = 0;
	for (int i = first + 1; i <= last; i++) {
		sumOfCostChanges += c[i] - c[i-1];
	}
	return (double)sumOfCostChanges / n;
}

double calculateD(int first, int last, double a)
{
	int n = last - first;
	double sum = 0.0;
	for (int i = first + 1; i <= last; i++) {
		sum += std::pow(c[i] - c[i-1] - a,   2);
	}
	return std::sqrt(sum / n);
}

// returns  1 if positive,  -1 if negative,  or 0 if none.
int calculateTrendForSegment(int first, int last)
{
	double a = calculateA(first, last);
	double d = calculateD(first, last, a);
	
	if ((d == 0 && a > 0) || (a/d >= p)) {
		return 1;
	}
	else if ((d == 0 && a < 0) || (a/d <= -p)) {
		return -1;
	}
	else {
		return 0;
	}
}

// Need to return 2 values, so it's done via parameters
void count(int& nPositiveSegments, int& nNegativeSegments)
{
	nPositiveSegments = nNegativeSegments = 0;
	
	// Go through all possible segments and count the trends
	for (int i = 0; i < d - 2; i++) {
		for (int j = i + 2; j < d; j++) {
			int trend = calculateTrendForSegment(i, j);
			if (trend > 0) {
				nPositiveSegments++;
			}
			else if (trend < 0) {
				nNegativeSegments++;
			}
		}
	}
}

int main()
{
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> d >> p;
	c = std::move(std::vector<int>(d, 0));
	for (int i = 0; i < d; i++) {
		std::cin >> c[i];
	}
	
	int nPositiveSegments, nNegativeSegments;
	count(nPositiveSegments, nNegativeSegments);
	
	std::cout << nPositiveSegments << ' ' << nNegativeSegments;
	return 0;
}
