#include <iostream>
#include <cmath>

struct XYpair
{
	int x;
	int y;
};

int pythagorianArea(int leg1, int leg2)
{
	return leg1 * leg1 + leg2 * leg2;
}

// Returns coordinates of the right point relative to the bottom point,
// or 0;0 of impossible
XYpair findXY(int s)
{
	int y = 0;
	for (int x = sqrt(s) + 0.00001; x >= 0; x--) {
		while (pythagorianArea(x, y) < s) {
			y++;
		}
		// std::cout << x << ' ' << y << '\n'; // used for debugging
		if (pythagorianArea(x, y) == s) {
			return {x, y};
		}
	}
	return {0, 0};
}

int main()
{
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	
	int s;
	std::cin >> s;
	
	auto coords = findXY(s);
	// std::cout << '\n'; // used for debugging
	
	if (coords.x == 0 && coords.y == 0) {
		std::cout << "Impossible";
	}
	else {
		// Start with 0;0 as a bottom point and go counter-clockwize
		std::cout << "0 0\n"
					<< coords.x << ' ' << coords.y << '\n'
					<< coords.x - coords.y << ' ' << coords.y + coords.x << '\n'
					<< -coords.y << ' ' << coords.x;
	}
	
	return 0;
}
