//  Copyright 2020 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i64 = int64_t;
using ui64 = uint64_t;

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

#ifdef GOLIKOV
mt19937_64 rng(566);
#else
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
#endif

template <typename T>
T rnd_helper(T from, T to, true_type) {
  return uniform_int_distribution<T>(from, to)(rng);
}

template <typename T>
T rnd_helper(T from, T to, false_type) {
  return uniform_real_distribution<T>(from, to)(rng);
}

template <typename T>
T rnd(T from, T to) {
  return rnd_helper(from, to, is_integral<T>{});
}

int main() {
#ifdef GOLIKOV
//  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif

  auto query = [](int i, int j) {
    cout << i + 1 << ' ' << j + 1 << endl;
    string s;
    cin >> s;
    if (s == "WIN") {
      exit(0);
    }
  };

  int n;
  cin >> n;
  while (true) {
    for (int i = 0; i + 1 < n; ++i) {
      query(i, i + 1);
    }
    for (int i = n - 1; i > 0; --i) {
      query(i - 1, i);
    }
    for (int it = 0; it < 2; ++it) {
      int i = rnd(0, n - 1);
      int j;
      do {
        j = rnd(0, n - 1);
      } while (j == i);
      query(i, j);
    }
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
