// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 100;

char symbols[N];
char a[N][N][N];
char grid[N][N];

int first[N][N];
int clear[N][N];

int w, h;

void getFirst(int id) {
	for (int i = 0; i < w; ++i) {
		for (int j = 1; j < w; ++j) {
			for (int k = 0; k < h; ++k) {
				if (grid[k][j - 1] != grid[k][j]) {
					grid[k][j - 1] = grid[k][j];
					++first[k][j - 1];
				}
			}
		}

		for (int k = 0; k < h; ++k) {
			if (grid[k][w - 1] != a[id][k][i]) {
				grid[k][w - 1] = a[id][k][i];
				++first[k][w - 1];
			}
		}
	}

	for (int i = 0; i < w - 1; ++i) {
		for (int j = 1; j < w - i; ++j) {
			for (int k = 0; k < h; ++k) {
				if (grid[k][j - 1] != grid[k][j]) {
					grid[k][j - 1] = grid[k][j];
					++first[k][j - 1];
				}
			}
		}
	}
}

void getClear() {
	for (int i = 0; i < w; ++i) {
		for (int j = 0; j < h; ++j) {
			if (grid[j][i] != '.') {
				++clear[j][i];
				grid[j][i] = '.';
			}
		}
	}
}

void run() {
	int n, s;
	scanf("%d%d%d%d", &n, &w, &h, &s);

	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			grid[i][j] = '.';
		}
	}

	for (int i = 0; i < n; ++i) {
		char cur;
		scanf("\n%c", &cur);

		symbols[i] = cur;

		for (int j = 0; j < h; ++j) {
			scanf("\n%s", a[i][j]);
		}
	}

	int bestId = -1;
	int bestLen = INF;
	for (int id = 0; id < n; ++id) {
		memset(first, 0, sizeof(first));
		memset(clear, 0, sizeof(clear));

		getFirst(id);
		getClear();

		for (int i = 0; i < h; ++i) {
			for (int j = 0; j < w; ++j) {
				if (first[i][j] + clear[i][j] == 0) {
					continue;
				}

				int len = ((s + clear[i][j]) + (first[i][j] + clear[i][j] - 1)) / (first[i][j] + clear[i][j]);
				if (len < bestLen) {
					bestLen = len;
					bestId = id;
				}
			}
		}
	}

	while (bestLen--) {
		printf("%c", symbols[bestId]);
	}
	printf("\n");
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
