//  Copyright 2020 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i64 = int64_t;
using ui64 = uint64_t;

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, c;
  cin >> n >> c;
  vector<int> all;
  struct item {
    int from;
    int to;
    bool need;
    int id;
  };
  vector<item> guys(n);
  all.push_back(c);
  for (int i = 0; i < n; ++i) {
    int x, y, t;
    cin >> x >> y >> t;
    all.push_back(x);
    all.push_back(y);
    guys[i] = {x, y, (t == 1), i};
  }
  sort(all.begin(), all.end());
  all.erase(unique(all.begin(), all.end()), all.end());
  int nvs = (int) all.size();
  vector<vector<pair<int, int>>> need(nvs);
  vector<item> to_skip;
  int nneed = 0;
  for (auto& [from, to, b, id] : guys) {
    from = (int) (lower_bound(all.begin(), all.end(), from) - all.begin());
    to = (int) (lower_bound(all.begin(), all.end(), to) - all.begin());
    if (b) {
      need[from].emplace_back(to, id);
      nneed++;
    } else {
      to_skip.push_back({from, to, b, id});
    }
  }
  c = (int) (lower_bound(all.begin(), all.end(), c) - all.begin());
  sort(to_skip.begin(), to_skip.end(), [](auto& x, auto& y) {
    return x.from < y.from;
  });
  vector<bool> dead(n);
  vector<int> ptr(nvs);
  vector<int> ids;
  auto euler = [&](auto&& euler, int v) -> void {
    for (; ptr[v] != (int) need[v].size(); ) {
      auto[u, id] = need[v][ptr[v]++];
      if (dead[id]) {
        continue;
      }
      dead[id] = true;
      euler(euler, u);
      ids.push_back(id);
      //  add edge v -> u, id to back of the path
    }
  };
  euler(euler, c);
  reverse(ids.begin(), ids.end());
  if ((int) ids.size() != nneed) {
    cout << "No\n";
    return 0;
  }
  if (!ids.empty()) {
    if (guys[ids[0]].from != c) {
      cout << "No\n";
      return 0;
    }
    for (int i = 1; i < (int) ids.size(); ++i) {
      if (guys[ids[i]].from != guys[ids[i - 1]].to) {
        cout << "No\n";
        return 0;
      }
    }
  }
  vector<int> ans;
  int cur_v = c;
  int ptrL = 0;
  int ptrR = (int) to_skip.size() - 1;
  for (int x : ids) {
    while (ptrL <= ptrR && to_skip[ptrL].from != cur_v) {
      ans.push_back(to_skip[ptrL++].id);
    }
    while (ptrL <= ptrR && to_skip[ptrR].from != cur_v) {
      ans.push_back(to_skip[ptrR--].id);
    }
    ans.push_back(x);
    assert(cur_v == guys[x].from);
    cur_v = guys[x].to;
  }
  if (ptrL <= ptrR) {
    cout << "No\n";
  } else {
    cout << "Yes\n";
    for (auto x : ans) {
      cout << x + 1 << ' ';
    }
    cout << '\n';
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
