//  Copyright 2020 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i64 = int64_t;
using ui64 = uint64_t;

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
// #ifdef GOLIKOV
  // assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
// #endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int p;
  cin >> p;
  int const alpha = 26;
  vector<vector<bool>> single(alpha, vector<bool>(alpha));
  vector<vector<vector<bool>>> concat(alpha, vector<vector<bool>>(alpha,
      vector<bool>(alpha)));
  vector<tuple<int, int, int>> grammar;
  for (int i = 0; i < p; ++i) {
    string s;
    cin >> s;
    auto start = s[0] - 'A';
    string end;
    cin >> end >> end;
    if (end.size() == 1) {
      single[start][end[0] - 'a'] = true;
    } else {
      auto x = end[0] - 'A';
      auto y = end[1] - 'A';
      concat[start][x][y] = true;
      grammar.emplace_back(start, x, y);
    }
  }
  int n, m, s, t;
  cin >> n >> m >> s >> t;
  --s, --t;
  struct edge {
    int from;
    int to;
    int let;
  };
  vector<edge> edges(m);
  for (auto& [from, to, let] : edges) {
    cin >> from >> to;
    char ch;
    cin >> ch;
    let = (ch - 'a');
    --from, --to;
  }
  int const INF = (int) 1e7;
  vector can(n, vector(n, vector(alpha, INF)));
  for (auto[from, to, let] : edges) {
    for (int i = 0; i < alpha; ++i) {
      if (single[i][let]) {
        can[from][to][i] = 1;
      }
    }
  }
  for (int k = 0; k < n; ++k) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
        for (auto[start, x, y] : grammar) {
          auto d1 = can[i][k][x];
          auto d2 = can[k][j][y];
          smin(can[i][j][start], d1 + d2);
        }
      }
    }
  }
  while (true) {
  	if (chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() >= 1900) {
  		break;
  	}
    for (int k = 0; k < n; ++k) {
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
          for (auto[start, x, y] : grammar) {
            auto d1 = can[i][k][x];
            auto d2 = can[k][j][y];
            smin(can[i][j][start], d1 + d2);
          }
        }
      }
    }
  }
  int s_i = 'S' - 'A';
  auto d = can[s][t][s_i];
  if (d == INF) {
    cout << "NO\n";
  } else {
    cout << d << '\n';
  }

// #ifdef GOLIKOV
  // cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
  //     chrono::high_resolution_clock::now()
  //         - _clock_start).count() << "ms." << endl;
// #endif
  return 0;
}
