#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

vector<int> a;
vector<int> b;
vector<pii> asks;
int n;
int qrsCounter;
mt19937 gen(8736452);

void init() {
  qrsCounter = 0;
  n = 50;
  a = vector<int>(n);
  iota(a.begin(), a.end(), 1);
  while (true) {
    shuffle(a.begin(), a.end(), gen);
    bool ok = true;
    for (int i = 1; i < n; i++) {
      ok &= a[i - 1] < a[i];
    }
    if (!ok) {
      break;
    }
  }
  b = a;
  asks.clear();
}

string ask(int i, int j) {
#ifdef LOCAL
  string res;
  qrsCounter++;
  if (qrsCounter == 10000) {
    cerr << "To many qrs\n";
    cerr << n << endl;
    for (int x : b) {
      cerr << x << " ";
    }
    cerr << endl;
//    for (auto[qi, qj] : asks) {
//      cerr << qi << " " << qj << endl;
//    }
    exit(0);
  }
  --i;
  --j;
  asks.emplace_back(i + 1, j + 1);
  if (qrsCounter % (2 * n) == 0) {
    int ti = gen() % n;
    int tj = gen() % n;
    swap(a[ti], a[tj]);
    cerr << "RANDOM: " << a[ti] << " " << a[tj] << endl;
  }
  if (0 && qrsCounter > (n * (n - 1) / 2)) {
    for (int x : a) {
      cerr << x << " ";
    }
    cerr << endl;
  }
  if (a[i] > a[j]) {
    swap(a[i], a[j]);
    for (int ti = 1; ti < n; ti++) {
      if (a[ti - 1] > a[ti]) {
        return "SWAPPED";
      }
    }
    return "WIN";
  } else {
    return "STAYED";
  }
#else
  cout << i << " " << j << endl;
  string s;
  cin >> s;
  if (s == "WIN") {
    exit(0);
  }
  return s;
#endif
}

void solve() {
#ifndef LOCAL
  cin >> n;
#endif
  while (true) {
    for (int i = 1; i < n; i++) {
      string ans = ask(i, i + 1);
      if (ans == "WIN") {
        return;
      }
    }
    for (int i = n - 1; i >= 1; i--) {
      string ans = ask(i, i + 1);
      if (ans == "WIN") {
        return;
      }
    }
    continue;

    for (int i = 1; i < n; i++) {
      string ans = ask(i, i + 1);
      if (ans == "WIN") {
        return;
      }
      if (ans == "SWAPPED") {
        for (int j = i + 2; j < n; j++) {
          ans = ask(j, j + 1);
          if (ans == "WIN") {
            return;
          }
          if (ans == "SWAPPED") {
            if (ask(i + 1, j) == "WIN") {
              return;
            }
            if (ask(i, i + 1) == "WIN") {
              return;
            }
            if (ask(j, j + 1) == "WIN") {
              return;
            }
            break;
          }
        }
        break;
      }
    }
  }
}

void stress() {
  while (true) {
    init();
    solve();
    cout << "Passed" << endl;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

//  stress();
  solve();

  return 0;
}
