#define testing
#include <bits/stdc++.h>
using namespace std;

#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////

int m, start;
struct Edge {
    int u, v, id, w;
    Edge() {}
    Edge(int u_, int v_, int i): u(u_), v(v_), id(i) {}
    friend ostream& operator<<(ostream& out, const Edge& u) {
        return out << "(" << u.u << ", " << u.v << ", " << u.id << ")";
    }
};

vector<Edge> all_edges;

void read() {
    cin >> m >> start;
    all_edges.resize(m);
    rep(i, m) {
        cin >> all_edges[i].u >> all_edges[i].v >>all_edges[i].w;
        all_edges[i].id = i;
    }
}

vector<vector<Edge>> gr;
vector<list<Edge>> rest;

list<Edge> euler_tour(int u) {
    list<Edge> ans;
    while (len(gr[u])) {
        auto e = gr[u].back();
        gr[u].pop_back();
        ans.push_back(e);
        u = e.v;
    }
    
    for (auto it = ans.begin(); it != ans.end(); ++it) {
        ans.splice(it, euler_tour(it->u));
    }
    if (ans.size()) ans.splice(ans.end(), euler_tour(ans.back().v));
    return ans;
}

vector<int> solve() {
    vector<int> vals;
    vals.push_back(start);
    rep(i, m) {
        vals.push_back(all_edges[i].u);
        vals.push_back(all_edges[i].v);
    }
    sort(vals.begin(), vals.end());
    int n = (int)(unique(vals.begin(), vals.end()) - vals.begin());
    vals.resize(n);
    gr.assign(n, vector<Edge>());
    rest.assign(n, list<Edge>());
    auto index = [&](int& u) {
        u = (int)(lower_bound(vals.begin(), vals.end(), u) - vals.begin());
    };
    
    vector<int> in_deg(n), out_deg(n);
    int new_start = start;
    index(new_start);
    int needed_edge = 0;
    rep(i, m) {
        auto cur_edge = all_edges[i];
        index(cur_edge.u);
        index(cur_edge.v);
        if (cur_edge.w) {
            gr[cur_edge.u].push_back(cur_edge);
            in_deg[cur_edge.v] ++;
            out_deg[cur_edge.u] ++;
            ++needed_edge;
        } else {
            rest[cur_edge.u].push_back(cur_edge);
        }
    }
    clog << db(in_deg) << endl;
    clog << db(out_deg) << endl;
    
    int has_out = -1, has_in = -1;
    for (int i = 0; i < n; ++i) {
        int diff = in_deg[i] - out_deg[i];
        if (diff == 0) continue;
        else if (diff == 1) {
            if (has_in != -1) return {};
            has_in = i;
        }else  if (diff == -1) {
            if (has_out != -1) return {};
            has_out = i;
        } else return {};
    }
    clog << db(has_out) << db(has_in) << endl;
    if ((has_out == -1) != (has_in == -1)) {
        return {};
    }
    if (has_out != -1 and has_out != new_start) {
        return {};
    }
    clog << db(new_start) << endl;
    auto ans = euler_tour(new_start);
    int euler_tour_size = len(ans);
    if (euler_tour_size != needed_edge) return {};
    clog << db(ans) << endl;
    auto start_euler_tour= ans.begin();
    rep(i, n) {
        if (rest[i].size() and i != new_start)
            ans.splice(ans.begin(), rest[i]);
    }
    for (auto it = start_euler_tour; it != ans.end(); ++it) {
        if (it->u != new_start)
            ans.splice(it, rest[new_start]);
    }
    if (euler_tour_size) {
        if (ans.back().v != new_start)
            ans.splice(ans.end(), rest[new_start]);
    }
    if (len(rest[new_start])) return {};
    
    assert(len(ans) == m);
    vector<int> true_ans;
    for (auto& it: ans) true_ans.push_back(it.id);
    return true_ans;
}

void gen() {
    ofstream inp("main.inp");
    m = rand() % 10 + 1;
    start = rand() % 10 + 1;
    
    all_edges.resize(m);
    for (int i = 0; i < m; ++i) {
        all_edges[i] = Edge(
                rand() % 10 + 1,
                rand() % 10 + 1,
                i);
        all_edges[i].w = rand() % 2;
    }
    
    inp << m << ' ' << start << '\n';
    rep(i, m) {
        inp << all_edges[i].u << ' ' << all_edges[i].v << ' ' << all_edges[i].w << '\n';
    }
}

bool check_perm(const vector<int>& pos) {
    int u = start;
    for (auto i: pos) { 
        if (all_edges[i].w) {
            if (all_edges[i].u != u) {
                return false;
            }
            u = all_edges[i].v;
        } else {
            if (all_edges[i].u == u) {
                return false;
            }
        }
    }
    return true;
}

vector<int> brute() {
    vector<int> pos(m);
    rep(i, m) pos[i] = i;
    do {
        if (check_perm(pos)) return pos;
    } while (next_permutation(pos.begin(), pos.end()));
    return {};
}

void stress() {
    while (true) {
        gen();
        auto exp = brute();
        auto ans = solve();
        if (!len(exp) and !len(ans)) {
            cout << "OK" << endl;
            continue;
        }
        if (!check_perm(ans)) {
            cout << "FAILED" << endl;
            cout << exp << endl;
            cout << ans << endl;
            exit(0);
        }
    }
    exit(0);
}

int main(void) {
    // stress();     
#ifdef LOCAL
    freopen("main.inp", "r", stdin);
    freopen("main.out", "w", stdout);
    freopen(".log", "w", stderr);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    read();
    auto ans = solve(); 
    // auto ans = brute(); 
    if (len(ans) != m) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (auto i: ans) cout << i + 1 << ' ';
    }
    
    return 0;
}

// vim: foldmethod=marker

