import java.io.*
import java.util.*
import java.math.BigInteger

private const val localFileName = "test"
private lateinit var out: PrintWriter
private lateinit var bf: BufferedReader
private var stok = StringTokenizer("")
private inline fun read(): String {
    while (!stok.hasMoreTokens()) stok = StringTokenizer(bf.readLine())
    return stok.nextToken()
}

private fun solve() {
    val maxn = 26
    val cnt_rules = read().toInt()
    val rules = Array(maxn) { Array(maxn) { ArrayList<Int>()} }
    val terminal_rules = Array(maxn) { ArrayList<Int>() }
    val ordA = 'A'.toInt()
    val orda = 'a'.toInt()
    for (i in 1 .. cnt_rules) {
        val dest = read()
        read()
        val ab = read()
        if (ab.length == 1) {
            terminal_rules[ab[0].toInt() - orda].add(dest[0].toInt() - ordA)
        } else {
            rules[ab[0].toInt() - ordA][ab[1].toInt() - ordA].add(dest[0].toInt() - ordA)
        }
    }

    data class Edge (val to: Int, val ch: Int)
    val n = read().toInt()
    val m = read().toInt()
    val s = read().toInt()
    val t = read().toInt()
    val gr = Array(n + 1) { ArrayList<Edge>() }
    for (i in 1..m) {
        val u = read().toInt()
        val v = read().toInt()
        val ch = read()[0].toInt() - orda
        gr[u].add(Edge(v, ch))
    }

    val inf = (-1).toBigInteger()
    val dist = Array(n + 1) { Array(maxn) { Array(n + 1) { inf } } }

    data class Goal (val from: Int, val rule: Int, val to: Int, val cost: BigInteger) : Comparable<Goal> {
        fun isInf(): Boolean {
            return cost == inf
        }
        override fun compareTo(other: Goal): Int {
            if (isInf() == other.isInf()) {
                return -cost.compareTo(other.cost)
            }
            return if (isInf()) 1 else -1
        }
    }

    val prio = PriorityQueue<Goal>()
    for (u in 1..n) {
        for ((v, ch) in gr[u]) {
            for (mid in terminal_rules[ch]) {
                dist[u][mid][v] = 1.toBigInteger()
                prio.add(Goal(u, mid, v, 1.toBigInteger()))
            }
        }
    }

    while (prio.size  > 0) {
        val (u_from, mid, u_to, cur_dist) = prio.poll()!!
        if (u_from == s && mid == 'S'.toInt() - ordA && u_to == t) break
        if (dist[u_from][mid][u_to] < cur_dist) continue
        for (v in 1..n) {
            for (new_mid in 0 until maxn) {
                if (dist[u_to][new_mid][v] == inf) continue
                val new_dist = cur_dist + dist[u_to][new_mid][v]
                for (new_rule in rules[mid][new_mid]) {
                    if (dist[u_from][new_rule][v] != inf && new_dist >= dist[u_from][new_rule][v]) {
                        continue
                    }
                    dist[u_from][new_rule][v] = new_dist
                    prio.add(Goal(u_from, new_rule, v, dist[u_from][new_rule][v]))
                }
            }
            for (new_mid in 0 until maxn) {
                if (dist[v][new_mid][u_from] == inf) continue
                val new_dist = dist[v][new_mid][u_from] + cur_dist
                for (new_rule in rules[new_mid][mid]) {
                    if (dist[v][new_rule][u_to] != inf && new_dist >= dist[v][new_rule][u_to]) {
                        continue
                    }
                    dist[v][new_rule][u_to] = new_dist
                    prio.add(Goal(v, new_rule, u_to, dist[v][new_rule][u_to]))
                }
            }
        }
    }

    val ans = dist[s]['S'.toInt() - ordA][t]

    if (ans == inf) out.println("NO")
    else out.println(ans)
}

fun main() {

    out = PrintWriter(System.out!!, false)
    bf = BufferedReader(InputStreamReader(System.`in`))

    solve()
    out.flush()
}
