#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

const int N = 8;
vector<int> res(1 << N);

struct Node {
  int type;
  Node *l, *r;
};

// 0+ - var
// 10 - or
// 11 - and
// 12 - not

void skip(string const &s, int &l) {
  while (s[l] == ' ') {
    l++;
  }
}

string getToken(string const &s, int l) {
  skip(s, l);
  string t;
  while (l < s.size() && s[l] != ' ') {
    t += s[l];
    l++;
  }
  return t;
}

const int START_PARSE = 10;
const int END_PARSE = 13;
const int OR = 11;
const int AND = 10;
const int NOT = 12;


map<int, string> getByPriority = {{OR,  "and"},
                                  {AND, "or"},
                                  {NOT, "not"}};

Node *parse(string const &s, int &cursor, int priority) {
  skip(s, cursor);
  if (priority == END_PARSE) {
    if (s[cursor] == '(') {
      cursor++;
      Node* expr = parse(s, cursor, START_PARSE);
      cursor++;
      return expr;
    }
    cursor++;
    return new Node{s[cursor - 1] - 'a', nullptr, nullptr};
  }
  if (priority == NOT) {
    skip(s, cursor);
    if (getToken(s, cursor) == getByPriority[priority]) {
      cursor += getByPriority[priority].size();
      return new Node{priority, parse(s, cursor, priority + 1), nullptr};
    } else {
      return parse(s, cursor, priority + 1);
    }
  }
  skip(s, cursor);
  Node *expr = parse(s, cursor, priority + 1);
  while (cursor < (int) s.size()) {
    skip(s, cursor);
    if (getToken(s, cursor) == getByPriority[priority]) {
      cursor += getByPriority[priority].size();
      expr = new Node{priority, expr, parse(s, cursor, priority)};
    } else {
      return expr;
    }
  }
  return expr;
}

bool calc(Node *t, int mask) {
  if (t->type == NOT) {
    return !calc(t->l, mask);
  } else if (t->type == AND) {
    return calc(t->l, mask) & calc(t->r, mask);
  } else if (t->type == OR) {
    return calc(t->l, mask) | calc(t->r, mask);
  } else {
    return (mask >> (t->type)) & 1;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string fun;
  getline(cin, fun);
  int cursor = 0;
  Node *f = parse(fun, cursor, START_PARSE);
  vector<int> F;
  vector<int> res;
  for (int mask = 0; mask < (1 << N); mask++) {
    if (calc(f, mask)) {
      res.push_back(mask);
      F.push_back(1);
    } else {
      F.push_back(0);
    }
  }
  for (int mask1 = 0; mask1 < (1 << N); mask1++) {
    for (int mask2 = 0; mask2 < (1 << N); mask2++) {
      if ((mask1 & mask2) == mask2 && F[mask1] < F[mask2]) {
        cout << "IMPOSSIBLE";
        return 0;
      }
    }
  }
  vector<int> nRes;
  for (int mask : res) {
    bool glob = true;
    for (int other : res) {
      if (mask != other) {
        if ((mask & other) == other) {
          glob = false;
        }
      }
    }
    if (glob) {
      nRes.push_back(mask);
    }
  }
  if (nRes.empty()) {
    cout << "++\n++";
    return 0;
  }
  res = nRes;
  sort(res.begin(), res.end(), [](int a, int b) {
    return __builtin_popcount(a) > __builtin_popcount(b);
  });
  int indMask = 0;
  int x = 1, y = 2;
  int mxMask = 0;
  int M = 10;
  vector<string> v(M);
  for (string &e : v) {
    e = string(M, ' ');
  }
  v[0][0] = '+';
  for (int i = 1; i < M; i++) {
    v[i][0] = (i % 2 ? '|' : '+');
  }
  for (int i = 1; i < M; i++) {
    v[0][i] = '+';
  }
  for (int i = 1; i < M; i++) {
    v[M - 1][i] = '+';
  }
  for (int i = 1; i < M; i++) {
    v[i][M - 1] = (i % 2 ? '|' : '+');
  }
  v[0][0] = v[0][M - 1] = v[M - 1][0] = v[M - 1][M - 1] = '+';
  v[M - 1][0] = v[M - 1][1] = ' ';
  v[0][M - 1] = v[0][M - 2] = ' ';
  int curMsk = 0;
  for (int mask : res) {
    curMsk++;
    mxMask = max(mxMask, __builtin_popcount(mask));
    int curX = 0;
    for (int bit = 0; bit < N; bit++) {
      if ((mask >> bit) & 1) {
        v[y][x + curX] = 'a' + bit;
        curX++;
      }
    }
    y += 2;
    if (y >= M - 2 || curMsk == res.size()) {
      for (int i = 2; i <= M - 3; i += 2) {
        if (v[i][x] != ' ') {
          for (int j = 0; j < mxMask; j++) {
            if (v[i][x + j] == ' ') {
              v[i][x + j] = '-';
            }
          }
        }
      }
      y = 2;
      x += mxMask;
      for (int i = 1; i < M - 1; i++) {
        v[i][x] = (i % 2 ? '|' : '+');
        v[i][x + 2] = (i % 2 ? '|' : '+');
      }
      v[1][x] = ' ';
      v[M - 2][x + 2] = ' ';
      mxMask = 0;
      x += 3;
    }
  }
  for (string &e : v) {
    for (char &c : e) {
      cout << c;
    }
    cout << endl;
  }
}
