#ifdef LOCAL
// #define NEED_INTERACTOR 
#endif
#include <bits/stdc++.h>
using namespace std;

#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////

int n;
vector<int> compose(const vector<int>& a, const vector<int>& b) {
    vector<int> ans;
    for (auto i: a) ans.push_back(b[i]);
    return ans;
}
vector<int> find_rev(const vector<int>& a) {
    vector<int> ans(len(a));
    rep(i, len(a)) ans[a[i]] = i;
    return ans;
}

#ifdef NEED_INTERACTOR
vector<int> original, rev_original;

void read() {
    cin >> n;
    original.resize(n);
    rep(i, n) {
        cin >> original[i];
        --original[i];
    }
    rev_original = find_rev(original);
}

vector<int> ask(const vector<int>& a) {
    cout << "?";
    for (auto i: a) cout << ' ' << i + 1;
    cout << endl;
    auto ans = compose(compose(rev_original, a), original);
    cout << "= ";
    for (auto i: ans) cout << i + 1 << ' ';
    cout << endl;
    return ans;
}

void answer(const vector<int>& ans) {
    cout << "!";
    for (auto i: ans) cout << ' ' << i + 1;
    cout << endl;
    
    if (ans != original) {
        cout << "FAILED" << endl;
        exit(0);
    }
    cout << "OK" << endl;
}

#else
void read() {
    cin >> n;
}

vector<int> ask(const vector<int>& a) {
    cout << "?";
    for (auto i: a) cout << ' ' << i + 1;
    cout << endl;
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        cin >> ans[i];
        --ans[i];
    }
    return ans;
}
void answer(const vector<int>& ans) {
    cout << "!";
    for (auto i: ans) cout << ' ' << i + 1;
    cout << endl;
    return ;
}
#endif

int main(void) {
#ifdef LOCAL
    // freopen("main.inp", "r", stdin); 
    // freopen("main.out", "w", stdout); 
    freopen(".log", "w", stderr);
#endif
    // ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); 
    int ntest; cin >> ntest;
    while (ntest--) {
        read();
        // ask({0, 2, 3, 1}); 
        vector<int> y(n);
        rep(i, n) y[i] = i + 1;
        y.back() = 0;
        auto u = ask(y);
        
        vector<int> b;
        int link = 0;
        rep(i, n) {
            b.push_back(link);
            link = u[link];
        }
        clog << db(b) << endl;
        assert(link == 0);
        
        swap(y[0], y.back());
        auto v = ask(y);
        int start = -1;
        rep(i, n) if (v[i] == i) {
            start = i;
            break;
        }
        assert(start != -1);
        vector<int> ans;
        rep(shift, n) {
            if (b[shift] == start) {
                rep(i, n) ans.push_back(b[(i + shift) % n]);
                break;
            }
        }
        assert(len(ans));
        answer(ans);
        
    }
    
    return 0;
}

// vim: foldmethod=marker

