#include <bits/stdc++.h>

using namespace std;

int n, w, h, s;
vector<vector<char>> screens[30];
char letters[94];
vector<pair<int, int>> optimal(30, {-1, -1});
vector<int> letter_param[94];

void input() {
  cin >> n >> w >> h >> s;

  for (int i = 0; i < n; i++) {
    cin >> letters[i];

    screens[i] = vector<vector<char>>(h, vector<char>(w));
    for (int i_h = 0; i_h < h; i_h++) {
      for (int i_w = 0; i_w < w; i_w++) {
        cin >> screens[i][i_h][i_w];
      }
    }
  }
}

int check_front(int i, int i_h) {
  return (screens[i][i_h][0] == '#' ? 1 : 0);
}

int check_back(int i, int i_h) {
  return (screens[i][i_h][w - 1] == '#' ? 1 : 0);
}

int check_both(int i, int i_h) {
  return check_front(i, i_h) + check_back(i, i_h);
}

void find_optimal_letter() {
  for (int i = 0; i < n; i++) {
    letter_param[i] = vector<int>(h);

    for (int i_h = 0; i_h < h; i_h++) {
      int num = 0;

      char last_char = screens[i][i_h][0];

      for (int i_w = 1; i_w < w; i_w++) {
        if (screens[i][i_h][i_w] != last_char) {
          last_char = screens[i][i_h][i_w];
          num++;
        }
      }

      letter_param[i][i_h] = num;
      num += check_both(i, i_h);

      if (optimal[i_h].first == -1 ||
          optimal[i_h].first < num) {
        optimal[i_h] = {num, i};
      }
    }
  }
}

int check_solo_ans(int cur, int j_h) {
  int ticks = 0;
  for (int i_w = 1; i_w < w; i_w++) {
    ticks++;
    if (screens[cur][j_h][i_w] != screens[cur][j_h][i_w - 1]) {
      s--;
    }

    if (s == 0) {
      return ticks;
    }
  }

  return 0;
}

int check_duo_first(int cur, int j_h) {
  int switches = 0;
  for (int i_w = 1; i_w < w; i_w++) {
    if (screens[cur][j_h][i_w] != screens[cur][j_h][i_w - 1]) {
      switches++;
      s--;
    }
  }

  return switches;
}

struct ans_s {
  int num;
  int in_last;

  int first;
  int mid;
  int last;

  ans_s(int num, int in_last, int first, int mid, int last)
    : num(num), in_last(in_last), first(first), mid(mid), last(last) {}
};

void solution() {
  find_optimal_letter();

  // ONE SCREEN IF ENOUGH
  pair<int, int> result_1 = {INT_MAX, INT_MAX};
  for (int i = 0; i < n; i++) {
    for (int i_h = 0; i_h < h; i_h++) {
      for (int i_w = 0; i_w < w; i_w++) {
        if (letter_param[i][i_h] >= s) {
          int tmp_s = s;

          int tmp = check_solo_ans(i, i_h);

          if (result_1.first > tmp) {
            result_1 = {tmp, i};
          }

          s = tmp_s;
        }
      }
    }
  }
  if (result_1.first != INT_MAX) {
    cout << letters[result_1.second];
    return;
  }

  // TWO SCREENS IS ENOUGH
  pair<int, pair<int, int>> result_2 = {INT_MAX, {0, 0}};
  for (int first = 0; first < n; first++) {
    for (int second = 0; second < n; second++) {
      for (int i_h = 0; i_h < h; i_h++) {
        int tmp_s = s;

        int tmp = check_duo_first(first, i_h) + check_back(first, i_h);
        if (s == 1 && check_front(second, i_h) == 1) {
          tmp += 1;
        } else {
          tmp += check_solo_ans(second, i_h) + 1;
        }

        if (tmp >= s && result_2.first > tmp) {
          result_2 = {tmp, {first, second}};
        }
        s = tmp_s;
      }
    }
  }

  if (result_2.first != INT_MAX) {
    cout << letters[result_2.second.first] << letters[result_2.second.second];
    return;
  }

  // NEED MORE THAN 2 SCREENS
  ans_s result_3 = {INT_MAX, INT_MAX, 0, 0, 0};
  for (int first = 0; first < n; first++) {
    for (int second = 0; second < n; second++) {
      for (int i_h = 0; i_h < h; i_h++) {
        int s_c = s - (check_solo_ans(first, i_h) + check_back(first, i_h));

        int ans = (s_c / optimal[i_h].first);

        s -= ans * optimal[i_h].first;

        int tmp;
        if (s == 1 && check_front(second, i_h) == 1) {
          tmp += 1;
        } else {
          tmp += check_solo_ans(second, i_h) + 1;
        }

        if (result_3.first > ans) {
          result_3 = {ans, tmp, first, optimal[i_h].second, second};
        }
      }
    }
  }

  cout << letters[result_3.first];
  for (int i = 0; i < result_3.first; i++) {
    cout << letters[result_3.mid];
  }
  cout << letters[result_3.last];
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  input();
  solution();

  return 0;
}
