#include <bits/stdc++.h>

using namespace std;

struct edge {
    int id;
    int from;
    int to;
    bool w;
    bool operator<(edge e) const {
        return this->id < e.id;
    }
};

int n, c, m;
map<int, int> compress;
map<int, int> decompress;
vector<bool> used;
int good = 0;
int used_good = 0;
vector<vector<edge>> g;
set<edge> not_accept;

vector<edge> path;
void euler(int u, edge prev_e) {
    while (!g[u].empty()) {
        edge e = g[u].back();
        g[u].pop_back();
        if (!used[e.id]) {
            used[e.id] = true;
            euler(e.to, e);
        }
    }
    if (prev_e.id != -1) {
        used_good++;
        path.push_back(prev_e);
    }
    set<edge> s;
    for (edge e : not_accept) {
        if (u != e.from) {
            s.insert(e);
        }
    }
    for (edge e : s) {
        path.push_back(e);
        not_accept.erase(e);
    }
}

void read() {
    cin >> n >> c;
    set<int> s;
    s.insert(c);
    vector<edge> edges;
    for (int i = 1; i <= n; ++i) {
        int a, b;
        bool w;
        cin >> a >> b >> w;
        s.insert(a);
        s.insert(b);
        edges.push_back({i, a, b, w});
    }
    m = s.size();
    int i = 0;
    for (int x : s) {
        compress[x] = i;
        decompress[i++] = x;
    }
    g.assign(m, {});
    for (edge &e : edges) {
        e.from = compress[e.from];
        e.to = compress[e.to];
        if (e.w) {
            good++;
            g[e.from].push_back(e);
        } else {
            not_accept.insert(e);
        }
    }
}

int edges_cnt = 0;
void dfs(int u, vector<bool> &visited) {
    visited[u] = true;
    for (edge e : g[u]) {
        edges_cnt++;
        if (!visited[e.to]) {
            dfs(e.to, visited);
        }
    }
}

bool validate() {
    vector<bool> visited(m, false);
    dfs(compress[c], visited);
    vector<int> in(m, 0), out(m, 0);
    for (int u = 0; u < m; ++u) {
        out[u] = g[u].size();
        for (edge e : g[u]) {
            in[e.to]++;
        }
    }
    int cnt = 0;
    bool c_was = false;
    for (int u = 0; u < m; ++u) {
        if (abs(in[u] - out[u]) > 1) {
            return false;
        }
        if (abs(in[u] - out[u]) == 1) {
            c_was |= (u == compress[c]);
            cnt++;
        }
    }
    return ((c_was && cnt == 2) || cnt == 0) && edges_cnt == n - not_accept.size();
}

int main() {
    read();
    if (!validate()) {
        cout << "NO\n";
        return 0;
    }
    used.assign(n, false);
    euler(compress[c], {-1, INT_MAX, INT_MAX, false});
    reverse(path.begin(), path.end());
    if (path.size() < n || used_good != good) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    for (edge e : path) {
        cout << e.id << " ";
    }
}