import java.io.*;

/**
 * @author Rakhim Khakimov (ramhakimov@niuitmo.ru)
 */

public class NunchucksShop {
    public static void main(String[] args) throws Exception {
        MyScan in = new MyScan(System.in);
        BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));
        in.hasNext();
        int n = in.nextNumber();
        int k = in.nextNumber();
        long ans = 0;
        long[][] Binom = new long[n + k + 1][n + k + 1];
        for (int i = 0; i < n + k + 1; i++) {
            Binom[0][i] = 1;
        }
        for (int i = 1; i < n + k + 1; i++) {
            for (int j = 1; j <= i; j++) {
                Binom[j][i] = Binom[j][i - 1] + Binom[j - 1][i - 1];
            }
        }
        int cur = 0;
        int L = Math.max(0, k - n);
        int R = Math.min(n, k);
        for (int i = L; i <= R; ++i) {
            ans += Binom[i][n];
        }
        int step = (n % 2 == 0) ? 2 : 1;
        for (int i = L + L % 2; i <= R; i += step) {
            if (i == k / 2) cur = 1;
            ans += Binom[i / 2][n / 2];
        }
        ans /= 2;
        if (k % 2 == 0) {
            ans += (Binom[k / 2][n] + Binom[k / 4][n / 2] * cur) / 2;
        }
        out.write(ans + "\n");
        out.flush();
    }

    public static class MyScan {
        private final BufferedReader source;
        private int currentIndex = 0;
        private int currentSize = 0;

        public MyScan(InputStream input) {
            source = new BufferedReader(new InputStreamReader(input));
        }

        private char[] buffer = new char[1024];

        boolean hasNext() throws IOException {
            while (currentSize <= currentIndex && currentSize != -1) {
                currentSize = source.read(buffer);
                currentIndex = 0;
            }
            return (currentSize > currentIndex);
        }

        public boolean isEndOfLine(boolean isWord) throws IOException {
            while (Character.isWhitespace(buffer[currentIndex])) {
                if (buffer[currentIndex++] == '\n') {
                    return true;
                }
                hasNext();
            }
            return false;

        }

        private String next() throws IOException {
            StringBuilder currentString = new StringBuilder();
            int counter = 0;
            while (currentIndex < currentSize) {
                if (!Character.isWhitespace(buffer[currentIndex])) {
                    counter++;
                    currentString.append(buffer[currentIndex]);
                    currentIndex++;
                    hasNext();
                } else if (counter != 0) {
                    break;
                } else {
                    currentIndex++;
                    if (currentIndex >= currentSize) {
                        if (!hasNext()) {
                            break;
                        }
                    }
                }
            }
            return currentString.toString();
        }

        public String nextWord() throws IOException {
            return next();
        }

        public int nextNumber() throws Exception {
            String temp = next();
            return Integer.parseInt(temp);
        }
    }
}