import java.io.*;
import java.nio.CharBuffer;
import java.util.*;

public class Main {
    static int[] parent;
    static int[] size;
    static int[] exp;
    static int n, w, h, s;
    static String command;
    static Character symbol, last;

    static int[] sumSquare(int n) {
        for (int i = 0; i * i <= n; i++)
            for (int j = 0; j * j <= n; j++)
                if (i * i + j * j == n) {
                    return new int[]{i, j};
                }
        return new int[]{-1, -1};
    }

    public static void main(String[] args) {
        FastScanner scanner = new FastScanner(System.in);
        PrintStream writer = System.out;
        n = scanner.nextInt();
        w = scanner.nextInt();
        h = scanner.nextInt();
        s = scanner.nextInt();
        Map<Character, String[]> symbols = new HashMap<>();
        char symbol;
        int most_common = 0;
        int[] cords = new int[]{0, 0};
        int global_max = 0, global_index = 0;
        char global_symbol = 'i';
        while (n-- > 0) {
            symbol = scanner.nextToken().charAt(0);
            int[] pixels = new int[w];
            for (int i = 0; i < h; i++) {
                String line = scanner.nextToken();
                int mx = 0;
                int index = 0;
                for (int j = 0; j < w; j++) {
                    if (line.charAt(j) == '#') {
                        pixels[j]++;
                        if (pixels[j] > mx) {
                            mx = pixels[j];
                            index = j;
                        }
                    }
                }
                if (mx > global_max) {
                    global_max = mx;
                    global_index = index;
                    global_symbol = symbol;
                }

            }
        }
//        writer.println(global_max);
        writer.printf("%s%n", spaces((int) Math.ceil((double) s / global_max), global_symbol));
    }

    static public String spaces(int spaces, char character) {
        return CharBuffer.allocate(spaces).toString().replace('\0', character);
    }

    static class MyStack {
        Stack<Integer> stackArray;
        Stack<Integer> minimalElement;

        MyStack() {
            stackArray = new Stack<>();
            minimalElement = new Stack<>();
        }

        public int getMinimum() {
            return minimalElement.peek();
        }

        void pop() {
            Integer t = stackArray.pop();
            if (t == getMinimum()) {
                minimalElement.pop();
            }
        }

        void push(Integer x) {
            if (stackArray.isEmpty()) {
                minimalElement.push(x);
                stackArray.push(x);
                return;
            }
            if (x <= getMinimum()) {
                minimalElement.push(x);
            }
            stackArray.push(x);
        }
    }

    public static class FastScanner implements AutoCloseable {
        BufferedReader br;
        StringTokenizer in;

        public FastScanner(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String nextToken() {
            try {
                while (in == null || !in.hasMoreTokens()) {
                    in = new StringTokenizer(br.readLine());
                }
                return in.nextToken();
            } catch (IOException e) {
                System.out.printf("I/O error! %s", e.getMessage());
                return "";
            }
        }

        public int nextInt() {
            return Integer.parseInt(nextToken());
        }

        public void close() {
            try {
                br.close();
            } catch (IOException e) {
                System.out.printf("I/O error! %s", e.getMessage());
            }
        }
    }
}
