// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) (s).size()
#define sqr(s) ((s) * (s))
#define pos(x) (2 * (x))
#define neg(x) (2 * (x) + 1)

using ll = long long;
using namespace std;

size_t n, m, c;

map<size_t, size_t> mpv;
set<pair<size_t, size_t>> g[200500];
pair<size_t, size_t> e[100500];
map<pair<size_t, size_t>, vector<size_t>> to_edge;

vector<size_t> path;

size_t to_vertex(size_t v) {
	if (!mpv.count(v))
		mpv[v] = mpv.size();
	n = mpv.size();
	return mpv[v];
}

void dfs(size_t v) {
	if (!g[v].empty()) {
		auto p = *g[v].begin();
		g[v].erase(g[v].begin());
		dfs(p.second);
	}
	path.push_back(v);
}

size_t get_edge(size_t u, size_t v) {
	size_t i = to_edge[{u, v}].back();
	to_edge[{u, v}].pop_back();
	return i;
}

int main() {
	ios::sync_with_stdio(false); cin.tie(0);
	// cout.precision(9); cout << fixed;
#ifdef EUGENE
	freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#else
	// freopen("nfc.in", "r", stdin);
	// freopen("nfc.out", "w", stdout);
#endif

	cin >> m >> c;
	c = to_vertex(c);
	bool has_edge_from_start = false;
	vector<size_t> bad_edges_start, bad_edges_else, good_edges_start_loop, good_edges;
	for (size_t i = 0; i < m; i++) {
		size_t u, v, w;
		cin >> u >> v >> w;
		u = to_vertex(u);
		v = to_vertex(v);
		if (w) {
			g[u].insert({i, v});
			good_edges.push_back(i);
			to_edge[{u, v}].push_back(i);
			if (u == c && v != c)
				has_edge_from_start = true;
			if (u == c && v == c)
				good_edges_start_loop.push_back(i);
		} else {
			if (u == c)
				bad_edges_start.push_back(i);
			else
				bad_edges_else.push_back(i);
		}
	}

	vector<size_t> answer;

	dfs(0);
	reverse(ALL(path));

	if (path.size() != good_edges.size() + 1) {
		cout << "No" << endl;
		return 0;
	}

	// for (size_t v : path)
	// 	cout << v + 1 << " ";
	// cout << endl;

	if (has_edge_from_start) {
		for (size_t i : bad_edges_else)
			answer.push_back(i);

		assert(path.size() > 1);

		size_t j = 0;
		for (; path[j] == c; j++) {
			answer.push_back(get_edge(path[j], path[j + 1]));
		}

		for (size_t i : bad_edges_start)
			answer.push_back(i);

		for (size_t i = j; i < path.size() - 1; i++) {
			answer.push_back(get_edge(path[i], path[i + 1]));
		}
	} else {
		if (good_edges.size() > good_edges_start_loop.size() ||
			bad_edges_start.size() > 0) {
			cout << "No" << endl;
			return 0;
		}

		for (size_t i : bad_edges_else)
			answer.push_back(i);

		for (size_t i : good_edges_start_loop)
			answer.push_back(i);

		assert(answer.size() == m);
	}

	cout << "Yes" << endl;
	for (size_t i : answer)
		cout << i + 1 << " ";
	cout << endl;
}
