#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

map<int, multiset<pair<int, int>>> G;
map<int, int> din, dout;
vector<int> path;

void dfs(int v) {
    while (!G[v].empty()) {
        auto c = *G[v].begin();
        int to = c.first, ind = c.second;
        G[v].erase(G[v].begin());
        G[to].erase(G[to].find({v, ind}));

        dfs(to);
        path.push_back(ind);
    }
}

void solve() {
    int n, c;
    cin >> n >> c;

    vector<int> negs, pre;
    int pos = 0;
    int good = -1;

    for (int i = 0; i < n; i++) {
        int a, b, t;
        cin >> a >> b >> t;

        if (t == 1) {
            dout[a]++;
            din[b]++;
            G[a].insert({b, i});
            G[b].insert({a, i});
            pos++;
            if (b != c) {
                good = i;
            }
        } else {
            if (a != c) {
                pre.push_back(i);
            } else {
                negs.push_back(i);
            }
        }
    }


    if (!negs.empty() && good == -1) {
        puts("No");
        return;
    }

    int start = -1, finish = -1;
    for (const auto& item : G) {
        int v = item.first;
        if (din[v] > dout[v]) {
            if (din[v] != dout[v] + 1 || finish != -1) {
                puts("No");
                return;
            }
            finish = v;
        }
        if (din[v] < dout[v]) {
            if (din[v] + 1 != dout[v] || start != -1) {
                puts("No");
                return;
            }
            start = v;
        }
    }

    if (start == -1 && finish == -1 || (start == c && finish != -1)) {
        dfs(c);
        reverse(path.begin(), path.end());

        if ((int)path.size() < pos) {
            puts("No");
            return;
        }

        cout << "Yes\n";
        for (int x : pre) cout << x + 1 << " ";

        for (int x : path) {
            cout << x + 1 << " ";
            if (x == good) {
                for (int t : negs) cout << t + 1 << " ";
            }
        }
        cout << "\n";
    } else {
        puts("No");
    }
}