#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

vector<vector<pair<int, int>>> rules(26);
vector<vector<char>> terms(26);
char G[31][31][31];

const ll base = (ll) 1e18;

struct big_int {

    vector<ll> data;

    int size() const { return data.size(); }

    ll &operator[](int x) { return data[x]; }

    ll operator[](int x) const { return data[x]; }
};

void check(int pos, big_int &a) {
    if (pos >= (int) a.size()) {
        a.data.push_back(0);
    }
}

big_int sum(big_int a, const big_int &b) {
    ll add = 0;

    for (int i = 0; i <= (int) b.size(); i++) {
        check(i, a);

        ll vb = (i < (int) b.size() ? b[i] : 0);
        a[i] += vb + add;
        add = 0;

        if (a[i] >= base) {
            add = 1;
            a[i] -= base;
        }
    }
    return a;
}

bool les(big_int &a, big_int &b) {
    while (a.data.back() == 0) a.data.pop_back();
    while (b.data.back() == 0) b.data.pop_back();
    if (a.size() > b.size()) return false;
    if (a.size() < b.size()) return true;
    for (int i = (int) a.size() - 1; i >= 0; i--) {
        if (a[i] < b[i]) return true;
        if (a[i] > b[i]) return false;
    }
    return false;
}

bool ok(const big_int &x) {
    return x.size() > 1 || x[0] != -1;
}

big_int d[31][31][31];

void solve() {
    for (auto &i : d) {
        for (auto &j : i) {
            for (auto &k : j) {
                k.data = {-1};
            }
        }
    }

    int p;
    cin >> p;
    for (int i = 0; i < p; i++) {
        char nont;
        cin >> nont;
        string tmp;
        cin >> tmp;
        string sec;
        cin >> sec;
        if (sec.size() == 2) {
            rules[nont - 'A'].emplace_back(sec[0] - 'A', sec[1] - 'A');
        } else {
            terms[nont - 'A'].push_back(sec[0] - 'a');
        }
    }

    int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--, t--;

    for (int i = 0; i < m; i++) {
        int a, b;
        char c;
        cin >> a >> b >> c;
        a--, b--;
        G[a][b][c - 'a'] = 1;
    }

    for (int a = 0; a < n; a++) {
        for (int b = 0; b < n; b++) {
            for (int nt = 0; nt < 26; nt++) {
                for (auto c : terms[nt]) {
                    if (G[a][b][c]) {
                        d[a][b][nt].data = {1};
//                        cout << a << " " << b << " " << (char)('A' + c) << "\n";
                    }
                }
            }
        }
    }

    int upd = 1;
    for (int it = 0; upd && clock() < 1.9 * CLOCKS_PER_SEC; it++) {
//        err("it = %d\n", it);
        upd = 0;
            for (int nt = 0; nt < 26; nt++) {
                   for (auto rule : rules[nt]) {
                for (int a = 0; a < n; a++) {
                    for (int b = 0; b < n; b++) {
        for (int c = 0; c < n; c++) {
                            if (ok(d[a][c][rule.first]) && ok(d[c][b][rule.second])) {
                                auto tmp = sum(d[a][c][rule.first], d[c][b][rule.second]);
                                if (!ok(d[a][b][nt])) {
                                    d[a][b][nt] = tmp;
                                    upd = 1;
                                } else {
                                    if (les(tmp, d[a][b][nt])) {
                                        d[a][b][nt] = tmp;
                                        upd = 1;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }


//    auto ta = big_int();
//    ta.data = {(ll)9e17};
//    auto tb = ta;
//    tb.data = {(ll)1e17 + 1123};
//    auto res = sum(ta, tb);

    auto res = d[s][t]['S' - 'A'];
    if (!ok(res)) {
        cout << "NO\n";
    } else {
        int first = 1;
        for (int i = (int) res.size() - 1; i >= 0; i--) {
            if (!first) {
                printf("%018lld", res[i]);
            } else {
                printf("%lld", res[i]);
            }
            first = 0;
        }
    }
}
