#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef SIR
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

double prob(vector<int> &s) {
    int m = s.size();
    double p = 1;
    double res = 0;
    for (int i = 0; i < m; i++) {
        if (s[i] == 1) {
            res += p;
            break;
        }
        if (s[i] == 0) {
            double t = 1.0 / (i + 2);
            res += t * p;
            p *= 1 - t;
        }
        p *= 0.5; // win
    }
    return 1 - res;
}

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
vector<gp_hash_table<int, bool> > vertex;
vector<gp_hash_table<int, int> > preorder;

vector<vector<double> > dp;
const int T = 35;
double dp3[T][T][T];

double prob2(int w, int n) {
    return dp[n][w];
}
double prob3(int i, int ss, int w) {
    return dp3[i][ss][w];
}

void solve() {
    int k, n;
    cin >> k >> n;
    vertex.resize(k);
    vertex[k - 1][0] = true;
    preorder.resize(k);
    double res = 0;
    for (int i = 0; i < n; i++) {
        int s, m;
        cin >> s >> m;
        s--, m--;
        preorder[s][m] = i;
        for (int j = s; j < k; j++) {
            vertex[j][m] = true;
            m /= 2;
        }
    }

    dp.resize(T, vector<double>(T));
    for (int ss = 0; ss < T; ss++) {
        for (int i = 0; i < T; i++) {
            vector<int> W(ss);
            if (i < ss) W[i] = 1;
            dp[ss][i] = prob(W);
        }
    }
    for (int i = 0; i < T; i++) {
        for (int W = 0; W < T; W++) {
            for (int SS = 0; SS < T; SS++) {
                if (i + W >= T || i + SS >= T) continue;
                int w = W;
                int ss = SS;
                double res = 0;
                for (int h = 0; h < i; h++) {
                    double p = prob2(w, ss);
                    double cnt = pow(2.0, h);
                    res += p * cnt;
                    w++;
                    ss++;
                }
                dp3[i][SS][W] = res;
            }
        }
    }

    for (int i = 0; i < k; i++) {
        for (auto Vt : vertex[i]) {
            int V = Vt.first;
            vector<int> s;
            bool count_V = preorder[i].find(V) != preorder[i].end();
            {
                int v = V;
                for (int j = i; j < k; j++) {
                    bool count_v = preorder[j].find(v) != preorder[j].end();
                    s.push_back(count_v);
                    if (count_V && count_v && preorder[i][V] < preorder[j][v]) {
                        s.back() = -1;
                    }
                    v /= 2;
                }
            }
            {
                auto w = s;
                w.erase(w.begin());
                if (count_V) {
                    for (auto &qq : w) {
                        if (qq == 0) {
                            qq = -1;
                        }
                    }
                }
                double p = prob(w);
                res += p;
            }
            for (auto &qq : s) {
                if (qq == -1) qq = 1;
            }
            int Q = s.size();
            for (int kk = 0; kk < s.size(); kk++) {
                if (s[kk] == 1) {
                    Q = kk;
                    break;
                }
            }

            if (i > 0) {
                for (int u : {V * 2, V * 2 + 1}) {
                    if (vertex[i - 1].find(u) == vertex[i - 1].end()) {
                        auto w = Q;
                        int ss = s.size();
                        res += prob3(i, ss, w);
                    }
                }
            }
        }
    }

    cout.precision(20);
    cout << fixed << res;
}
