// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

void solve() {
	string s;
	getline(cin, s);
	vector<string> tokens;
	string cur = "";
	for (char c : s) {
		if (!('a' <= c && c <= 'z')) {
			if (szof(cur)) {
				tokens.push_back(cur);
				cur.clear();
			}

			if (c != ' ') {
				tokens.push_back(string(1, c));
			}
		} else {
			cur += c;
		}
	}

	if (szof(cur)) {
		tokens.push_back(cur);
	}

	int pos = 0;

	vector<string> op = {"or", "and"};

	function<bitset<256>()> parse_un;

	function<bitset<256>(int)> parse_bin = [&](int lvl) {
		if (lvl == 2) {
			return parse_un();
		}
		// cerr << "parse bin " << lvl << " " << pos << " " << tokens[pos] << endl;

		bitset<256> ret = parse_bin(lvl + 1);
		while (pos < szof(tokens) && tokens[pos] == op[lvl]) {
			++pos;
			bitset<256> tmp = parse_bin(lvl + 1);
			if (lvl == 0) {
				ret |= tmp;
			} else {
				ret &= tmp;
			}
		}

		return ret;
	};

	parse_un = [&]() {
		// cerr << "parse un " << pos << " " << tokens[pos] << endl;
		if (tokens[pos] == "(") {
			++pos;
			auto ret = parse_bin(0);
			assert(tokens[pos] == ")");
			++pos;
			return ret;
		}

		if (tokens[pos] == "not") {
			++pos;
			return ~parse_un();
		}

		// cerr << tokens[pos] << endl;
		assert(szof(tokens[pos]) == 1 && 'a' <= tokens[pos][0] && tokens[pos][0] <= 'z');
		bitset<256> ret;
		for (int i = 0; i < 256; ++i) {
			if (i & (1 << (tokens[pos][0] - 'a'))) {
				ret[i] = 1;
			}
		}
		++pos;
		return ret;
	};

	bitset<256> res = parse_bin(0);

	vector<int> need;
	for (int i = 0; i < 256; ++i) {
		int cnt = 0;
		for (int ind = 0; ind < 8; ++ind) {
			if (i & (1 << ind)) {
				if (res[i] < res[i ^ (1 << ind)]) {
					cout << "IMPOSSIBLE\n";
					return;
				}
				if (res[i ^ (1 << ind)]) {
					++cnt;
				}
			}
		}
		if (res[i] && !cnt) {
			need.push_back(i);
		}
	}

	vector<vector<char>> field(50, vector<char>(50, ' '));

	for (int i = 0; i < 50; ++i) {
		field[i][0] = '.';
	}

	field[49][1] = '.';
	field[1][10] = field[1][11] = field[1][12] = '.';
	field[49][21] = field[49][22] = field[49][23] = '.';
	vector<pii> positions;
	for (int q = 0; q < 3; ++q) {
		for (int i = 0; i <= 24; ++i) {
			for (int j = 0; j < 8; ++j) {
				field[49 - i * 2][2 + j + q * (8 + 3)] = '.';
			}
			if (i < 24) {
				positions.push_back({49 - i * 2 - 1, 2 + q * (8 + 3)});
			}
		}
	}

	for (int i = 31; i < 50; ++i) {
		field[0][i] = '.';
	}

	for (int i = 0; i < szof(need); ++i) {
		auto [x, y] = positions[i];
		for (int j = 0; j < 8; ++j) {
			if (need[i] & (1 << j)) {
				field[x][y + j] = 'a' + j;
			}
		}
	}

	for (int i = szof(need); i < szof(positions); ++i) {
		auto [x, y] = positions[i];
		field[x][y] = '.';
	}

	for (int i = 0; i < 50; ++i) {
		for (int j = 0; j < 50; ++j) {
			if (field[i][j] != '.') {
				continue;
			}
			vector<int> dirs;
			for (int d = 0; d < 4; ++d) {
				int nx = i + dx[d];
				int ny = j + dy[d];
				if (0 <= nx && nx < 50 && 0 <= ny && ny < 50 && field[nx][ny] != ' ') {
					dirs.push_back(d);
				}
			}

			if (dirs == vector<int>({0, 2})) {
				field[i][j] = '|';
			} else if (dirs == vector<int>({1, 3})) {
				field[i][j] = '-';
			} else {
				field[i][j] = '+';
			}
		}
	}

	field[0][0] = field[0][49] = '+';

	for (int i = 0; i < 50; ++i) {
		for (int j = 0; j < 50; ++j) {
			cout << field[i][j];
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}