// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<int> pi, inv_pi;

vector<int> appl(vector<int> a, vector<int> b) {
	vector<int> ret(szof(a));
	for (int i = 0; i < szof(a); ++i) {
		ret[i] = b[a[i]];
	}
	return ret;
}

vector<int> ask(vector<int> perm) {
#ifdef TEST
	// return appl(inv_pi, appl(perm, pi));
	return appl(appl(inv_pi, perm), pi);
#else
	cout << "? ";
	for (int num : perm) {
		cout << num + 1 << " ";
	}
	cout << endl;
	vector<int> ret;
	for (int i = 0; i < szof(perm); ++i) {
		int num;
		cin >> num;
		--num;
		ret.push_back(num);
	}
	return ret;
#endif
}

void answer(vector<int> ans) {
#ifdef TEST
	assert(ans == pi);
#else
	cout << "! ";
	for (int num : ans) {
		cout << num + 1 << " ";
	}
	cout << endl;
#endif
}

void solve(int n) {
	vector<int> perm(n);
	for (int i = 0; i < n; ++i) {
		perm[i] = (i + 1) % n;
	}
	auto res = ask(perm);
	vector<int> order;
	int cur = 0;
	do {
		order.push_back(cur);
		cur = res[cur];
	} while (cur != 0);

	perm[0] = 0;
	for (int i = 1; i < n; ++i) {
		perm[i] = i % (n - 1) + 1;
	}

	res = ask(perm);

	int who = -1;
	for (int i = 0; i < n; ++i) {
		if (res[i] == i) {
			who = i;
			break;
		}
	}

	vector<int> ans(n);
	rotate(order.begin(), find(order.begin(), order.end(), who), order.end());
	for (int i = 0; i < n; ++i) {
		ans[order[i]] = i;
	}

	answer(ans);
}

void stress() {
	for (int t = 1; t <= 1000; ++t) {
		cerr << "test #" << t << endl;
		int n = rnd(3, 10000);
		pi = vector<int>(n);
		iota(pi.begin(), pi.end(), 0);
		inv_pi = vector<int>(n);
		for (int i = 0; i < n; ++i) {
			inv_pi[pi[i]] = i;
		}

		solve(n);
	}
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef TEST
	stress();
	return 0;
#endif

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		int n;
		cin >> n;
		solve(n);
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}