// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, k;
	cin >> n >> k;

	vector<vector<ll>> cnk(n + 1, vector<ll>(n + 1));
	cnk[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= i; ++j) {
			cnk[i][j] = cnk[i - 1][j];
			if (j) {
				cnk[i][j] += cnk[i - 1][j - 1];
			}
		}
	}

	auto calc = [&](int q) {
		ll tot = cnk[n][q];
		if (n % 2 == 0 && q % 2 == 0) {
			tot += cnk[n / 2][q / 2];
		}
		if (n % 2 == 1 && q % 2 == 0 && q < n) {
			tot += cnk[n / 2][q / 2];
		}
		if (n % 2 == 1 && q % 2 == 1) {
			tot += cnk[n / 2][q / 2];
		}
		tot /= 2;
		return tot;
	};

	ll ans = 0;
	if (k % 2 == 0) {
		ans += 2 * calc(k / 2);
	}
	for (int i = 0; i <= n; ++i) {
		if (i * 2 != k && i <= k && k <= i + n) {
			ans += calc(i);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}