#include <bits/stdc++.h>

using namespace std;

int n, m = 0;
vector<multiset<pair<int, int>>> edg;
vector<multiset<int>> edg_n;
vector<int> in, out;
vector<bool> used;
vector<int> ans;
unordered_map<int, int> id;
set<pair<int, int>> bad;
int cnt = 0;

bool check() {
  int same = 0, m1 = 0, p1 = 0;
  for (int i = 0; i < n; ++i) {
    if (out[i] == in[i]) ++same;
    if (out[i] == in[i] - 1) ++m1;
    if (out[i] - 1 == in[i]) ++p1;
  }
  return m1 == 1 && p1 == 1 && same == n - 2;
}

void dfs(int v, int &cnt) {
  used[v] = true;

  for (auto e : edg_n[v]) {
    ++cnt;
    if (!used[e]) {
      dfs(e, cnt);
    }
  }
}

void euler(int v) {
  stack<pair<int, int>> st;
  st.push({v, -1});
  while(!st.empty()) {
    auto u = st.top();
    pair<int, int> f = {-1, -1};
    for (auto &e : edg[u.first]) {
      st.push(e);
      f = e;
      break;
    }
    if (f.first != -1) {
      edg[u.first].erase(f);
    }
    else {
      ans.push_back(u.second);
      st.pop();
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  int c;
  cin >> n >> c;
  vector<pair<int, int>> cache;
  for (int i = 0; i < n; ++i) {
    int a, b, w;
    cin >> a >> b >> w;
    if (w == 0) {
      bad.insert({a, i});
    }
    else {
      if (id.count(a) == 0) {
        id[a] = cnt++;
        in.push_back(0);
        out.push_back(0);
        edg.emplace_back();
        edg_n.emplace_back();
        used.emplace_back();
      }
      if (id.count(b) == 0) {
        id[b] = cnt++;
        in.push_back(0);
        out.push_back(0);
        edg.emplace_back();
        edg_n.emplace_back();
        used.emplace_back();
      }
      int &id_a = id[a];
      int id_b = id[b];
      ++in[id_b];
      ++out[id_a];
      edg[id_a].insert({id_b, i});
      edg_n[id_a].insert(id_b);
      cache.emplace_back(a, b);
    }
  }

  int cnt1 = 0;
  dfs(0, cnt1);
  if (!check() || cnt1 != n - bad.size()) {
    cout << "No";
    return 0;
  }

  euler(0);
  ans.erase(ans.end() - 1);
  reverse(ans.begin(), ans.end());

  vector<int> real_ans;

  for (auto good : ans) {
    set<pair<int, int>> new_bad;
    for (auto &bad_el : bad) {
      if (bad_el.first == c) {
        new_bad.insert(bad_el);
      }
      else {
        real_ans.push_back(bad_el.second);
      }
    }
    bad = new_bad;
    c = cache[good].second;
    real_ans.push_back(good);
  }

  if (real_ans.size() < n) {
    cout << "No";
  }
  else {
    cout << "Yes\n";
    for (auto el : real_ans) {
      cout << el + 1 << " ";
    }
  }

  return 0;
}