#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <unordered_map>
#include <map>



using namespace std;

unordered_map <int, vector<pair<int, int>> > g;
map<pair<int, int>, vector<int>> indexes_by_pair;
vector<int> ans;
map<int, vector<int>> unused_edges;

void findPath(int v) {
    while (!g[v].empty()) {
        int next_v = g[v].back().first;
        g[v].pop_back();
        findPath(next_v);
    }
    ans.push_back(v);
}




int main() {
    int n, c;
    cin >> n >> c;

    for (int i = 0; i < n; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        if (w == 1) {
            g[a].push_back({b, i});
            indexes_by_pair[{a,b}].push_back(i + 1);
        } else {
            unused_edges[a].push_back(i + 1);
        }
    }


    findPath(c);
    reverse(ans.begin(), ans.end());

//    for (int i = 0; i < ans.size(); i++) {
//        cout << ans[i] << ' ';
//    }
//    cout << endl;
//    return  0;


    vector <int> result;
    int current_vertex = c;
    for (int i = 1; i < ans.size(); i++) {
        if (indexes_by_pair[{ans[i - 1], ans[i]}].empty()) {
            cout << "NO";
            return 0;
        }
        int current_index = indexes_by_pair[{ans[i - 1], ans[i]}].back();
        indexes_by_pair[{ans[i - 1], ans[i]}].pop_back();


        vector <int> deleted_edges;
        for (auto x : unused_edges) {
            if (x.first != current_vertex) {
                while (!unused_edges[x.first].empty()) {
                    result.push_back(unused_edges[x.first].back());
                    unused_edges[x.first].pop_back();
                }
                deleted_edges.push_back(x.first);
            }
        }
        for (int j = 0; j < deleted_edges.size(); j++) {
            unused_edges.erase(deleted_edges[j]);
        }

        result.push_back(current_index);
        current_vertex = ans[i];
    }

    vector <int> deleted_edges;
    for (auto x : unused_edges) {
        if (x.first != current_vertex) {
            while (!unused_edges[x.first].empty()) {
                result.push_back(unused_edges[x.first].back());
                unused_edges[x.first].pop_back();
            }
            deleted_edges.push_back(x.first);
        }
    }
    for (int j = 0; j < deleted_edges.size(); j++) {
        unused_edges.erase(deleted_edges[j]);
    }



    if (result.size() != n) {
        cout << "NO";
    } else {
        cout << "YES\n";
        for (int i = 0; i < result.size(); i++) {
            cout << result[i] << ' ';
        }
    }

    return 0;
}
//
//4 1
//1 2 0
//1 2 1
//2 3 1
//3 4 0
//
//7 1
//1 2 1
//2 3 1
//2 3 1
//3 2 1
//3 5 1
//3 10 0
//2 3 0


//3 1
//1 2 1
//1 2 1
//1 2 0

//3  1
//1 1 1
//1 1 0
//1 3 1