#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

vector <int64_t> v;
vector<int64_t> precalc;
vector<int64_t> precalc_prod;

double get_A(int i, int j) {
    return 1.* (v[j] - v[i]) / (j - i);
}

double get_pref_summ(int i, int j) {
    return precalc[j + 1] - precalc[i];
}

double get_pref_prid(int i, int j) {
    return precalc_prod[j] - precalc_prod[i];
}

double get_D(int i, int j, double A) {
    double result = 2 * get_pref_summ(i, j) - v[i] * v[i] - v[j] * v[j] + A * A * (j - i);
    result -= get_pref_prid(i, j);
    result += 2 * v[i] * A;
    result -= 2 * v[j] * A;
    return sqrt(result / (j - i));
}

double get_D_slow(int i, int j, double A) {
    double result = 0;
    for (int  k = i + 1; k <= j; k++) {
        result += (v[k] - v[k - 1] - A) * (v[k] - v[k - 1] - A);
    }
    return sqrt(result / (j - i));
}



int main() {
    int d;
    cin >> d;
    double P;
    cin >> P;
    v = vector<int64_t>(d);
    precalc = vector<int64_t>(d + 1);
    precalc_prod = vector<int64_t>(d);
    for (int i = 0; i < d; i++) {
        cin >> v[i];
        precalc[i + 1] = v[i] * v[i];
        precalc[i + 1] += precalc[i];
        if (i != 0) {
            precalc_prod[i] = 2 * v[i] * v[i - 1];
            precalc_prod[i] += precalc_prod[i - 1];
        }
    }


    int count_pos = 0;
    int count_neg = 0;
    for (int i = 0; i < d; i++ ){
        for (int j = i + 2; j < d; j++) {
            double A = get_A(i, j);
            double D = get_D_slow(i, j, A);

            if (D == 0) {
                if (A > 0) {
                    count_pos++;
                }
                if (A < 0) {
                    count_neg++;
                }
            } else {
                double x = A / D;
                if (x >= P) {
                    count_pos++;
                }
                if (x <= -P) {
                    count_neg++;
                }
            }
        }
    }
    cout << count_pos << ' ' << count_neg;


    return 0;
}


