#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <stack>

using namespace std;


void dfs(int v, map<int, bool> &was, map<int, vector<int>> &gr) {
    if (was[v]) {
        return;
    }
    was[v] = true;
    for (int i : gr[v]) {
        dfs(i, was, gr);
    }
}

bool checkForEuler(map<int, vector<int>> &gr, vector<int> const & vs, map<int, int> &cntIn, int c, map<int, vector<int>> &grFull) {
    bool foundFirst = false, foundLast = false;
    for (int i : vs) {
        if (gr[i].size() != cntIn[i]) {
            if (!foundFirst && gr[i].size() - cntIn[i] == 1 && i == c) {
                foundFirst = true;
            } else if (!foundLast && gr[i].size() - cntIn[i] == -1) {
                foundLast = true;
            } else {
                return false;
            }
        }
    }

    if (foundLast != foundFirst) {
        return false;
    }

    map<int, bool> was;
    for (int v : vs) {
        if (!gr[v].empty()) {
            dfs(v, was, grFull);
            break;
        }
    }

    for (int v : vs) {
        if (!gr[v].empty() && !was[v]) {
            return false;
        }
    }

    return true;
}

void findEulerWay(int c, map<int, vector<int>> &gr, vector<int> &ans,
                  map<int, vector<int>> &num, vector<int> &failed) {
    stack<int> s;
    s.push(c);
    map<int, int> lim;
    bool failedDone = false;
    while (!s.empty()) {
        int w = s.top();

        if (lim[w] < gr[w].size()) {
            ans.push_back(num[w][lim[w]]);
            if (gr[w][lim[w]] != c && !failedDone) {
                failedDone = true;
                for (int a : failed) {
                    ans.push_back(a);
                }
            }
            s.push(gr[w][lim[w]++]);
        } else {
            s.pop();
        }
    }
}

int main()
{
    int n, c;
    cin >> n >> c;
    c--;
    map<int, vector<int>> gr;
    map<int, vector<int>> grFull;
    map<int, vector<int>> edNum;
    vector<int> failed;
    vector<int> ans;
    set<int> exists;
    map<int, int> cntIn;

    for (int i = 0; i < n; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        exists.insert(a);
        exists.insert(b);
        if (w) {
            gr[a].push_back(b);
            grFull[a].push_back(b);
            grFull[b].push_back(a);
            edNum[a].push_back(i);
            cntIn[b]++;
        }
        else {
            if (a != c) {
                ans.push_back(i);
            } else {
                failed.push_back(i);
            }
        }
    }
    vector<int> vertexes;
    while (!exists.empty()) {
        vertexes.push_back(*exists.begin());
        exists.erase(exists.begin());
    }


    if (checkForEuler(gr, vertexes, cntIn, c, grFull)) {
        findEulerWay(c, gr, ans, edNum, failed);
        if (ans.size() != n) {
            cout << "No" << endl;
            return 0;
        }
        cout << "Yes\n";
        for (int i : ans) {
            cout << i + 1 << " ";
        }
    } else {
        cout << "No" << endl;
    }
    return 0;
}