import collections

And = collections.namedtuple('And', 'x y')
Or = collections.namedtuple('Or', 'x y')
Not = collections.namedtuple('Not', 'x')

letters = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']

s = input().replace('(', '( ').replace(')', ' )')
tokens = s.split()


def parsedigit(i):
    global tokens

    if tokens[i] in letters:
        return ord(tokens[i]) - 97, i + 1
    
    if tokens[i] == 'not':
        value, i = parsedigit(i + 1)
        return Not(value), i
    
    if tokens[i] == '(':
        value, i = parse(i + 1)
        return value, i + 1
    
    raise ValueError()


def parseand(i):
    global tokens

    value, i = parsedigit(i)

    if i < len(tokens) and tokens[i] == 'and':
        right, i = parseand(i + 1)
        value = And(value, right)
    
    return value, i


def parse(i):
    global tokens

    value, i = parseand(i)

    if i < len(tokens) and tokens[i] == 'or':
        right, i = parse(i + 1)
        value = Or(value, right)
    
    return value, i


value, _ = parse(0)
# print(value)

def calc(v, p):
    if isinstance(v, int):
        return (p & (1 << v)) == (1 << v)

    if isinstance(v, And):
        return calc(v.x, p) and calc(v.y, p)
    if isinstance(v, Or):
        return calc(v.x, p) or calc(v.y, p)
    if isinstance(v, Not):
        return not calc(v.x, p)


results = [None] * 256
primitives = []
for p in range(256):
    results[p] = calc(value, p)
    if results[p]:
        primitive = True
        for v in range(8):
            if (p & (1 << v)) == (1 << v) and results[p & (255 - (1 << v))]:
                primitive = False
                break
        if primitive:
            primitives.append(p)
    else:
        sub = p
        while True:
            sub = (sub - 1) & p

            if results[sub]:
                print("IMPOSSIBLE")
                exit()

            if sub == 0:
                break

if primitives == [0]:
    print('+ +')
    exit(0)

def bits(x):
    c = 0
    while x > 0:
        c += x & 1
        x >>= 2
    return c

primitives.sort(key=bits)
# print(primitives)

field = [[' ' for j in range(50)] for i in range(50)]

x = 0
by = 0
next_y = 1

to_right = True

for p in primitives:
    if x == 48 and to_right:
        field[next_y][46] = '|'
        x = 44
        by = next_y + 1
        to_right = False
    elif x == -4 and not to_right:
        field[next_y][0] = '|'
        by = next_y + 1
        x = 0
        to_right = True
    elif to_right:
        field[by][x - 1] = '-'
    else:
        field[by][x + 3] = '-'
    
    y = by

    for v in range(8):
        if (p & (1 << v)) == (1 << v):
            # print(v, x, y)
            if y > by:
                field[y][x] = '|'
                field[y][x + 2] = '|'
                y += 1
            
            # print("let", x, y)
            field[y][x] = '+'
            field[y][x + 2] = '+'
            field[y][x + 1] = chr(97 + v)

            y += 1
    
    if y == by + 1:
        field[by][x] = '-'
        field[by][x + 2] = '-'

    next_y = max(next_y, y)

    if to_right:
        x += 4
    else:
        x -= 4

# x, next_y → deep end

if to_right:
    for xx in range(x - 1, 49):
        field[next_y - 1][xx] = '-'

    field[next_y - 1][49] = '+'

    for yy in range(1, next_y - 1):
        field[yy][49] = '|'
else:
    x += 4

    field[next_y][x] = '|'
    field[next_y + 1][x] = '+'

    for xx in range(x + 1, 49):
        field[next_y + 1][xx] = '-'

    field[next_y + 1][49] = '+'

    for yy in range(1, next_y + 1):
        field[yy][49] = '|'

field[0][0] = '+'
field[0][49] = '+'

for line in field:
    print(*line, sep='')
