#include <iostream>
#include <functional>
#include <vector>
#include <map>
#include <cmath>

int is_square(int x)
{
    if (x < 0)
        return -1;
    int t = (int) sqrt(x);
    return t * t == x ? t : -1;
}

void solve(std::istream& is, std::ostream& os)
{
    int s;
    is >> s;
    for (int i = 0; i < s; ++i)
    {
        int j = is_square(s - i * i);
        if (i * i < s && j != -1)
        {
            os << "0 0" << std::endl;
            os << i << " " << j << std::endl;
            os << i - j << " " << j + i << std::endl;
            os << -j << " " << i << std::endl;
            return;
        }
    }
    os << "Impossible" << std::endl;

}

signed main()
{
    solve(std::cin, std::cout);
    return 0;
}
/*
3 4 5 16
I
.#..
#.#.
.#..
.#..
###.
C
.##.
#..#
#...
#..#
.##.
P
###.
#..#
###.
#...
#...
 */