#include <iostream>
#include <functional>
#include <vector>
#include <map>
#include <cmath>
#include <climits>

int is_square(int x)
{
    if (x < 0)
        return -1;
    int t = (int) sqrt(x);
    return t * t == x ? t : -1;
}

void solve(std::istream& is, std::ostream& os)
{
    int n;
    is >> n;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        is >> a[i];
    }
    std::sort(a.begin(), a.end());
    int min = INT_MAX;
    int max = INT_MIN;
    for (int i = 0; i < n - 1; ++i)
    {
        max = std::max(max, a[i + 1] - a[i]);
    }

    for (int i = 0; i < n - 2; ++i)
    {
        min = std::min(min, a[i + 2] - a[i]);
    }
    if (max < min)
    {
        os << max << std::endl;
    }
    else
    {
        os << 0 << std::endl;
    }

}

signed main()
{
    solve(std::cin, std::cout);
    return 0;
}
/*
5
5 13 2 10 8
 */