#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
int pos = 0;
int neg = 0;
long double eps = 1e-9;
long double p;

void check(long double a, long double d2) {
    if (abs(d2) < eps) {
        if (a > 0) {
            pos++;
        } else if (a < 0) {
            neg++;
        }
    } else {
        long double kek = (p * sqrt(d2));
        if (a >= kek) {
            pos++;
        } else if (a <= -kek) {
            neg++;
        }
    }
}

int main() {
    int n;
    cin >> n >> p;
    vector<int> c(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int l = 1; l < n; l++) {
        long double a = 0;
        long double d2 = 0;
        a += c[l] - c[l - 1];
        d2 += (c[l] - c[l - 1] - a) * (c[l] - c[l - 1] - a);
        for (int delta = 2; delta + l <= n; delta++) {
            long double a_new = (a * (delta - 1) + (c[l + delta - 1] - c[l + delta - 2])) / (delta);
            d2 = ((delta - 1) * d2 +
                  (c[l + delta - 1] - c[l + delta - 2] - a_new) * (c[l + delta - 1] - c[l + delta - 2] - a)) / (delta);
            a = a_new;
            check(a, d2);
        }
    }
    cout << pos << " " << neg;
    return 0;
}