import java.io.*
import java.lang.Integer.max
import java.util.*
import kotlin.system.exitProcess

const val INPUT_FILE_NAME = "test"

const val INPUT_JUDGE = ""

fun MutableList<Int>.swap(i: Int, j: Int): Boolean {
    if (this[i] > this[j]) {
        val tmp = this[i]
        this[i] = this[j]
        this[j] = tmp
        return true
    }
    return false
}

fun List<Int>.isSorted(): Boolean {
    for (i in 1 until this.size) {
        if (this[i] < this[i - 1])
            return false
    }
    return true
}

fun test(n: Int): (Int, Int) -> String {
    val arr = IntArray(n) {
        it + 1
    }.toMutableList()
    arr.shuffle()
    var start = List(n) {
        arr[it]
    }
    var res = ""
    var count = 0

    fun ask(i: Int, j: Int): String {
        val sw = arr.swap(i - 1, j - 1)
        res = if (sw) {
            if (arr.isSorted()) {
                "WIN"
            } else {
                "SWAPPED"
            }
        } else {
            "STAYED"
        }
        count++
        if (count % (2 * n) == 0) {
            arr.swap(random.nextInt(n), random.nextInt(n))
        }
        if (count >= 10_000) {
            start.forEach {
                out.print("$it ")
            }
            out.println()
            arr.forEach {
                out.print("$it ")
            }
            out.close()
            exitProcess(0)
        }
        return res
    }

    return ::ask
}

fun solve() {
    repeat(1) {
        val n = readInt()
        val solver = { i: Int, j: Int ->
            out.println("$i $j")
            out.flush()
            read()
        }
        solve(n, solver)
    }

}

//4 5 7 8 2 6 3 1

fun solve(n: Int, ask: (Int, Int) -> String) {
    var s = "neWin"
    var cnt = 0
    var last = n
    while (s != "WIN") {
        var i = 1
        var start = 1
        while (i in 0 until n) {
            for (j in start until n - i) {
                s = ask(j, j + 1)
                cnt++
                if (s == "WIN")
                    return
                if (cnt >= 10_000)
                    System.exit(-1)
                while (cnt % (2 * n) == 0) {
                    last = -1
                    if (cnt >= 10_000)
                        System.exit(-1)
                    for (k in n - i until n) {
                        s = ask(k, k + 1)
                        if (s == "WIN")
                            return
                        cnt++
                        if (s == "SWAPPED") {
                            last = k
                        }
                    }
                    for (k in n - 1 downTo 2) {
                        s = ask(k - 1, k)
                        if (s == "WIN")
                            return
                        cnt++
                        start++
                    }
                    if (last == -1)
                        continue
                    for (k in last downTo 2) {
                        s = ask(k - 1, k)
                        if (s == "WIN")
                            return
                        cnt++
                        start++
                    }
                    for (k in 1 until last) {
                        s = ask(k, k + 1)
                        if (s == "WIN")
                            return
                        cnt++
                    }
                    i++
                }
            }
            i++
        }
    }
}

val random = Random(System.currentTimeMillis() * 63)

data class IntPair(var x: Int, var y: Int) : Comparable<IntPair> {
    override fun compareTo(other: IntPair): Int {
        if (x != other.x)
            return x.compareTo(other.x)
        return y.compareTo(other.y)
    }
}

fun readInts(n: Int): IntArray = IntArray(n) {
    readInt()
}

class IntList(private val initialCap: Int = 16) {
    var a = IntArray(initialCap)
    var size = 0

    operator fun get(i: Int) = a[i]
    operator fun set(i: Int, x: Int) {
        a[i] = x
    }

    fun resize(newSize: Int) {
        size = newSize
        a = Arrays.copyOf(a, newSize)
    }

    fun add(x: Int) {
        if (size == a.size) {
            a = a.copyOf(size shl 1)
        }
        a[size++] = x
    }

    inline fun forEach(f: (it: Int) -> Unit) {
        for (i in 0 until size) f(a[i])
    }

    fun getArray(): IntArray {
        a = a.copyOf(size)
        return a
    }
}

private fun IntArray.println(out: PrintWriter) {
    this.forEach { out.print("$it ") }
    out.println()
}

operator fun Int.get(i: Int) = (this and (1 shl i)) != 0

data class Tripl(var a: Int, var b: Int, var c: Int)

operator fun Int.times(s: String) = s.repeat(this)
operator fun String.times(x: Int) = this.repeat(x)

fun main() {
    //var time = System.currentTimeMillis()
    solve()
    out.close()
}

val ONLINE_JUDGE = File("$INPUT_JUDGE.in").exists()
val LOCAL_TEST = File("$INPUT_FILE_NAME.in").exists()

var br = when {
    ONLINE_JUDGE -> BufferedReader(InputStreamReader(FileInputStream("$INPUT_JUDGE.in")))
    LOCAL_TEST -> BufferedReader(InputStreamReader(FileInputStream("$INPUT_FILE_NAME.in")))
    else -> BufferedReader(InputStreamReader(System.`in`))
}

var out = if (ONLINE_JUDGE)
    PrintWriter("$INPUT_JUDGE.out")
else
    PrintWriter(System.out)

var tok = StringTokenizer(" ")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = read().toInt()