#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define len(x) int(x.size())

typedef long long ll;
namespace std {
    template<>
    struct hash<std::pair<int, int>> {
        inline size_t operator()(const std::pair<int, int>& v) const {
            std::hash<int> int_hasher;
            return int_hasher(v.first) ^ int_hasher(v.second);
        }
    };
}

const int N = 1e5 + 10;

unordered_set<pair<int, int>> g[N], rg[N];
vector <int> deg, rdeg;
vector <pair<pair<int, int>, int>> edges;

unordered_map<int, int> num;

int compress(vector<int> &vertexes) {
    sort(all(vertexes));
    int cur_num = 1;
    for (int i = 0; i < len(vertexes); i++) {
        if (num[vertexes[i]] == 0) {
            num[vertexes[i]] = cur_num++;
        }
    }
    return (cur_num);
}

vector <pair<int, int>> path;
int edges_count = 0;
int last_vert = 0;

void find_path(int v) {
    last_vert = v;
    while (!g[v].empty()) {
        int x = g[v].begin()->first;
        int ind = g[v].begin()->second;
        g[v].erase({x, ind});
        edges_count++;
        path.push_back({v, ind});
        find_path(x);
    }
}

int main() {
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#endif  // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, v;
    cin >> n >> v;
    v--;
    vector <int> vertexes;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        vertexes.push_back(a);
        vertexes.push_back(b);
        edges.push_back({{a, b}, c});
    }
    int m = compress(vertexes);
    deg.resize(m, 0);
    rdeg.resize(m, 0);
    int true_edges_count = 0;
    for (int i = 0; i < n; i++) {
        edges[i].first.first = num[edges[i].first.first];
        edges[i].first.second = num[edges[i].first.second];
        int x = edges[i].first.first;
        int y = edges[i].first.second;
        if (edges[i].second == 1) {
            true_edges_count++;
            g[x].insert({y, i});
            deg[x]++;
            rdeg[y]++;
        } else {
            rg[x].insert({y, i});
        }
    }
    int start = -1;
    int finish = 0;
    int count = 0;
    for (int i = 1; i < m; i++) {
        if (deg[i] != rdeg[i]) {
            count++;
            if (start == -1 && deg[i] - 1 == rdeg[i]) {
                start = i;
            } else if (rdeg[i] - 1 == deg[i]){
                finish = i;
            }
        }
    }
    v = num[v];
    vector <int> ans;
    for (int i = 0; i < n; i++) {
        if (edges[i].second == 0 && edges[i].first.first != v) {
            ans.push_back(i);
        }
    }
    if (len(ans) == n) {
        cout << "Yes\n";
        for (auto i : ans) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    if (start == -1) {
        cout << "No";
        return 0;
    }
    if (count != 0 && count != 2) {
        cout << "No";
        return 0;
    }
    find_path(start);
#ifdef HOME
    cout << start << ' ' << finish << "\n";
    cout << "path : ";
    for (auto i : path) {
        cout << i.first << ' ';
    }
    cout << "\n";
#endif // HOME
    if (count == 0 || last_vert != finish) {
        cout << "No";
        return 0;
    }
    if (true_edges_count != edges_count) {
        cout << "No";
        return 0;
    }
    if (v != start) {
        cout << "No";
        return 0;
    }
    int ind = 0;
    int nw_vert = v;
    while (true) {
        int cur_edge_num = path[ind].second;
        if (edges[cur_edge_num].first.second == v) {
            ans.push_back(cur_edge_num);
            ind++;
        } else {
            nw_vert = edges[cur_edge_num].first.second;
            ans.push_back(cur_edge_num);
            ind++;
            break;
        }
    }
    if (nw_vert == v) {
        bool found = (len(rg[v]) != 0);
        if (found) {
            cout << "No";
            return 0;
        }
    }
    for (auto i : rg[v]) {
        ans.push_back(i.second);
    }
    for (int i = ind; i < len(path); i++) {
        ans.push_back(path[i].second);
    }
    cout << "Yes\n";
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
    return 0;
}