import java.io.*
import java.util.*
import kotlin.math.sqrt

const val INPUT_FILE_NAME = "test"

const val INPUT_JUDGE = ""

fun res(s: Int): IntPair? {
    for (x in 0 until s) {
        val y = s - x
        val q = sqrt(y.toDouble()).toInt()
        val qx = sqrt(x.toDouble()).toInt()
        if (q * q == y && qx * qx == x) {
            return IntPair(sqrt(x.toDouble()).toInt(), sqrt(y.toDouble()).toInt())
        }
    }
    return null
}

fun solve() {
    val s = readInt()
    val result = res(s)
    if (result == null) {
        out.println("Impossible")
    } else {
        out.println("${result.x} 0")
        out.println("0 ${result.y}")
        out.println("${result.x + result.y} ${result.x}")
        out.println("${result.y} ${result.x + result.y}")
    }
}

val random = Random(System.currentTimeMillis() * 63)

data class IntPair(var x: Int, var y: Int) : Comparable<IntPair> {
    override fun compareTo(other: IntPair): Int {
        if (x != other.x)
            return x.compareTo(other.x)
        return y.compareTo(other.y)
    }
}

fun readInts(n: Int): IntArray = IntArray(n) {
    readInt()
}

class IntList(private val initialCap: Int = 16) {
    var a = IntArray(initialCap)
    var size = 0

    operator fun get(i: Int) = a[i]
    operator fun set(i: Int, x: Int) {
        a[i] = x
    }

    fun resize(newSize: Int) {
        size = newSize
        a = Arrays.copyOf(a, newSize)
    }

    fun add(x: Int) {
        if (size == a.size) {
            a = a.copyOf(size shl 1)
        }
        a[size++] = x
    }

    inline fun forEach(f: (it: Int) -> Unit) {
        for (i in 0 until size) f(a[i])
    }

    fun getArray(): IntArray {
        a = a.copyOf(size)
        return a
    }
}

private fun IntArray.println(out: PrintWriter) {
    this.forEach { out.print("$it ") }
    out.println()
}

operator fun Int.get(i: Int) = (this and (1 shl i)) != 0

data class Tripl(var a: Int, var b: Int, var c: Int)

operator fun Int.times(s: String) = s.repeat(this)
operator fun String.times(x: Int) = this.repeat(x)

fun main() {
    //var time = System.currentTimeMillis()
    solve()
    out.close()
}

val ONLINE_JUDGE = File("$INPUT_JUDGE.in").exists()
val LOCAL_TEST = File("$INPUT_FILE_NAME.in").exists()

var br = when {
    ONLINE_JUDGE -> BufferedReader(InputStreamReader(FileInputStream("$INPUT_JUDGE.in")))
    LOCAL_TEST -> BufferedReader(InputStreamReader(FileInputStream("$INPUT_FILE_NAME.in")))
    else -> BufferedReader(InputStreamReader(System.`in`))
}

var out = if (ONLINE_JUDGE)
    PrintWriter("$INPUT_JUDGE.out")
else
    PrintWriter(System.out)

var tok = StringTokenizer(" ")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = read().toInt()