#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 3100;
const double EPS = 1e-8;

vector <ll> a, diff, diffsq, diffsq_prefix;
double trend[MAXN][MAXN];

double get_average(int l, int r) {
	double len = r - l;
	double average = (a[r] - a[l]) / len;
	return average;
}

ll get_diffsq_sum(int l, int r) {
	return diffsq_prefix[r] - diffsq_prefix[l];
}

/*double deviationsq_of_three(ll c0, ll c1, ll c2) {
	double d1 = c1 - c0, d2 = c2 - c1;
	double three_average = double(c0 + c1 + c2) / 3;
	double divisible = (d1 - three_average) * (d1 - three_average) +
						(d2 - three_average) * (d2 - three_average);
	return divisible / 2;
}*/

double get_deviationsq(int l, int r) {
	double len = r - l;
	double average = get_average(l, r);
	double s1 = get_diffsq_sum(l, r);
	double s2 = -2 * average * (a[r] - a[l]);
	double s3 = average * average * len;
	double res = (s1 + s2 + s3) / len;
	return res;
}

int main() {
	#ifdef HOME
		freopen("input.txt", "rt", stdin);
	#endif
	int n;
	double p;
	cin >> n >> p;
	a.resize(n);
	diff.resize(n - 1);
	diffsq.resize(n - 1);
	diffsq_prefix.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	// diff[0] = first difference
	for (int i = 0; i < n - 1; i++) {
		diff[i] = a[i + 1] - a[i];
		diffsq[i] = diff[i] * diff[i];
	}
	diffsq_prefix[0] = 0;
	for (int i = 1; i < n; i++) {
		diffsq_prefix[i] = diffsq_prefix[i - 1] + diffsq[i - 1];
	}
	int positive = 0, negative = 0;
	for (int l = 0; l < n; l++) {
		for (int r = l + 2; r < n; r++) {
			double deviationsq = get_deviationsq(l, r);
			double deviation = sqrt(deviationsq);
			double average = get_average(l, r);
			if (fabs(average) < EPS) {
				continue;
			}
			double value = average / deviation;
			if (value - p >= EPS) {
				positive++;
			} else if (value + p <= -EPS) {
				negative++;
			}
		}
	}
	cout << positive << ' ' << negative;
	return 0;
}
