#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <iterator>
#include <iomanip>
#include <map>
#include <stack>
#include <cctype>
#include <queue>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<ll>> cs;

ll binomialCoeff(int n, int k)
{
	// Base Cases
	if (k > n)
		return 0;
	if (k == 0 || k == n)
		return 1;

	// Recur
	return binomialCoeff(n - 1, k - 1)
		+ binomialCoeff(n - 1, k);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, k;
	cin >> n >> k;

	cs.resize(2 * n + 1, vector<ll>(2 * k + 1, 0));
	forn(i, 2 * n + 1) {
		forn(j, 2 * k + 1) {
			if (j == 0 || i == j) {
				cs[i][j] = 1;
			}
		}
	}

	for(int i = 1; i < 2 * n + 1; ++i) for(int j = 1; j < 2 * k + 1; ++j) {
		cs[i][j] = cs[i - 1][j - 1] + cs[i - 1][j];
	}



	long long ans = 0;
	for(int i = 0; i <= min(k, n); ++i) {
		if (k - i <= n) {
			ll all = cs[n][i];
			ll p = cs[n / 2][i / 2];
			if (n % 2 == 0 && i % 2 == 1) {
				p = 0;
			}
			ll w = all - p;
			ll curr = w / 2 + p;
			if (i == k / 2 && k % 2 == 0) {
				curr *= 2;
			}
			ans += curr;
		}
	}
	cout << ans;
//	cout << endl << cs[10][6];

	return 0;
}