#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using ii = pair<int, int>;
using vii = vector<ii>;

map<int, vi> gr;
map<int, int> out;
map<int, int> in;
set<int> nodes;
list<int> path;

void dfs(int at) {
    while (out[at] != 0) {
      int next = gr[at][--out[at]];
      dfs(next);
    }
    path.push_front(at);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, c; cin >> n >> c;
    map<ii, vi> edge_to_num;
    map<ii, vi> uns_edge_to_num;
    map<int, vector<ii>> non_used_edges;
    int ec = 0;
    for (int i = 0; i < n; i++) {
        int a, b, w; cin >> a >> b >> w;

        if (w == 1) {
           edge_to_num[{a, b}].push_back(i + 1);
           gr[a].push_back(b);
           ++in[b]; ++out[a];
           nodes.insert(a);
           nodes.insert(b);
           ec++;
        }
        else {
            uns_edge_to_num[{a, b}].push_back(i + 1);
            non_used_edges[a].push_back({a, b});
        }
    }

    int start_node = 0;
    int start_nodes = 0, end_nodes = 0;
    bool can = true;
    if (ec == 0) can = false;
    for (auto node : nodes) {
        int diffoi = out[node] - in[node];
        int diffio = in[node] - out[node];
        if (abs(diffoi) > 1 || abs(diffio) > 1) {
            can = false;
            break;
        }
        else if (diffoi - diffio == 1) {
            start_nodes++;
            start_node = node;
        }
        else if (diffio - diffoi == 1) {
            end_nodes++;
        }
    }

    if (can) {
        if ((start_nodes == 0 && end_nodes == 0) || (start_nodes == 1 && end_nodes == 1 && start_node == c)) {
            can = true;
        }
        else{
            can = false;
        }
    }

    if (!can) {
        cout << "No" << endl;
    }
    else {
        dfs(c);
        if (path.size() != ec + 1) {
            cout << "No" << endl;
        }
        else {
            vector<ii> final_edges;
            int prev = -1;
            for (auto q : path) {
                if (prev == -1) prev = q;
                else {
                        final_edges.push_back({prev, q});
                        prev = q;
                }
            }
            vector<int> ans;
            int considered = -1;
            for (auto edge : final_edges) {
                //cout << edge.first << " " << edge.second << endl;
                if (considered == -1) {
                    considered = edge.first;
                    for (auto kvp : non_used_edges) {
                        if (kvp.first != considered) {
                            for (auto el : kvp.second) {
                                ans.push_back(uns_edge_to_num[el].back());
                                uns_edge_to_num[el].pop_back();
                            }
                        }
                    }
                }
                else if (considered != -2 && considered != edge.first){
                    for (auto el : non_used_edges[considered]) {
                        ans.push_back(uns_edge_to_num[el].back());
                        uns_edge_to_num[el].pop_back();
                    }
                    considered = -2;
                }
                ans.push_back(edge_to_num[edge].back());
                edge_to_num[edge].pop_back();
            }

            if (ans.size() != n) {
                cout << "No" << endl;
            }
            else {
                cout << "Yes" << endl;
                for (auto el : ans) cout << el << " ";
                cout << endl;
            }
        }
    }

}
