#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using ii = pair<int, int>;
using vii = vector<ii>;

map<int, vi> gr;
map<int, int> out;
map<int, int> in;
set<int> nodes;
list<int> path;

void dfs(int at) {
    while (out[at] != 0) {
        int next = gr[at][--out[at]];
        dfs(next);
    }
    path.push_front(at);
}

vector<ii> getedges() {
    vector<ii> final_edges;
    int prev = -1;
    for (auto q : path) {
        if (prev == -1) prev = q;
        else {
            final_edges.push_back({ prev, q });
            prev = q;
        }
    }
    return final_edges;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, c; cin >> n >> c;

    map<ii, vi> edge_to_num;
    map<ii, vi> uns_edge_to_num;
    vector<ii> non_used_edges;
    set<int> nodes;
    int ec = 0;
    for (int i = 0; i < n; i++) {
        int a, b, w; cin >> a >> b >> w;
        if (w == 1) {
            edge_to_num[{a, b}].push_back(i + 1);
            gr[a].push_back(b);
            ++out[a]; ++in[b];
            ec++;
            nodes.insert(a);
            nodes.insert(b);
        }
        else {
            uns_edge_to_num[{a, b}].push_back(i + 1);
            non_used_edges.push_back({ a, b });
        }
    }

    int start_node = 0;
    int start_nodes = 0, end_nodes = 0;
    bool can = true;
    for (auto node : nodes) {
        int diffoi = out[node] - in[node];
        int diffio = in[node] - out[node];
        if (abs(diffoi) > 1) {
            can = false;
            break;
        }
        else if (diffoi - diffio == 1) {
            start_nodes++;
            start_node = node;
        }
        else if (diffio - diffoi == 1) {
            end_nodes++;
        }
    }

    if (can) {
        if ((start_nodes == 0 && end_nodes == 0) || (start_nodes == 1 && end_nodes == 1 && start_node == c)) {
            can = true;
        }
        else {
            can = false;
        }
    }

    if (!can) {
        cout << "No" << endl;
        return 0;
    }

    dfs(c);

    if (path.size() != ec + 1) {
        cout << "No" << endl;
        return 0;
    }

    vector<ii> final_edges = getedges();
    vector<int> ans;
    for (auto non_used_edge : non_used_edges) {
        if (non_used_edge.first != c) {
            ans.push_back(uns_edge_to_num[non_used_edge].back());
            uns_edge_to_num[non_used_edge].pop_back();
        }
    }
    int considered = 1;
    for (auto edge : final_edges) {
        if (considered == 1 && c != edge.first) {
            for (auto non_used_edge : non_used_edges) {
                if (non_used_edge.first == c) {
                    ans.push_back(uns_edge_to_num[non_used_edge].back());
                    uns_edge_to_num[non_used_edge].pop_back();
                }
            }
            considered = 0;
        }

        ans.push_back(edge_to_num[edge].back());
        edge_to_num[edge].pop_back();
    }

    if (ans.size() != n) {
        cout << "No" << endl;
    }
    else {
        cout << "Yes" << endl;
        for (auto el : ans) cout << el << " ";
        cout << endl;
    }



}
