#include <bits/stdc++.h>

using namespace std;
#ifdef MIA
#define __int128 long long
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif
typedef long long ll;

#define multitest false

void solve();

int main() {
#ifdef MIA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    if (multitest) cin >> t;
    for (int it = 1; it <= t; ++it) solve();
    return 0;
}

// CONSTANTS HERE

vector<set<pair<int, int>>> G;
vector<int> in, out;

struct edge {
    int a, b, num;
};

void dfs(int v, vector<int>& used) {
    used[v] = 1;
    for (auto& i : G[v]) {
        if (!used[i.first]) {
            dfs(i.first, used);
        }
    }
}

void getPath(int v, pair<int, int> edge, vector<pair<int, int>>& ans) {
    while (!G[v].empty()) {
        auto e = *G[v].begin();
        G[v].erase(G[v].begin());
        getPath(e.first, e, ans);
    }
    ans.push_back(edge);
}

void solve() {
    int n, c;
    cin >> n >> c;
    vector<int> sz;
    sz.push_back(c);
    vector<edge> edges;
    set<pair<int, int>> notE;
    for (int i = 0; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        if (w) {
            edges.push_back({a, b, i});
        } else {
            notE.insert({a, i});
        }
        sz.push_back(a);
        sz.push_back(b);
    }
    sort(sz.begin(), sz.end());
    sz.resize(unique(sz.begin(), sz.end()) - sz.begin());
    G.resize(sz.size());
    in.resize(sz.size());
    out.resize(sz.size());
    set<int> V;
    {
        c = lower_bound(sz.begin(), sz.end(), c) - sz.begin();
        for (auto& i : edges) {
            i.a = lower_bound(sz.begin(), sz.end(), i.a) - sz.begin();
            i.b = lower_bound(sz.begin(), sz.end(), i.b) - sz.begin();
            G[i.a].insert({i.b, i.num});
            V.insert(i.a);
            V.insert(i.b);
            out[i.a]++, in[i.b]++;
        }
        set<pair<int, int>> newE;
        for (auto& i : notE) {
            newE.insert({lower_bound(sz.begin(), sz.end(), i.first) - sz.begin(), i.second});
        }
        notE = newE;
    }
    n = sz.size();
    int ok = 1, cntEnds = 0;
    for (int i : V) {
        if (abs(out[i] - in[i]) > 1) {
            ok = 0;
            break;
        }
        if (out[i] - in[i] == 1) {
            if (i != c) {
                ok = 0;
                break;
            }
        } else if (in[i] - out[i] == 1) {
            if (++cntEnds > 1) {
                ok = 0;
                break;
            }
        }
    }
    vector<int> used(n, 0);
    dfs(c, used);
    if (count(used.begin(), used.end(), 1) != V.size()) {
        ok = 0;
    }
    if (!ok) {
        cout << "No\n";
        return;
    }
    vector<pair<int, int>> euler;
    getPath(c, {-1, -1}, euler);
    reverse(euler.begin(), euler.end());
    int lastc = -1;
    vector<int> ans;
    for (auto& i : euler) {
        if (i.first != -1) {
            lastc = c;
            c = i.first;
            ans.push_back(i.second);
        }
        if (c != lastc) {
            vector<pair<int, int>> rem;
            for (auto& e : notE) {
                if (e.first != c) {
                    ans.push_back(e.second);
                    rem.push_back(e);
                }
            }
            for (auto& e : rem) notE.erase(e);
        }
    }
    if (!notE.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (int& i : ans) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}