#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 2010;
const ll INF = 5e18 + 3;
const ld EPS = 1e-9, PI = acos(-1);
const int MOD = 1e9 + 7, INFI = 2e9 + 7;
const ull A = 1000, P = 1e9 + 9;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}

inline void operator delete (void * ) {}

int n, c;
unordered_map<int, vector<int> > g;
unordered_map<int, int> sta;
unordered_map<int, unordered_map<int, vector<int> > > g1;
vector<pair<int, int> > p;
vector<int> bad, st, ans, anss;

void dfs(int v) {
    int &i = sta[v];
    vector<int> &gg = g[v];
    while (i < gg.size()) {
        int to = gg[i];
        i++;
        dfs(to);
    }
    st.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> c;
    for (int i = 0; i < n; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        p.emplace_back(a, b);
        if (w) {
            sta[a] = 0;
            g[a].push_back(b);
            g1[a][b].push_back(i);
        } else {
            bad.push_back(i);
        }
    }
    dfs(c);
    for (int i = st.size() - 1; i > 0; i--) {
        if (g1[st[i]][st[i - 1]].empty()) {
            cout << "No" << endl;
            return 0;
        }
        ans.push_back(g1[st[i]][st[i - 1]].back());
        g1[st[i]][st[i - 1]].pop_back();
    }
    for (auto i : bad) {
        if (p[i].first != c) {
            anss.push_back(i + 1);
        }
    }
    bool f = 0;
    for (auto i : ans) {
        anss.push_back(i + 1);
        if (p[i].second != c && !f) {
            f = 1;
            for (auto j : bad) {
                if (p[j].first == c) {
                    anss.push_back(j + 1);
                }
            }
        }
    }
    if (anss.size() == n) {
        cout << "Yes" << endl;
        for (auto i : anss) {
            cout << i << ' ';
        }
        cout << endl;
    } else {
        cout << "No" << endl;
    }

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}