#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 2010;
const ll INF = 5e18 + 3;
const ld EPS = 1e-9, PI = acos(-1);
const int MOD = 1e9 + 7, INFI = 2e9 + 7;
const ull A = 1000, P = 1e9 + 9;

void get_ans(vector<int> &a, vector<int> &c, int k) {
    vector<int> b(a.size());
    b[0] = k;
    int p = 0;
    for (int q = 0; q < a.size() - 1; q++) {
        b[a[p] - 1] = (k + q) % a.size() + 1;
        p = a[p] - 1;
    }
    vector<int> d;
    for (int i = 0; i < a.size(); i++) {
        if (b[i] == 1 || b[i] == 2) {
            d.push_back(i);
        }
    }
    if (c == d) {
        cout << "! ";
        for (auto i : b) {
            cout << i << ' ';
        }
        cout << endl;
        exit(0);
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    cout << "? ";
    for (int i = 2; i <= n; i++) {
        cout << i << ' ';
    }
    cout << 1 << endl;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << "? 2 1 ";
    for (int i = 3; i <= n; i++) {
        cout << i << ' ';
    }
    cout << endl;
    vector<int> c;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x != i + 1) {
            c.push_back(i);
        }
    }

    for (int k = 1; k <= n; k++) {
        get_ans(a, c, k);
    }

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}