import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;

public class TaskE {
    static HashMap<Long, ArrayList<Edge>> map;
    static HashMap<Long, ArrayList<Integer>> toSolve;
    static int count = 0;
    static boolean ended = false;
    static ArrayList<Integer> answer = new ArrayList<>();

    static class Edge {
        boolean marked;
        long to;
        int order;

        public Edge(long to, int order) {
            this.to = to;
            this.order = order;
            marked = false;
        }
    }

    static void findPath(long current, int order) {
        ArrayList<Edge> edges = map.getOrDefault(current, new ArrayList<>());
        if (order != -1) {
            System.out.println(order);
        }
        for (HashMap.Entry<Long, ArrayList<Integer>> entry : toSolve.entrySet()) {
            if (entry.getKey() != current) {
                if(entry.getValue() == null) {
                    continue;
                }
                answer.addAll(entry.getValue());
            }
        }
        ArrayList<Integer> res = toSolve.get(current);
        toSolve = new HashMap<>();
        toSolve.put(current, res);
        if (edges.size() > 0) {
            Edge last = edges.get(edges.size() - 1);
            long to = last.to;
            int ord = last.order;
            count--;
            answer.add(ord);
            edges.remove(edges.size() - 1);
            findPath(to, order);
        } else if (count > 0) {
            ended = true;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String[] line = reader.readLine().split(" ");
        int n = Integer.parseInt(line[0]);
        long v = Long.parseLong(line[1]);
        map = new HashMap<>();
        toSolve = new HashMap<>();
        for (int i = 0; i < n; i++) {
            line = reader.readLine().split(" ");
            long a = Long.parseLong(line[0]);
            long b = Long.parseLong(line[1]);
            int c = Integer.parseInt(line[2]);
            if (c == 0) {
                ArrayList<Integer> valuesIn = toSolve.getOrDefault(a, new ArrayList<>());
                valuesIn.add((i + 1));
                toSolve.put(a, valuesIn);
            } else {
                ArrayList<Edge> edges = map.getOrDefault(a, new ArrayList<>());
                edges.add(new Edge(b, (i + 1)));
                map.put(a, edges);
                count++;
            }
        }
        findPath(v, -1);
        if (ended) {
            System.out.println("No");
            return;
        } else {
            System.out.println("Yes");
        }
        for (Integer ans : answer) {
            System.out.print(ans + " ");
        }
    }
}
