// #pragma GCC optimize("O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
const int mod = 1e9 + 7;
const ld EPS = 1e-9;

ll pw(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

enum TYPE {
	OPEN,
	CLOSE,
	NOT,
	AND,
	OR,
	NONE
};

struct SHIT {
	char ch;
	TYPE tp;
};

vector<int> getMasks(const string& s) {
	vector<SHIT> a;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '(') {
			a.push_back({ 0, OPEN });
		}
		else if (s[i] == ')') {
			a.push_back({ 0, CLOSE });
		}
		else if (s[i] == 'n') {
			a.push_back({ 0, NOT });
			i += 2;
		}
		else if (s[i] == 'o') {
			a.push_back({ 0, OR });
			i += 1;
		}
		else if (s[i] == 'a' && i + 1 < s.size() && s[i + 1] == 'n') {
			a.push_back({ 0, AND });
			i += 2;
		}
		else if (isalpha(s[i])) {
			a.push_back({ s[i], NONE });
		}
	}
	for (int i = 0; i < a.size(); i++) {
		if (a[i].tp == AND) {
			int l = i - 1;
			if (a[l].tp == CLOSE) {
				int b = -1;
				while (b != 0) {
					l--;
					if (a[l].tp == CLOSE) {
						b--;
					}
					if (a[l].tp == OPEN) {
						b++;
					}
				}
			}

			int r = i + 1;
			if (a[r].tp == OPEN) {
				int b = 1;
				while (b != 0) {
					r++;
					if (a[r].tp == CLOSE) {
						b--;
					}
					if (a[r].tp == OPEN) {
						b++;
					}
				}
			}

			a.insert(a.begin() + r + 1, { 0, CLOSE });
			a.insert(a.begin() + l, { 0, OPEN });
			i++;

		}
	}
	vector<int> ret;
	for (int m = 0; m < (1 << 8); m++) {
		vector<SHIT> st;
		for (auto x : a) {
			if (x.tp == NONE) {
				char val = (char)(m >> (x.ch - 'a') & 1);
				st.push_back({ val, NONE });
			}
			else if (x.tp == CLOSE) {
				auto y = st.back();
				st.pop_back();
				st.pop_back();
				st.push_back(y);
			}
			else {
				st.push_back(x);
			}
			while (!st.empty() && st.back().tp == NONE) {
				auto rhs = st.back();
				st.pop_back();
				if (st.empty()) {
					st.push_back(rhs);
					break;
				}
				auto op = st.back();
				if (op.tp == OPEN) {
					st.push_back(rhs);
					break;
				}
				if (op.tp == NOT) {
					st.pop_back();
					st.push_back({ !rhs.ch, NONE });
					continue;
				}
				if (op.tp == OR) {
					st.pop_back();
					auto lhs = st.back();
					st.pop_back();
					st.push_back({ lhs.ch || rhs.ch, NONE });
					continue;
				}
				if (op.tp == AND) {
					st.pop_back();
					auto lhs = st.back();
					st.pop_back();
					st.push_back({ lhs.ch && rhs.ch, NONE });
					continue;
				}
			}
		}
		if (st.back().ch == 1) {
			ret.push_back(m);
		}
	}
	return ret;
}


const int N = 8;
const int M = 1 << N;
const int K = 50;

int good[M];
char a[K][K];

void solve() {
    string s;
    getline(cin, s);
    vector<int> masks = getMasks(s);
    for (int mask : masks) {
        good[mask] = 1;
    } 
    for (int i = 0; i < K; i++) {
        fill(a[i], a[i] + K, ' '); 
    }
    vector<int> hui;
    for (int mask = 1; mask < M; mask++) {
        if (!good[mask]) {
            for (int sub = (mask - 1) & mask; sub > 0; sub = (sub - 1) & mask) {
                if (good[sub]) {
                    cout << "IMPOSSIBLE\n";
                    return;
                }
            }
            continue;
        }
        int ok = false;
        for (int i = 0; i < N; i++) {
            if (mask >> i & 1) {
                ok |= good[mask ^ (1 << i)];
            }
        }
        if (!ok) {
            hui.push_back(mask);
        }
    }
    sort(hui.rbegin(), hui.rend());
    int pos = 0;
    for (int it = 0; it < 4; it++) {
        int f = 9 * it;
        for (int i = 0; i < 49; i++) {
            if (i % 2 && pos < hui.size()) {
                for (int j = 0; j < 8; j++) {
                    if (hui[pos] >> j & 1) {
                        a[i][f + j] = char('a' + j);
                    }
                }
                pos++;
            } else {
                for (int j = 0; j < 8; j++) {
                    a[i][f + j] = '+';
                }
            }
        }
    }
    a[48][8] = '-';
    a[0][17] = '-';
    a[48][26] = '-';
    for (int i = 0; i < 49; i++) {
        for (int j = 0; j < 36; j++) {
            cout << a[i][j];
        }
        cout << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}