#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, w, h, s;
	cin >> n >> w >> h >> s;

	map<char, vector<int>> lets;
	for (int it = 0; it < n; it++)
	{
		char ch;
		cin >> ch;

		vector<string> grid(h);
		for (auto &row : grid)
			cin >> row;

		vector<int> cur(h);
		for (int i = 0; i < h; i++)
		{
			int cnt = 0;
			cnt += (grid[i].front() != '.');
			for (int j = 1; j < w; j++)
				cnt += (grid[i][j] != grid[i][j - 1]);
			cnt += (grid[i].back() != '.');

			cur[i] = cnt;
		}

		assert(!lets.count(ch));
		lets[ch] = cur;
	}

	int best = numeric_limits<int>::max();
	char when = -1;

	for (int i = 0; i < w; i++)
	{
		char best_let = -1;
		int cnt = -1;

		for (const auto &pr : lets)
		{
			if (cnt < pr.second[i])
			{
				cnt = pr.second[i];
				best_let = pr.first;
			}
		}

		assert(cnt > 0);
		const int len = ((s + cnt - 1) / cnt);
		if (best > len)
		{
			best = len;
			when = best_let;
		}
	}

	assert(when != -1);
	cout << string(best, when) << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
