#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

void norm (vector<int> &v)
{
	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());
}
int pos_at (const vector<int> &v, const int what)
{
	const int pos = lower_bound(v.begin(), v.end(), what) - v.begin();
	assert(pos < int(v.size()) && v[pos] == what);
	return pos;
}

struct edge
{
	int from, to, win, id;
};

const string yes = "Yes", no = "No";

void dfs (const int v, vector<vector<int>> &g, vector<int> &order)
{
	while (!g[v].empty())
	{
		const int cur = g[v].back();
		g[v].pop_back();
		dfs(cur, g, order);
	}
	order.push_back(v);
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, c;
	cin >> n >> c;

	vector<int> vals = {c};
	vector<edge> e(n);
	for (int i = 0; i < n; i++)
	{
		cin >> e[i].from >> e[i].to >> e[i].win;
		vals.push_back(e[i].from);
		vals.push_back(e[i].to);
		e[i].id = i;
	}

	norm(vals);
	c = pos_at(vals, c);
	for (auto &it : e)
	{
		it.from = pos_at(vals, it.from);
		it.to = pos_at(vals, it.to);
	}

	vector<vector<int>> lose_by_start(vals.size());
	int bad = 0;

	for (const auto &it : e)
		if (it.win == 0)
		{
			bad++;
			lose_by_start[it.from].push_back(it.id);
		}

	map<pair<int, int>, vector<int>> by_ends;
	vector<vector<int>> g(vals.size());

	for (const auto &it : e)
		if (it.win == 1)
		{
			by_ends[{it.from, it.to}].push_back(it.id);
			g[it.from].push_back(it.to);
		}

	vector<int> path;
	dfs(c, g, path);
	reverse(path.begin(), path.end());

//	for (int x : path)
//		cerr << x << ' ';
//	cerr << endl;

	vector<int> p;
	vector<bool> was_value(vals.size());

	for (int i = 0; i < int(path.size()); i++)
	{
		const int cur_value = path[i];
		if (!was_value[cur_value] && bad > 0)
		{
			for (int j = 0; j < int(lose_by_start.size()); j++)
				if (j != cur_value)
				{
					p.insert(p.end(), lose_by_start[j].begin(), lose_by_start[j].end());
					bad -= int(lose_by_start[j].size());
					assert(bad >= 0);
					lose_by_start[j].clear();
				}
		}
		was_value[cur_value] = true;

		if (i + 1 == int(path.size()))
			break;

		auto &cur = by_ends[{path[i], path[i + 1]}];
		if (!cur.empty())
		{
			p.push_back(cur.back());
			cur.pop_back();
		}
		else
			break;
	}

	if (int(p.size()) < int(e.size()))
	{
		cout << no << endl;
		return;
	}

	cout << yes << endl;
	for (int i = 0; i < int(p.size()); i++)
		cout << p[i] + 1 << " \n"[i + 1 == int(p.size())];
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
