#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

ll sqr (ll x)
{
	return x * x;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int days;
	cin >> days;
	ld p;
	cin >> p;

	vector<int> c(days);
	for (int i = 0; i < days; i++)
		cin >> c[i];

	vector<ll> pref(int(c.size()) + 1);
	for (int i = 0; i < int(c.size()); i++)
		pref[i + 1] = pref[i] + sqr(i == 0 ? 0 : c[i] - c[i - 1]);

	int pos = 0, neg = 0;

	for (int len = 2; len < int(c.size()); len++)
		for (int i = 0; i + len < int(c.size()); i++)
		{
			ll da = abs(c[i + len] - c[i]);
			ll s2 = pref[i + len + 1] - pref[i + 1];

			ll numer = da * da;
			ll denom = len * s2 - numer;

//			cerr << numer << ' ' << denom << endl;
//			cerr << i << ' ' << i + len << endl;

			assert(denom >= 0);
			if (denom == 0)
			{
				if (c[i + len] > c[i])
					pos++;
				if (c[i + len] < c[i])
					neg++;
			}
			else if (ld(numer) / denom > p * p)
			{
				if (c[i + len] > c[i])
					pos++;
				if (c[i + len] < c[i])
					neg++;
			}
		}

	cout << pos << ' ' << neg << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
