#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

const int let = 26;

template<class T>
using min_heap = priority_queue<T, vector<T>, greater<T>>;

bool bit (int mask, int i)
{
	return ((mask >> i) & 1);
}

struct trie
{
	const int max_depth;
	vector<array<int, 2>> next;
	vector<int> depth, cnt, is_input;

	int add_vertex (const int d)
	{
		next.emplace_back(array<int, 2>{-1, -1});
		depth.push_back(d);
		cnt.push_back(0);
		is_input.push_back(0);
		return int(next.size()) - 1;
	}

	void expand_vertex (const int v)
	{
		assert(depth[v] < max_depth);
		for (int i = 0; i < 2; i++)
			if (next[v][i] == -1)
			{
				const int cur = add_vertex(depth[v] + 1);
				next[v][i] = cur;
			}
	}

	trie (const int max_depth_) : max_depth(max_depth_)
	{
		add_vertex(0);
	}

	void add (const string &s)
	{
		int v = 0;

		for (int i = 0; i < int(s.size()); i++)
		{
			cnt[v]++;
			const int ch = int(s[i] - '0');
			expand_vertex(v);
			v = next[v][ch];
		}

		cnt[v]++;
		is_input[v] = 1;

		if (int(s.size()) < max_depth)
			expand_vertex(v);
	}

	void dfs (const int v, const int since_last, vector<int> &to_root, vector<int> &to_prev)
	{
		if (cnt[v] == 0)
		{
			if (since_last == depth[v] && !is_input[0])
			{
				for (int i = depth[v]; i <= max_depth; i++)
					to_root[i] += (1 << (i - depth[v]));
			}
			else
			{
				for (int i = depth[v]; i <= max_depth; i++)
					to_prev[since_last + (i - depth[v])] += (1 << (i - depth[v]));
			}
			return;
		}

		assert(depth[v] == max_depth || (next[v][0] != -1 && next[v][1] != -1));
		if (depth[v] == max_depth)
		{
			assert(is_input[v] == 1);
			return;
		}

		if (!is_input[v])
		{
			((since_last == depth[v] && !is_input[0]) ? to_root[since_last] : to_prev[since_last])++;
			for (int i = 0; i < 2; i++)
				dfs(next[v][i], since_last + 1, to_root, to_prev);
		}
		else
		{
			for (int i = 0; i < 2; i++)
				dfs(next[v][i], 1, to_root, to_prev);
		}
	}
};

ld solveused(int h)//среди 1-ых n
{
	ld val = 1.0;
	for (int i = 1; i < h; i++)
		val /= (2.0);
	return 1.0 - val;
}

ld solvefreewithoutroot(int h)//невзятая вершина, расст до корня =h, среди отцов нет из 1-ых n
{
	ld val = 1.0;
	for (int i = 1; i <= h; i++)
	{
		ld prob = 1.0 / (i * (i + 1));
		for (int j = 1; j < i; j++)
			prob /= 2.0;
		val -= prob;
	}
	return val;
}

ld solvefreefatheronlvl(int h)//невзятая вершина, расст до взятого из 1-ых n равно h
{
	ld val = 1.0;
	for (int i = 1; i < h; i++)
	{
		ld prob = 1.0 / (i * (i + 1));
		for (int j = 1; j < i; j++)
			prob /= 2.0;
		val -= prob;
	}
	ld pb = 1.0 / h;
	for (int i = 1; i < h; i++)
		pb /= 2.0;
	val -= pb;
	return val;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int k, n;
	cin >> k >> n;

	trie trie(k - 1);

	vector<pair<int, int>> input(n);
	set<int> was;
	vector<int> input_to_prev(k);

	int always = 0;
	for (int iter = 0; iter < n; iter++)
	{
		int s, m;
		cin >> s >> m;

		s = k - s, m--;
		input[iter] = {s, m};

		const int vertex = (1 << s) + m;
		int up = 0, cur = vertex;

		for (cur = vertex; cur > 0 && !was.count(cur); cur >>= 1)
			up++;
		if (cur != 0)
			input_to_prev[up]++;
		else
			always++;

		was.insert(vertex);

		string word;
		for (int i = s - 1; i >= 0; i--)
			word += (bit(m, i) ? '1' : '0');
		trie.add(word);
	}

	vector<int> to_root(k), to_prev(k);
	trie.dfs(0, 0, to_root, to_prev);

	assert(input_to_prev[0] == 0 && to_prev[0] == 0);


//	for (int i = 0; i < k; i++)
//		cerr << input_to_prev[i] << ' ' << to_root[i] << ' ' << to_prev[i] << endl;
//	cerr << endl;
//	exit(0);

	ld ans = always;
	for (int i = 0; i < k; i++)
	{
		ans += to_root[i] * solvefreewithoutroot(i);

		if (i > 0)
		{
			ans += to_prev[i] * solvefreefatheronlvl(i);
			ans += input_to_prev[i] * solveused(i);
		}
	}

	cout << fixed << setprecision(numeric_limits<ld>::digits10 + 1);
	cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
