#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


bool check(const string &formula, int l, int r, unsigned mask)
{
	while (l < r && formula[l] == ' ')
		l++;
	while (l < r && formula[r - 1] == ' ')
		r--;

	assert(l < r);

	if (l + 1 == r)
	{
		assert('a' <= formula[l] && formula[l] <= 'h');

		return (mask & (1u << unsigned(formula[l] - 'a'))) != 0;
	}

	for (int i = l, bal = 0; i < r; i++)
	{
		if (formula[i] == '(')
			bal++;
		if (formula[i] == ')')
			bal--;
		assert(bal >= 0);
		if (bal == 0 && formula.substr(i, 2) == "or")
			return check(formula, l, i, mask) || check(formula, i + 2, r, mask);
	}
	for (int i = l, bal = 0; i < r; i++)
	{
		if (formula[i] == '(')
			bal++;
		if (formula[i] == ')')
			bal--;
		assert(bal >= 0);
		if (bal == 0 && formula.substr(i, 3) == "and")
			return check(formula, l, i, mask) && check(formula, i + 3, r, mask);
	}

	if (formula.substr(l, 3) == "not")
		return !check(formula, l + 3, r, mask);

	assert(formula[l] == '(' && formula[r - 1] == ')');

	return check(formula, l + 1, r - 1, mask);
}


void draw_sep(vector<string> &ans, const vector<int> &sep, int x, int y)
{
	ans[y][x] = '|';
	if (sep.size() == 1)
	{
		ans[y + 1][x] = ans[y + 3][x] = '|';
		ans[y + 2][x] = char(sep.front() + 'a');

		return;
	}
	ans[y + 1][x] = ans[y + 3][x] = '+';

	for (int i = 0; i < sep.size(); i++)
	{
		if (i != 0)
		{ ans[y + 1][x + i * 2 - 1] = ans[y + 3][x + i * 2 - 1] = '-'; }
		ans[y + 1][x + i * 2] = ans[y + 3][x + i * 2] = '+';
		ans[y + 2][x + i * 2] = char(sep[i] + 'a');
	}
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	string formula;

	getline(cin, formula);

	array<bool, 1u << 8u> arr{};

	for (unsigned mask = 0; mask < arr.size(); mask++)
		arr[mask] = check(formula, 0, formula.size(), mask);

	for (unsigned mask = 0; mask < arr.size(); mask++)
		if (arr[mask])
			for (unsigned i = 0; i < 8; i++)
				if (!arr[mask | (1u << i)])
				{
					cout << "IMPOSSIBLE" << endl;

					return;
				}

	if (!arr.back())
	{
		cout << "+ +" << endl;

		return;
	}

	if (arr.front())
	{
		cout << "+-+" << endl;

		return;
	}

	vector<vector<int>> seps;

	for (unsigned mask = 0; mask < arr.size(); mask++)
	{
		bool ok = arr[mask];

		for (unsigned i = 0; ok && i < 8; i++)
			if (mask & (1u << i))
				ok &= !arr[mask & ~(1u << i)];

		if (ok)
		{
			seps.emplace_back();

			for (unsigned i = 0; i < 8; i++)
				if (mask & (1u << i))
					seps.back().push_back(i);
		}
	}

	assert(seps.size() <= 70);

	sort(seps.begin(), seps.end(), [](const auto &a, const auto &b)
	{
		return a.size() < b.size();
	});

	vector<string> ans(50, string(50, ' '));

	fill(ans.front().begin(), ans.front().end(), '+');
	fill(ans.back().begin(), ans.back().end(), '+');

	for (int pos = 0, x = 0; pos < seps.size(); pos += 12)
	{
		int sz = 0;

		for (int i = 0; i < 12 && pos + i < seps.size(); i++)
		{
			sz = max(sz, (int) seps[pos + i].size());
			draw_sep(ans, seps[pos + i], x, 1 + i * 4);
		}

		assert(sz > 0);

		auto vert = max(2, x + 2 * sz - 1);

		for (int i = 1; i + 1 < ans.size(); i++)
			ans[i][vert] = '|';
		ans.back()[vert + 1] = ' ';
		if (vert != 0)
			ans.front()[vert - 1] = ' ';

		if (seps.back().size() == 1)
		{
			int y = ans.size() - 2;
			while (ans[y][x] == ' ')
				ans[y--][x] = '|';
		}
		else
		{
			int y = ans.size() - 2;
			while (ans[y][x + 2] == ' ')
				ans[y--][x + 2] = '|';
		}

		x = vert + 1;
	}

	for (const auto &row : ans)
		cout << row << endl;
}


void gen(ostream &cout = std::cout)
{
	for (unsigned i = 0; i < (1u << 8u); i++)
		if (__builtin_popcount(i) == 4)
		{
			cout << '(';
			vector<int> q;

			for (unsigned j = 0; j < 8; j++)
				if (i & (1u << j))
					q.push_back(j);

			cout << char('a' + q.front());

			for (int k = 1; k < q.size(); k++)
				cout << " and " << char('a' + q[k]);
			cout << ") or";
		}
	cout << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	gen();

	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
