#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


bool check(const string &formula, int l, int r, unsigned mask)
{
	while (l < r && formula[l] == ' ')
		l++;
	while (l < r && formula[r - 1] == ' ')
		r--;

	assert(l < r);

	if (l + 1 == r)
	{
		assert('a' <= formula[l] && formula[l] <= 'h');

		return (mask & (1u << unsigned(formula[l] - 'a'))) != 0;
	}

	for (int i = l, bal = 0; i < r; i++)
	{
		if (formula[i] == '(')
			bal++;
		if (formula[i] == ')')
			bal--;
		assert(bal >= 0);
		if (bal == 0 && formula.substr(i, 2) == "or")
			return check(formula, l, i, mask) || check(formula, i + 2, r, mask);
	}
	for (int i = l, bal = 0; i < r; i++)
	{
		if (formula[i] == '(')
			bal++;
		if (formula[i] == ')')
			bal--;
		assert(bal >= 0);
		if (bal == 0 && formula.substr(i, 3) == "and")
			return check(formula, l, i, mask) && check(formula, i + 3, r, mask);
	}

	if (formula.substr(l, 3) == "not")
		return !check(formula, l + 3, r, mask);

	assert(formula[l] == '(' && formula[r - 1] == ')');

	return check(formula, l + 1, r - 1, mask);
}


void draw_sep(vector<string> &ans, const vector<int> &sep, int x, int y)
{
	if (sep.size() == 1)
	{
		ans[y][x] = '+';
		ans[y + 1][x] = char(sep.front() + 'a');

		return;
	}

	for (int i = 0; i < sep.size(); i++)
	{
		if (i != 0)
			ans[y][x + i * 2 - 1] = '+';
		ans[y][x + i * 2] = '+';
		ans[y + 1][x + i * 2] = char(sep[i] + 'a');
	}
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	string formula;

	getline(cin, formula);

//	if (formula == "a or (b and c)")
//	{
//		cout << "+-+ +b-+" << endl;
//		cout << "| | |  |" << endl;
//		cout << "+-a-+-c+" << endl;
//
//		return;
//	}

	vector<bool> arr(1u << 8u);

	for (unsigned mask = 0; mask < arr.size(); mask++)
		arr[mask] = check(formula, 0, formula.size(), mask);

	for (unsigned mask = 0; mask < arr.size(); mask++)
		if (arr[mask])
			for (unsigned i = 0; i < 8; i++)
				if (!arr[mask | (1u << i)])
				{
					cout << "IMPOSSIBLE" << endl;

					return;
				}

	if (!arr.back())
	{
		cout << "+ +" << endl;

		return;
	}

	if (arr.front())
	{
		cout << "+-+" << endl;

		return;
	}

	vector<vector<int>> seps;

	for (unsigned mask = 0; mask < arr.size(); mask++)
	{
		bool ok = arr[mask];

		for (unsigned i = 0; ok && i < 8; i++)
			if (mask & (1u << i))
				ok &= !arr[mask & ~(1u << i)];

		if (ok)
		{
			seps.emplace_back();

			for (unsigned i = 0; i < 8; i++)
				if (mask & (1u << i))
					seps.back().push_back(i);
		}
	}

	assert(!seps.empty());
	assert(seps.size() <= 70);

	if (seps.front().size() == 8)
	{
		cout << "+-+-+-+-+-+-+-+ +" << endl;
		cout << "a b c d e f g h |" << endl;
		cout << "+-+-+-+-+-+-+-+-+" << endl;

		return;
	}

	sort(seps.begin(), seps.end(), [](const auto &a, const auto &b)
	{
		return a.size() < b.size();
	});

	vector<string> ans(50, string(50, ' '));

	const int hor = 24;

	for (int pos = 0, x = 0; pos < seps.size(); pos += hor)
	{
		int sz = 0;

		for (int i = 0; i < hor && pos + i < seps.size(); i++)
		{
			sz = max(sz, (int) seps[pos + i].size());
			draw_sep(ans, seps[pos + i], x, i * 2);
		}

		int y = ans.size() - 2;

		while (ans[y][x] == ' ')
			y--;
		y++;

		for (int q = 0; q < 16; q++)
			ans[y][x + q] = '+';

		assert(sz > 0);

		auto vert = x + 15;

		for (int i = 0; i < y; i++)
			ans[i][vert] = '+';
		for (int i = vert; i <= vert + 2 && i < ans.size(); i++)
			ans.front()[i] = '+';

		x = vert + 2;
	}

	const int dx[] = {-1, 1, 0, 0}, dy[] = {0, 0, -1, 1};

	auto test = [&dx, &dy, &ans](int x, int y, int i)
	{
		return 0 <= y + dy[i] && y + dy[i] < ans.size() &&
		       0 <= x + dx[i] && x + dx[i] < ans.size() &&
		       ans[y + dy[i]][x + dx[i]] != ' ';
	};

	for (int y = 0; y < ans.size(); y++)
		for (int x = 0; x < ans.size(); x++)
			if (ans[y][x] == '+')
			{
				int cnt = 0;

				for (int i = 0; i < 4; i++)
					if (test(x, y, i))
						cnt++;

				if (cnt == 2 && test(x, y, 0) && test(x, y, 1))
					ans[y][x] = '-';
				if (cnt == 2 && test(x, y, 2) && test(x, y, 3))
					ans[y][x] = '|';
			}

	for (auto &row : ans)
		while (!row.empty() && row.back() == ' ')
			row.pop_back();
	while (ans.back().empty())
		ans.pop_back();

	for (const auto &row : ans)
		cout << row << endl;
}


void gen(ostream &cout = std::cout)
{
	for (unsigned i = 0; i < (1u << 8u); i++)
		if (__builtin_popcount(i) == 4)
		{
			cout << '(';
			vector<int> q;

			for (unsigned j = 0; j < 8; j++)
				if (i & (1u << j))
					q.push_back(j);

			cout << char('a' + q.front());

			for (int k = 1; k < q.size(); k++)
				cout << " and " << char('a' + q[k]);
			cout << ") or";
		}
	cout << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
