#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);


ll conn[256][27][27];
char gr[27][27];
string rules[101];

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int p;
	cin >> p;


	for (int i = 0; i < p; i++) {
        rules[i].clear();
		string rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		cin >> rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		if (sz(rule) > 1) rules[i].pb(rule[1]);
	}

	int n, m, s, t;
	cin >> n >> m >> s >> t;
	s--, t--;

	for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            gr[i][j] = ' ';
        }
    }
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		char ch;
		cin >> ch;
		gr[a][b] = ch;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			if (gr[i][j] != ' ') conn[gr[i][j]][i][j] = 1;
			for (auto rule : rules) if (sz(rule) == 2 && rule[1] == gr[i][j]) conn[rule[0]][i][j] = 1;
		}

	queue<pair<int, pair<int, int>>> que;
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				que.push(mp(k, mp(i, j)));
			}
		}
	}

	while (!que.empty()) {
		int k = que.front().first;
		int i = que.front().second.first;
		int j = que.front().second.second;
		que.pop();

		for (auto rule : rules) {
			if (sz(rule) == 3 && conn[rule[1]][i][k] > 0 && conn[rule[2]][k][j] > 0) {
				if (conn[rule[0]][i][j] == 0 || conn[rule[0]][i][j] > conn[rule[1]][i][k] + conn[rule[2]][k][j]) {
					conn[rule[0]][i][j] = conn[rule[1]][i][k] + conn[rule[2]][k][j];
					for (int a = 0; a < n; a++) {
						que.push(mp(j, mp(i, a)));
						que.push(mp(i, mp(a, j)));
					}
				}
			}
		}
	}

	if (conn['S'][s][t] == 0) cout << "NO" << endl;
	else cout << conn['S'][s][t] << endl;
}
