#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);

//typedef __int128 ll;
//typedef long double ld;
 
const ll T = 1e8, Q = 8, K = 10;
 
void printd(ll k)
{
    vector<int> a;
    for (int i = 0; i < Q; i++)
    {
        a.push_back(k % K);
        k /= K;
    }
    for (int i = Q - 1; i >= 0; i--)
        cout << a[i];
}
 
struct Integer
{
    int sgn;
    vector<ll> dig;
 
    Integer() 
    {
        sgn = 0;
        dig.clear();
    }
 
    void rem()
    {
        while (dig.size() && dig.back() == 0)
            dig.pop_back();
        if (!dig.size())
        {
            sgn = 0;
            return;
        }
        for (int i = 0; i + 1 < dig.size(); i++)
        {
            dig[i + 1] += dig[i] / T;
            dig[i] %= T;
        }
        while (dig.back() >= T)
        {
            int z = dig.size() - 1;
            dig.push_back(dig[z] / T);
            dig[z] %= T;
 
        }
    }
 
    Integer(ll p)
    {
        dig.clear();
        if (!p)
        {
            sgn = 0;
            return;
        }
        sgn = 1;
        if (p < 0)
        {
            sgn = -1;
            p = -p;
        }
        ll cur = 0;
        while (p)
        {
            ll nxt = cur * 10LL + (p % 10LL);
            if (nxt >= T)
            {
                dig.push_back(cur);
                cur = p % 10LL;
            }
            else
                cur = nxt;
            p /= 10;
        }
        dig.push_back(cur);
        (*this).rem();
    }

    /*Integer(const Integer& other) {
        sgn = other.sgn;
        dig = other.dig;
    }*/

    Integer& operator=(const Integer& other) = default;
/*        Integer kek(other);
        swap(kek, *this);
    }*/
 
    void print()
    {
        (*this).rem();
        if (sgn == 0)
        {
            cout << "0\n";
            return;
        }
        if (sgn == -1)
            cout << "-";
        cout << dig.back();
        for (int i = (int)dig.size() - 2; i >= 0; i--)
            printd(dig[i]);
        cout << '\n';
    }
 
    Integer operator*(const Integer &x) const
    {
        if (sgn == 0)
            return *this;
        if (x.sgn == 0)
            return x;
        Integer ans;
        ans.sgn = sgn * x.sgn;
        ans.dig.assign(dig.size() + x.dig.size(), 0);
        for (int i = 0; i < dig.size(); i++)
            for (int j = 0; j < x.dig.size(); j++)
                ans.dig[i + j] += dig[i] * x.dig[j];
        ans.rem();
        return ans;
    }
 
    bool operator==(const Integer &x) const
    {
        if (sgn == 0)
            return x.sgn == 0;
        return (sgn == x.sgn && x.dig == dig);
    }

    bool operator==(const ll &x) const
    {
        return (*this) == Integer(x);
    }
 
    bool operator!=(const Integer &x) const
    {
        if (sgn == 0 && x.sgn == 0)
            return 0;
        return (sgn != x.sgn || x.dig != dig);
    }
 
    bool operator>(const Integer &x) const
    {
        if (sgn != x.sgn)
            return sgn > x.sgn;
        if (sgn == 0)
            return 0;
        if (x.dig.size() != dig.size())
            return ((x.dig.size() < dig.size()) ^ (sgn == -1));
        for (int i = 0; i < dig.size(); i++)
            if (dig[i] != x.dig[i])
                return ((sgn == -1) ^ (dig[i] > x.dig[i]));
        return 0;
    }
 
    bool operator<(const Integer &x) const
    {
        if (sgn != x.sgn)
            return sgn < x.sgn;
        if (sgn == 0)
            return 0;
        if (x.dig.size() != dig.size())
            return ((x.dig.size() > dig.size()) ^ (sgn == -1));
        for (int i = 0; i < sz(dig); i++)
            if (dig[i] != x.dig[i])
                return ((sgn == -1) ^ (dig[i] < x.dig[i]));
        return 0;
    }
 
    bool operator>=(const Integer &x) const
    {
        return (*this) > x || (*this) == x;
        if (sgn != x.sgn)
            return sgn > x.sgn;
        if (sgn == 0)
            return 1;
        if (x.dig.size() != dig.size())
            return ((x.dig.size() < dig.size()) ^ (sgn == -1));
        for (int i = 0; i < sz(dig); i++)
            if (dig[i] != x.dig[i])
                return ((sgn == -1) ^ (dig[i] > x.dig[i]));
        return 1;
    }
 
    bool operator<=(const Integer &x) const
    {
        return (*this) < x || (*this) == x;
        if (sgn != x.sgn)
            return sgn < x.sgn;
        if (sgn == 0)
            return 1;
        if (x.dig.size() != dig.size())
            return ((x.dig.size() > dig.size()) ^ (sgn == -1));
        for (int i = 0; i < sz(dig); i++)
            if (dig[i] != x.dig[i])
                return ((sgn == -1) ^ (dig[i] < x.dig[i]));
        return 1;
    }
 
 
    Integer operator-() const
    {
        Integer ans = *this;
        ans.sgn = -ans.sgn;
        return ans;
    }
 
    
    Integer operator-(Integer x)
    {
        if (x.sgn == 0)
            return (*this);
        if (sgn == 0)
            return -x;
        if (sgn != x.sgn)
            return (*this) + (-x);
        if (sgn == -1)
            return (-x) - (-(*this));
        if (x == (*this))
        {
            Integer y = x;
            y.sgn = 0;
            y.dig.clear();
            return y;
        }
        Integer a = (*this), b = x;
        bool cmp = (a > b);
        if (!cmp)
            swap(a, b);
        Integer ans;
        while (a.dig.size() < b.dig.size())
            a.dig.push_back(0);
        while (a.dig.size() > b.dig.size())
            b.dig.push_back(0);
        ans.dig.assign(a.dig.size(), 0);
        for (int i = 0; i < a.dig.size(); i++)
            ans.dig[i] = a.dig[i] - b.dig[i];
        for (int i = (int)a.dig.size() - 1; i > 0; i--)
            while (ans.dig[i] < 0)
            {
                ans.dig[i] += T;
                ans.dig[i - 1]--;
            }
        ans.sgn = (cmp ? 1 : -1);
        ans.rem();
        return ans;
    }
 
 
    Integer operator+(Integer x)
    {
        if (sgn == 0)
            return x;
        if (x.sgn == 0)
            return *this;
        if (sgn != x.sgn)
        {
            return (*this) - (-x);
        }
        vector<ll> dig1 = dig;
        while (dig1.size() < x.dig.size())
            dig1.push_back(0);
        while (dig1.size() > x.dig.size())
            x.dig.push_back(0);
        Integer ans;
        ans.sgn = x.sgn;
        ans.dig.assign(dig1.size(), 0);
        for (int i = 0; i < dig1.size(); i++) {
            while (ans.dig.size() <= i + 1) {
                ans.dig.push_back(0);
            }
            ans.dig[i] = dig1[i] + x.dig[i];
        }
        ans.rem();
        return ans;
    }
 
};

struct myint {
    const ll T = 1e18;
    ll x, y;

    myint() {
        x = y = 0;
    }

    myint(ll z) {
        y = z;
        x = 0;
    }

    myint(ll x, ll y): x(x), y(y) {}

    myint operator+(myint z) {
        ll X = x + z.x;
        ll Y = y + z.y;
        X += Y / T;
        Y %= T;
        return myint(X, Y);
    }

    bool operator<(myint z) {
        return make_pair(x, y) < make_pair(z.x, z.y);
    }

    bool operator==(myint z) {
        return make_pair(x, y) == make_pair(z.x, z.y);
    }

    bool operator==(ll z) {
        return x == z / T && y == z % T;
    }

    bool operator==(int z) {
        return x == z / T && y == z % T;
    }

    void operator=(myint z) {
        x = z.x;
        y = z.y;
    }

    void print() {
        if (!x) {
            cout << y;
        } else {
            cout << x;
            vector<int> kek;
            ll a = y;
            for (int i = 0; i < 18; i++) {
                kek.push_back(a % 10);
                a /= 10;
            }
            reverse(kek.begin(), kek.end());
            for (int i : kek) {
                cout << i;
            }
        }
    }
};


Integer conn[256][27][27];
char gr[27][27];
string rules[101];

int xx[27][27][27];

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int p;
	cin >> p;


	for (int i = 0; i < p; i++) {
        rules[i].clear();
		string rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		cin >> rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		if (sz(rule) > 1) rules[i].pb(rule[1]);
	}

	int n, m, s, t;
	cin >> n >> m >> s >> t;
	s--, t--;

	for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            gr[i][j] = ' ';
        }
    }
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		char ch;
		cin >> ch;
		gr[a][b] = ch;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			if (gr[i][j] != ' ') conn[gr[i][j]][i][j] = Integer(1);
			for (auto rule : rules) if (sz(rule) == 2 && rule[1] == gr[i][j]) conn[rule[0]][i][j] = Integer(1);
		}

	queue<pair<int, pair<int, int>>> que;
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				que.push(mp(k, mp(i, j)));
                xx[k][i][j] = 1;
			}
		}
	}

	while (!que.empty()) {
		int k = que.front().first;
		int i = que.front().second.first;
		int j = que.front().second.second;
        xx[k][i][j] = 0;
		que.pop();

		for (auto rule : rules) {
			if (sz(rule) == 3 && !(conn[rule[1]][i][k] == 0) && !(conn[rule[2]][k][j] == 0)) {
				if (conn[rule[0]][i][j] == 0 || conn[rule[1]][i][k] + conn[rule[2]][k][j] < conn[rule[0]][i][j]) {
					conn[rule[0]][i][j] = conn[rule[1]][i][k] + conn[rule[2]][k][j];
					for (int a = 0; a < n; a++) {
						if (!xx[j][i][a]) { que.push(mp(j, mp(i, a))); xx[j][i][a] = 1; }
						if (!xx[i][a][j]) { que.push(mp(i, mp(a, j))); xx[i][a][j] = 1; }
					}
				}
			}
		}
	}

	if (conn['S'][s][t] == 0) cout << "NO" << endl;
	else {
        conn['S'][s][t].print();
        cout << endl;
    }
//    myint xx = myint(123, 123);
//    xx.print();
}
