#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);


int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int k, n;
	cin >> k >> n;

	ld ans = 0;

	vector<pair<int, int>> tree(1, mp(-1, -1));
	vector<int> ht(1, k);
	vector<int> ctop(1, inf);
	vector<int> par(1, -1);

	vector<ld> res_1(2 * k + 1);
	for (int i = 2; i <= 2 * k; i++) res_1[i] = res_1[i - 1] + 1.0 / (1LL << (i - 1)) * 1.0 / (i);
	vector<ld> res_1_inf(2 * k + 1);
	res_1_inf[0] = 1;
	for (int i = 1; i <= 2 * k; i++) {
		for (int ht = 1; ht < i; ht++) res_1_inf[i] += 1.0 / (ht + 1) * 1.0 / (1LL << (ht));
		res_1_inf[i] += 1.0 / (i + 1) * 1.0 / (1LL << (i - 1));
	}

	vector<vector<ld>> res_tree_ht(k + 1, vector<ld>(k + 1));
	for (int ht = 0; ht <= k; ht++) {
		res_tree_ht[ht][0] = res_1[ht];
		for (int l = 1; l <= k; l++) {
			res_tree_ht[ht][l] = res_tree_ht[ht][l - 1] + res_1[ht + l] * (1LL << l);
		}
	}
	vector<vector<ld>> res_infinitree_ht(k + 1, vector<ld>(k + 1));
	for (int ht = 0; ht <= k; ht++) {
		res_infinitree_ht[ht][0] = res_1_inf[ht];
		for (int l = 1; l <= k; l++) {
			res_infinitree_ht[ht][l] += res_infinitree_ht[ht][l - 1] + res_1_inf[ht + l] * (1LL << l);
		}
	}

	for (int i = 0; i < n; i++) {
		int s, m;
		cin >> s >> m;
		s = k - s;
		m--;

		int x;
		x = 0;

		while (s > 0) {
			if (m >= (1LL << (s - 1))) {
				m -= (1LL << (s - 1));
				if (tree[x].second == -1) {
					tree[x].first = sz(tree);
					tree.pb(mp(-1, -1));
					ht.pb(ht[x] - 1);
					ctop.pb(ctop[x] + 1);
					par.pb(x);
					tree[x].second = sz(tree);
					tree.pb(mp(-1, -1));
					ht.pb(ht[x] - 1);
					ctop.pb(ctop[x] + 1);
					par.pb(x);
				}
				ctop[tree[x].first] = min(ctop[tree[x].first], ctop[x] + 1);
				ctop[tree[x].second] = min(ctop[tree[x].second], ctop[x] + 1);
				x = tree[x].second;
				s--;
			}
			else {
				if (tree[x].first == -1) {
					tree[x].second = sz(tree);
					tree.pb(mp(-1, -1));
					ht.pb(ht[x] - 1);
					ctop.pb(ctop[x] + 1);
					par.pb(x);
					tree[x].first = sz(tree);
					tree.pb(mp(-1, -1));
					ht.pb(ht[x] - 1);
					ctop.pb(ctop[x] + 1);
					par.pb(x);
				}
				ctop[tree[x].first] = ctop[x] + 1;
				ctop[tree[x].second] = ctop[x] + 1;
				x = tree[x].first;
				s--;
			}
		}

		if (ctop[x] >= inf) ans += 1;
		else ans += 1 - 1.0 / (1LL << (ctop[x] - 1));
		ctop[x] = 0;
		if (tree[x].second == -1) {
			tree[x].first = sz(tree);
			tree.pb(mp(-1, -1));
			ht.pb(ht[x] - 1);
			ctop.pb(ctop[x] + 1);
			par.pb(x);
			tree[x].second = sz(tree);
			tree.pb(mp(-1, -1));
			ht.pb(ht[x] - 1);
			ctop.pb(ctop[x] + 1);
			par.pb(x);
		}
	}

	for (int i = 0; i < sz(tree); i++) {
		if (tree[i].first != -1) ctop[tree[i].first] = min(ctop[tree[i].first], ctop[i] + 1);
		if (tree[i].second != -1) ctop[tree[i].second] = min(ctop[tree[i].second], ctop[i] + 1);
		if (ctop[i] > 0) {
			if (tree[i].first == -1) {
				if (ctop[i] >= inf) ans += res_infinitree_ht[k - ht[i]][ht[i] - 1];
				else ans += res_tree_ht[ctop[i]][ht[i] - 1];
			}
			else {
				if (ctop[i] >= inf) ans += res_1_inf[k - ht[i]];
				else ans += res_1[ctop[i]];
			}
		}
	}

	cout << fixed << setprecision(20) << ans << endl;
}