#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

vector <int> all;

const int MAXN = 3e5;

int find(int kek) {
	return lower_bound(all.begin(), all.end(), kek) - all.begin();
}

int a[MAXN], b[MAXN], w[MAXN];

vector <pair <int, int> > gr[MAXN];
vector <pair <int, int> > d;

int deg[MAXN], inv_deg[MAXN];

vector <int> ans, ans_with_unsuccessfull;
int c;

bool solve() {
	for (int i = 0; i < MAXN; i++)
		for (pair <int, int> to : gr[i])
			inv_deg[to.first]++;
	int f = c, l = -1;
	for (int i = 0; i < MAXN; i++) {
		deg[i] = gr[i].size();
		if (deg[i] > inv_deg[i] && i != f)
			return false;
		if (deg[i] > inv_deg[i] + 1)
			return false;
		if (deg[i] < inv_deg[i] - 1)
			return false;
		if (deg[i] == inv_deg[i] - 1) {
			if (l != -1)
				return false;
			l = i;
		}
	}
	
	vector <int> st;
	vector <int> edges;
	st.push_back(f);
	ans.clear();
	while (!st.empty()) {
		int v = st.back();
		if (deg[v] == 0) {
			st.pop_back();
			if (!edges.empty()) {
				ans.push_back(edges.back());
				edges.pop_back();
			}
		} else {
			pair <int, int> to = gr[v].back();
			edges.push_back(to.second);
			st.push_back(to.first);
			gr[v].pop_back();
			deg[v]--;
		}
	}
	
	for (int i = 0; i < MAXN; i++)
		if (deg[i] != 0)
			return false;
	for (int i = 0; (int)ans.size() - i - 1 > i; i++)
		swap(ans[i], ans[(int)ans.size() - i - 1]);
	
	int prev_c = -1, new_c = c;
	for (int i = 0; i < (int)ans.size(); i++) {
		if (prev_c != new_c) {
			vector <pair <int, int>> new_d;
			for (pair <int, int> to : d) {
				if (new_c != to.first) {
					ans_with_unsuccessfull.push_back(to.second);
				} else {
					new_d.push_back(to);
				}
			}
			d = new_d;
		}
		ans_with_unsuccessfull.push_back(ans[i]);
		prev_c = new_c;
		new_c = b[ans[i]];
	}
	
	for (pair <int, int> to : d) {
		if (new_c != to.first) {
			ans_with_unsuccessfull.push_back(to.second);
		} else {
			return false;
		}
	}
	
	return true;
}

int32_t main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(false);
	
	int n; cin >> n >> c;
	all.push_back(c);
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i] >> w[i];
		all.push_back(a[i]);
		all.push_back(b[i]);
	}
	
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	
	c = find(c);
	for (int i = 0; i < n; i++) {
		a[i] = find(a[i]);
		b[i] = find(b[i]);
		if (w[i] == 1) {
			gr[a[i]].push_back({b[i], i});
		} else {
			d.push_back({a[i], i});
		}
	}
	
	if (!solve()) {
		cout << "No" << endl;
	} else {
		cout << "Yes" << endl;
		for (int i = 0; i < (int)ans_with_unsuccessfull.size(); i++)
			cout << ans_with_unsuccessfull[i] + 1 << " ";
		cout << endl;
	}
	
	return 0;
}
