#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <ctime>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")

using namespace std;
typedef long long ll;
typedef long double ld;

typedef vector <int> kek;

const int maxn = 30;
kek dp[maxn][maxn][maxn];
bool is_inf[maxn][maxn][maxn];

vector <int> rules[maxn][maxn];
const kek kek_inf = {1};

const int base = 1e9;

kek sum_keks(kek a, const kek& b) {
	int carry = 0;
	for (size_t i=0; i<max(a.size(),b.size()) || carry; ++i) {
		if (i == a.size())
			a.push_back (0);
		a[i] += carry + (i < b.size() ? b[i] : 0);
		carry = a[i] >= base;
		if (carry)  a[i] -= base;
	}
	return a;
}

void print_kek(const kek &a) {
	printf ("%d", a.empty() ? 0 : a.back());
	for (int i=(int)a.size()-2; i>=0; --i)
		printf ("%09d", a[i]);
}

bool is_greater(kek a, kek b) {
	while (a.size() > 0 && a.back() == 0)
		a.pop_back();
	while (b.size() > 0 && b.back() == 0)
		b.pop_back();
	if (a.size() > b.size())
		return true;
	if (a.size() < b.size())
		return false;
	for (int i = (int)a.size() - 1; i >= 0; i--) {
		if (a[i] > b[i])
			return true;
		if (a[i] < b[i])
			return false;
	}
	return false;
}

vector <pair <int, pair <int, int> > > all_rules;

bool last_changed_i[maxn];
bool last_changed_j[maxn][maxn];
bool last_changed_n3[maxn][maxn][maxn];

bool new_last_changed_i[maxn];
bool new_last_changed_j[maxn][maxn];
bool new_last_changed_n3[maxn][maxn][maxn];

int main() {
	//freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int p; cin >> p;
    vector <vector <pair<int, int>>> a(26);

    string tmp; getline(cin, tmp);

    for (int i = 0; i < p; i++){
        string s;
        getline(cin, s);
        if (s.length() == 7) {
            a[s[0] - 'A'].push_back({s[5] - 'A', s[6] - 'A'});
            all_rules.push_back({s[0] - 'A', {s[5] - 'A', s[6] - 'A'}});
        }
        else{
            a[s[0] - 'A'].push_back({s[5] - 'a', -1});
        }
    }

    int s, t, n, m;
    cin >> n >> m >> s >> t; s--; t--;
    vector <vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v; u--; v--;
        char c; cin >> c;
        gr[u].push_back({v, c - 'a'});
    }
    
    


    for (int i = 0; i < maxn; i++){
        for (int j = 0; j < maxn; j++){
            for (int k = 0; k < maxn; k++){
                dp[i][j][k] = kek_inf;
                is_inf[i][j][k] = true;
            }
        }
    }

    for (int i = 0; i < 26; i++){
        for (auto rule : a[i]) {
            if (rule.second == -1) {
                for (int u = 0; u < n; u++) {
                    for (auto e : gr[u]) {
                        if (e.second == rule.first) {
							is_inf[i][u][e.first] = false;
                            dp[i][u][e.first] = {1};
                        }
                    }
                }
            }
        }
    }
    
    for (int i = 0; i < maxn; i++)
		for (int j = 0; j < maxn; j++)
			for (int n3 = 0; n3 < maxn; n3++)
				last_changed_i[i] = last_changed_j[i][j] = last_changed_n3[i][j][n3] = true;
    
    bool changed = true;
    while (changed) {
		for (int i = 0; i < maxn; i++) {
			new_last_changed_i[i] = false;
			for (int j = 0; j < maxn; j++) {
				new_last_changed_j[i][j] = false;
				for (int n3 = 0; n3 < maxn; n3++)
					new_last_changed_n3[i][j][n3] = false;
			}
		}
		changed = false;
		for (int k = 0; k < n; k++)	
			for (int i = 0; i < n; i++) if (last_changed_i[i] || last_changed_i[k])
				for (int j = 0; j < n; j++) if ((last_changed_j[i][k] || last_changed_j[k][j]))
					for (pair <int, pair <int, int> > r : all_rules) {
						int n3 = r.first, n1 = r.second.first, n2 = r.second.second;
							if (!is_inf[n1][i][k] && !is_inf[n2][k][j] && (last_changed_n3[i][k][n1] || last_changed_n3[k][j][n2])) {
								kek new_kek = sum_keks(dp[n1][i][k], dp[n2][k][j]);
								if (is_inf[n3][i][j] || is_greater(dp[n3][i][j], new_kek)) {
									dp[n3][i][j] = new_kek;
									is_inf[n3][i][j] = false;
									changed = true;
									new_last_changed_i[i] = true;
									new_last_changed_j[i][j] = true;
									new_last_changed_n3[i][j][n3] = true;
									//last_changed_i[i] = true;
									//last_changed_j[i][j] = true;
									//last_changed_n3[i][j][n3] = true;
								}
							}
					}
		swap(last_changed_i, new_last_changed_i);
		swap(last_changed_j, new_last_changed_j);
		swap(last_changed_n3, new_last_changed_n3);
		if ((double)clock() / CLOCKS_PER_SEC > 1.9)
			break;
	}

    kek res = dp['S' - 'A'][s][t];
    if (is_inf['S' - 'A'][s][t]) cout << "NO\n";
    else {
		print_kek(res);
		cout << "\n";
	}

    return 0;
}

