#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

typedef vector <int> kek;

const int maxn = 30;
kek dp[maxn][maxn][maxn];

vector <int> rules[maxn][maxn];
const kek kek_inf = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1};

const int base = 1e9;

kek sum_keks(kek a, const kek& b) {
	int carry = 0;
	for (size_t i=0; i<max(a.size(),b.size()) || carry; ++i) {
		if (i == a.size())
			a.push_back (0);
		a[i] += carry + (i < b.size() ? b[i] : 0);
		carry = a[i] >= base;
		if (carry)  a[i] -= base;
	}
	return a;
}

void print_kek(const kek &a) {
	printf ("%d", a.empty() ? 0 : a.back());
	for (int i=(int)a.size()-2; i>=0; --i)
		printf ("%09d", a[i]);
}

bool is_greater(kek a, kek b) {
	while (a.size() > 0 && a.back() == 0)
		a.pop_back();
	while (b.size() > 0 && b.back() == 0)
		b.pop_back();
	if (a.size() > b.size())
		return true;
	if (a.size() < b.size())
		return false;
	for (int i = (int)a.size() - 1; i >= 0; i--) {
		if (a[i] > b[i])
			return true;
		if (a[i] < b[i])
			return false;
	}
	return false;
}

int main() {
	//freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int p; cin >> p;
    vector <vector <pair<int, int>>> a(26);

    string tmp; getline(cin, tmp);

    for (int i = 0; i < p; i++){
        string s;
        getline(cin, s);
        if (s.length() == 7) {
            a[s[0] - 'A'].push_back({s[5] - 'A', s[6] - 'A'});
            rules[s[5] - 'A'][s[6] - 'A'].push_back(s[0] - 'A');
        }
        else{
            a[s[0] - 'A'].push_back({s[5] - 'a', -1});
        }
    }

    int s, t, n, m;
    cin >> n >> m >> s >> t; s--; t--;
    vector <vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v; u--; v--;
        char c; cin >> c;
        gr[u].push_back({v, c - 'a'});
    }


    for (int i = 0; i < maxn; i++){
        for (int j = 0; j < maxn; j++){
            for (int k = 0; k < maxn; k++){
                dp[i][j][k] = kek_inf;
            }
        }
    }

    for (int i = 0; i < 26; i++){
        for (auto rule : a[i]) {
            if (rule.second == -1) {
                for (int u = 0; u < n; u++) {
                    for (auto e : gr[u]) {
                        if (e.second == rule.first) {
                            dp[i][u][e.first] = {1};
                        }
                    }
                }
            }
        }
    }
    
    bool changed = true;
    while (changed) {
		changed = false;
		for (int k = 0; k < n; k++)	
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++)
					for (int n1 = 0; n1 < 26; n1++)
						if (dp[n1][i][k] != kek_inf)
							for (int n2 = 0; n2 < 26; n2++)
								if (dp[n2][k][j] != kek_inf) {
									for (int n3 : rules[n1][n2]) {
										kek new_kek = sum_keks(dp[n1][i][k], dp[n2][k][j]);
										if (is_greater(dp[n3][i][j], new_kek)) {
											dp[n3][i][j] = new_kek;
											changed = true;
										}
									}
								}
	}

    kek res = dp['S' - 'A'][s][t];
    if (res == kek_inf) cout << "NO\n";
    else {
		print_kek(res);
		cout << "\n";
	}

    return 0;
}

