#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int N = 8;

vector<string> tokenize(const string& F) {
    vector<string> res;
    for (int i = 0; i < F.size();) {
        if (F[i] == ' ') {
            i++;
            continue;
        }
        if (F[i] == '(' || F[i] == ')') {
            res.push_back(F.substr(i, 1));
            i++;
            continue;
        }
        int j = i;
        while (j < F.size() && F[j] != '(' && F[j] != ')' && F[j] != ' ') j++;
        res.push_back(F.substr(i, j - i));
        i = j;

    }
    return res;
}

bool getm(int mask, int i) {
    return (mask >> i) & 1;
}
int setm(int mask, int i, bool x) {
    if (x) return mask | (1 << i);
    return mask & ~(1 << i);
}

bool eval_atomic(char c, int mask) {
    if (c == '0') return 0;
    if (c == '1') return 1;
    return getm(mask, c - 'a');
}

bool eval(vector<string> tokens, int mask) {
    vector<string> tokens2;
    for (int i = 0; i < tokens.size(); ) {
        string t = tokens[i];

        if (t == "(") {
            int j = i + 1;
            int c = 1;
            while (c > 0) {
                if (tokens[j] == "(") c++;
                if (tokens[j] == ")") c--;
                j++;
            }
            vector<string> ts;
            for (int k = i + 1; k  + 1 < j; k++) {
                ts.push_back(tokens[k]);
            }
            bool r = eval(ts, mask);
            tokens2.push_back(string(1, '0' + r));
            i = j;
        }
        else {
            tokens2.push_back(t);
            i++;
        }
    }

    vector<string> ops;
    vector<bool> vals;
    for (int i = 0; i < tokens2.size(); i++) {
        string t = tokens2[i];

        if (t == "not") ops.push_back(t);
        if (t == "and") {
            while (ops.size() > 0 && ops.back() == "not") {
                ops.pop_back();
                bool val = vals.back(); vals.pop_back();
                vals.push_back(!val);
            }
            ops.push_back(t);
        }
        if (t == "or") {
            while (ops.size() > 0 && (ops.back() == "not" || ops.back() == "and")) {
                string op = ops.back(); ops.pop_back();
                bool val1 = vals.back(); vals.pop_back();
                if (op == "and") {
                    bool val2 = vals.back(); vals.pop_back();
                    vals.push_back(val1 && val2);
                }
                if (op == "not") {
                    vals.push_back(!val1);
                }
            }
            ops.push_back(t);
        }
        if (t.size() == 1) {
            vals.push_back(eval_atomic(t[0], mask));
        }
    }
    while (ops.size() > 0) {
        string op = ops.back(); ops.pop_back();
        bool val1 = vals.back(); vals.pop_back();
        if (op == "and") {
            bool val2 = vals.back(); vals.pop_back();
            vals.push_back(val1 && val2);
        }
        if (op == "not") {
            vals.push_back(!val1);
        }
        if (op == "or") {
            bool val2 = vals.back(); vals.pop_back();
            vals.push_back(val1 || val2);
        }
    }
    assert(vals.size() == 1);
    return vals.back();
}

bool table[1 << N];
vector<int> mms;

void printm(int mask) {
    for (int i = 0; i < N; i++) {
        cout << getm(mask, i) << " ";
    }
}

const int W = 20;
const int H = 20;

char ANS[H + 5][W + 5];

void build_block(int y, int x, int mask) {
    for (int i = 0; i < N; i++) {
        ANS[y + 2 * i][x] = '+';
        ANS[y + 2 * i][x + 2] = '+';
        if (i > 0) ANS[y + 2 * i - 1][x] = '|';
        if (i > 0) ANS[y + 2 * i - 1][x + 2] = '|';
        if (getm(mask, i)) ANS[y + 2 * i][x + 1] = 'a' + i;
        else ANS[y + 2 * i][x + 1] = ' ';
    }
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    printf("\
+a+-+ +-+a+-+ +----+\n\
| | | | | | | |     \n\
+ + +b+ + + +b+     \n\
| | | | | | | |     \n\
+ + +c+ + + +c+     \n\
| | | | | | | |     \n\
+ + + + + + + +     \n\
| | | | | | | |     \n\
+ + + + + + + +     \n\
| | | | | | | |     \n\
+ + + + + + + +     \n\
| | | | | | | |     \n\
+ + + + + + + +     \n\
| | | | | | | |     \n\
+ + + + + + + +     ");
    return 0;


    for (int y = 0; y < H; y++) {
        for (int x = 0; x < W; x++) {
            ANS[y][x] = ' ';
        }
    }

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    string F;
    getline(cin, F);
    auto tokens = tokenize(F);

    for (int mask = 0; mask < (1 << N); mask++) {
        bool r = eval(tokens, mask);
        table[mask] = r;
    }

    for (int mask = 0; mask < (1 << N); mask++) {
        int was = 0;
        for (int sm = mask; ; sm = (sm - 1) & mask) {
            if (sm != mask && table[sm] == 1) was = 1;
            if (sm == 0) break;
        }

        if (was && !table[mask]) {
            cout << "IMPOSSIBLE" << endl;
            return 0;
        }
        if (!was && table[mask]) {
            mms.push_back(mask);
        }
    }

    /*for (int m : mms) {
        for (int i = 0; i < N; i++) {
            cout << (char)('a' + i) << ": " << getm(m, i) << "; ";
        }
        cout << endl;
    }
    return 0;*/

    int cur = 0;
    int SZ = mms.size();

    if (SZ == 0) {
        cout << "+-+" << endl;
        return 0;
    }

    int c = 1;

    int y = 0;
    while (y + 2 * N < H) {
        int x;
        if (c) {
            x = 0;
            while (x + 5 <= W) {
                build_block(y, x, mms[cur % SZ]); cur++;
                ANS[y][x + 3] = '-';
                x += 4;
            }
            while (x < W - 1) {
                ANS[y][x] = '-';
                x++;
            }
        }
        else {
            x = W - 1;
            while (x - 5 >= 0) {
                x -= 2;
                build_block(y, x, mms[cur % SZ]); cur++;
                ANS[y][x - 1] = '-';
                x -= 2;
            }
            while (x > 0) {
                ANS[y][x] = '-';
                x--;
            }
        }
        /*for (int i = 0; i < 2 * N; i++) {
            ANS[y + i][x] = '|';
        }*/
        ANS[y][x] = '+';
        c ^= 1;
        y += 2 * N;
    }

    /*while (y < H - 1) {
        ANS[y][W - 1] = '|';
        y++;
    }
    */

    ANS[0][W - 1] = '*';


    for (int y = 0; y < H; y++) {
        for (int x = 0; x < W; x++) {
            cout << ANS[y][x];
        }
        if (y + 1 < H) cout << endl;
    }

    return 0;
}
