#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;

struct BigInt
{
 	vector <ll> number;
 	const ll MOD = (ll) 1e18;
 	BigInt()
 	{
 	 	number.pb(0);
 	}
 	BigInt& operator = (ll x)
 	{
 	 	number.clear();
 	 	while (x > 0)
 	 	{
 	 	 	number.pb(x % MOD);
 	 	 	x /= MOD;
 	 	}
 	 	return *this;
 	}
 	BigInt& operator = (const BigInt &a)
 	{
 	 	number = a.number;
 	 	return *this;
 	}

 	bool operator < (const BigInt &a) const
 	{
 		if (number.size() < a.number.size()) return true;
 		if (number.size() > a.number.size()) return false;
 		for (int i = (int) number.size() - 1; i >= 0; i--)
 		{
 			if (number[i] < a.number[i]) return true;
 			if (number[i] > a.number[i]) return false;
 		}
 		return false;
 	}

 	bool operator == (const BigInt &a) const
 	{
 	 	return !(*this < a) && !(a < *this);
 	}

 	bool is_zero() const
 	{
 	 	return number.size() == 1 && number[0] == 0;
 	}
};

BigInt operator + (BigInt a, BigInt b)
{
 	while (a.number.size() < b.number.size()) a.number.pb(0);
 	while (a.number.size() > b.number.size()) b.number.pb(0);
 	bool fl = false;
 	for (int i = 0; i < a.number.size(); i++)
 	{
 	 	a.number[i] += b.number[i];
 	 	if (a.number[i] >= a.MOD)
 	 	{
 	 	 	if (i + 1 < a.number.size()) a.number[i + 1]++, a.number[i] -= a.MOD;
 	 	 	else fl = true, a.number[i] -= a.MOD;
 	 	}
 	}
 	if (fl) a.number.pb(1);
 	return a;
}

ostream& operator << (ostream &os, const BigInt &a)
{
 	os << a.number.back();
 	for (int i = (int) a.number.size() - 2; i >= 0; i--)
 	{
 	 	string s = to_string(a.number[i]);
 	 	for (int c = s.length(); c < 18; c++) os << '0';
 	 	os << s;
 	}
 	return os;
}

bool matr[30][30];
vector <pair <int, pair <int, int> > > spis;
BigInt dist[30][30][30];

struct vertex
{
	int sost, from, to;
	vertex(int b = 0, int c = 0, int d = 0) {sost = b, from = c, to = d;}
	bool operator < (const vertex &a) const
	{
	 	return (dist[sost][from][to] < dist[a.sost][a.from][a.to]) || 
	 		   (dist[sost][from][to] == dist[a.sost][a.from][a.to] && sost < a.sost) || 
	 		   (dist[sost][from][to] == dist[a.sost][a.from][a.to] && sost == a.sost && from < a.from) ||
	 		   (dist[sost][from][to] == dist[a.sost][a.from][a.to] && sost == a.sost && from == a.from && to < a.to);
	}
};

set <vertex> opa;

int main()
{
 	//freopen("input.txt", "r", stdin);
 	//freopen("output.txt", "w", stdout);
 	ios_base::sync_with_stdio(0); cin.tie(0);
 	int p;
 	string t;
 	cin >> p;
 	getline(cin, t);
 	for (int i = 1; i <= p; i++)
 	{
 	 	string s;
 	 	getline(cin, s);
 	 	int lef = s[0] - 'A' + 1;
 	 	if (s[5] <= 'z' && s[5] >= 'a') matr[lef][s[5] - 'a' + 1] = true;
 	 	else spis.pb(mp(lef, mp(s[5] - 'A' + 1, s[6] - 'A' + 1)));
	}
	int Start = 'S' - 'A' + 1;

	int n, m, start, finish;
	cin >> n >> m >> start >> finish;
	
	for (int i = 1; i <= m; i++)
	{
	 	int u, v;
	 	char c;
	 	cin >> u >> v >> c;
	 	for (int j = 1; j <= 26; j++)
	 		if (matr[j][c - 'a' + 1]) dist[j][u][v] = 1, opa.insert(vertex(j, u, v));
	}
	
	while (!opa.empty())
	{
	 	vertex A = *opa.begin();
	 	opa.erase(opa.begin());
	 	for (int i = 1; i <= n; i++)
	 		for (int nx = 0; nx < (int) spis.size(); nx++)
	 		{
	 			int st1 = spis[nx].x, st2 = spis[nx].y.x, st3 = spis[nx].y.y;
	 			if (st2 == A.sost && !dist[st3][A.to][i].is_zero() &&
	 			   (dist[A.sost][A.from][A.to] + dist[st3][A.to][i] < dist[st1][A.from][i] || dist[st1][A.from][i].is_zero()))
	 			{
	 			 	opa.erase(vertex(st1, A.from, i));
	 			 	dist[st1][A.from][i] = dist[A.sost][A.from][A.to] + dist[st3][A.to][i];
	 			 	opa.insert(vertex(st1, A.from, i));
	 			}
	 			if (st3 == A.sost && !dist[st2][i][A.from].is_zero() &&
	 			   (dist[st2][i][A.from] + dist[A.sost][A.from][A.to] < dist[st1][i][A.to] || dist[st1][i][A.to].is_zero()))
	 			{
	 				opa.erase(vertex(st1, i, A.to));
	 			 	dist[st1][i][A.to] = dist[st2][i][A.from] + dist[A.sost][A.from][A.to];
	 			 	opa.insert(vertex(st1, i, A.to));
	 			}
	 	   	}
	}
	if (dist[Start][start][finish].is_zero()) cout << "NO\n";
	else cout << dist[Start][start][finish] << '\n';
 	return 0;
}