#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;
const ld eps = 1e-9;
const ld pi = atan2(0, -1);

struct Interactor {
    vector<int> a;
    int n, cnt;

    Interactor() {}

    Interactor(int n): n(n) {
        cnt = 0;
        a.assign(n, 0);
        iota(a.begin(), a.end(), 0);
        reverse(a.begin(), a.end());
//        random_shuffle(a.begin(), a.end());
    }

    int check_win() {
        for(int i = 1; i < n; ++i)
            if(a[i-1] >= a[i]) return 0;
        return 1;
    }

    string ask(int i, int j) {
        cnt++;
        if((cnt % (2*n)) == 0) {
            int i_rand = rand()%n, j_rand = rand()%n;
            swap(a[i_rand], a[j_rand]);
        }

        if(check_win()) return "WIN";
        if(a[i] < a[j]) return "STAYED";
        swap(a[i], a[j]);
        if(check_win()) return "WIN";
        return "SWAPPED";
    }
};

struct Solver {
//    Interactor jury;
    int n, cnt;

    Solver(int n): n(n) {
        cnt = 0;
//        jury = {n};
    }

    string ask(int i, int j) {
//        cnt++;
//        cout << cnt << "\n";
//        if(cnt == 10005) {
//            cout << "LOSE :(\n";
//            exit(0);
//        }

        cout << i+1 << " " << j+1 << endl;
        string ans;
        cin >> ans;

//        string ans = jury.ask(i, j);

        if(ans == "WIN") exit(0);
        return ans;
    }

    void repair(int k) {
        int l = -1;
        int r = -1;
        int broken = 0;

        for(int i = 0; i+1 < k; ++i) {
            string ans = ask(i, i+1);
            if(ans == "SWAPPED") {
                l = i;
                broken = 1;
            }

            if(broken && (ans == "STAYED")) {
                r = i;
                break;
            }
        }

        if(broken && (r == -1)) r = k-1;

        for(int i = r-1; i-1 >= l; --i)
            ask(i-1, i);
    }

    void solve() {
        for(int t = 0; t < n; ++t) {
            for(int i = n-2; i >= 0; --i) {
                ask(i, i+1);
                if((cnt % (2*n)) == 0) repair(t+1);
            }
        }
    }
};

const int debug = 0;
int32_t main() {
//    freopen("inp.txt", "r", stdin);
    cout << fixed << setprecision(16);
    if(!debug) {
        ios_base::sync_with_stdio();
        cin.tie(0); cout.tie(0);
    }


    srand(time(0));
    int tests = (debug ? 1000 : 1);
//    cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!debug) {
            /// Main part ///

            int n;
            cin >> n;

            Solver solver(n);
            solver.solve();
            cout << endl;


            /// Main part ///
        } else {}
    }

    return 0;
}

/**

*/
