#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;
const ld eps = 1e-9;
const ld pi = atan2(0, -1);

struct Solver {
    vector<int> a, p1, p2;
    int n;
    ld p;

    Solver(auto a, auto p): a(a), p(p) {
        n = a.size();

        p1.assign(n, 0);
        p2.assign(n, 0);

        for(int i = 0; i < n; ++i) {
            p1[i] = a[i];
            p2[i] = a[i]*a[i];

            if(i > 0)
                p1[i] += p1[i-1], p2[i] += p2[i-1];

//            cout << p1[i] << " ";
        }
    }

    int get_p1(int l, int r) {
//        cout << l << " " << r << " " << p1[r] << "\n";
        int res = p1[r];
        if(l > 0) res -= p1[l-1];
        return res;
    }

    int get_p2(int l, int r) {
        int res = p2[r];
        if(l > 0) res -= p2[l-1];
        return res;
    }

    pair<int, int> solve() {
        pair<int, int> res = {0, 0};

        for(int i = 0; i < n; ++i) {
            for(int j = i+1; j < n; ++j) {
                ld p1_sum = get_p1(i, j);
                ld p2_sum = get_p2(i, j);

                ld A = p1_sum / (ld)(j-i+1);
                ld D = (j-i+1)*A*A + p2_sum - 2*A*p1_sum;
                D /= (ld)(j-i+1);
                D = sqrt(D);

//                cout << i << " " << j << " | " << p1_sum << " " << A << " " << D << "\n";

                if(abs(D) < eps) {
                    if(A > eps) res.first++;
                    if(A < -eps) res.second++;
                }

                else {
                    if(A/D >= p) res.first++;
                    if(A/D <= -p) res.second++;
                }
            }
        }

        return res;
    }
};

const int debug = 0, fast_io = 1;
int32_t main() {
//    freopen("inp.txt", "r", stdin);
    cout << fixed << setprecision(16);
    if(fast_io) {
        ios_base::sync_with_stdio();
        cin.tie(0); cout.tie(0);
    }

    int tests = (debug ? 1000 : 1);
//    cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!debug) {
            /// Main part ///

            int d;
            ld p;
            cin >> d >> p;

            vector<int> a(d, 0);
            for(int i = 0; i < d; ++i)
                cin >> a[i];

            vector<int> b(d-1, 0);
            for(int i = 0; i+1 < d; ++i)
                b[i] = a[i+1] - a[i];

            Solver solver(b, p);
            pair<int, int> res = solver.solve();
            cout << res.first << " " << res.second << "\n";

            /// Main part ///
        } else {}
    }

    return 0;
}

/**

*/
