#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <stack>

using namespace std;

int getadr(vector<int> &v, int a){
	return upper_bound(v.begin(), v.end(), a) - v.begin() - 1;
}

int main(){
	//freopen("inpA.txt", "t", stdin);
	int n, ini;
	int edges = 0;
	int cntone = 0;
	cin >> n >> ini;
	vector<int> st(n, 0);
	vector<int> fi(n, 0);
	vector<int> wh(n, 0);
	set<int> alv;
	for(int i = 0; i < n; i++){
		cin >> st[i] >> fi[i] >> wh[i];
		if(wh[i] == 1){
			cntone++;
			edges++;
			alv.insert(st[i]);
			alv.insert(fi[i]);
		}
	}
	if(cntone == 0){
		for(int i = 0; i < n; i++){
			if(st[i] == ini){
				cout << "No";
				return 0;
			}
		}
		cout << "Yes" << endl;
		for(int i = 0; i < n; i++){
			cout << i << " ";
		}
		return 0;
	}
	vector<int> ver;
	ver.reserve(100001);
	for(auto it = alv.begin(); it != alv.end(); ++it){
		ver.push_back(*it);
	}
	sort(ver.begin(), ver.end());
	int V = ver.size();

	vector<vector<int>> g(V);

	vector<int> degs(V, 0);

	for(int i = 0; i < n; i++){
		if(wh[i] == 1){
			int l = getadr(ver, st[i]);
			int r = getadr(ver, fi[i]);
			degs[l]++;
			degs[r]--;
			g[l].push_back(r);
		}
	}
	int ss = -1;
	for(int i = 0; i < V; i++){
		if((degs[i] == 1 || degs[i] == 0)&& i == getadr(ver, ini)){
			ss = i;
			break;
		}
	}
	if(ss < 0){
		cout << "No" << endl;
		return 0;
	}

	stack<int> sta;
	vector<int> ans;

	sta.push(ss);
	while(!sta.empty()){
		int vv = sta.top();
		bool istoans = true;
		for(int i = 0; i < g[vv].size(); i++){
			if(g[vv][i] >= 0){
				sta.push(g[vv][i]);
				g[vv][i] = -1;
				istoans = false;
				break;
			}
		}
		if(istoans){
			ans.push_back(vv);
			sta.pop();
		}
	}
	
	for(int i = 0; i < V; i++){
		for(int j = 0; j < g[i].size(); j++){

			if(g[i][j] >= 0){
				cout << "No";
				return 0;
			}
		}
	}

	int fis = ver[ans[ans.size() - 1]];
	int fif = ver[ans[0]];

	/*for(int i = ans.size() - 1; i >= 0; i--){
		cout << ver[ans[i]] << " ";
	}
	cout << endl;
	*/

	//here we start 
	vector<pair<pair<int, int>, pair<int, int>>> suu(n);
	for(int i = 0; i < n; i++){
		suu[i] = make_pair(make_pair(st[i], fi[i]), make_pair(0, i + 1));
	}
	sort(suu.begin(), suu.end());
	vector<int> midd;


	for(int i = ans.size() - 1; i > 0; i--){
		int tmp = upper_bound(suu.begin(), suu.end(), make_pair(make_pair(ver[ans[i]], ver[ans[i - 1]]), make_pair(1, 2000000000))) - suu.begin() - 1;
		midd.push_back(suu[tmp].second.second);
		//cout << suu[tmp].second.second << " ";
		suu[tmp].second.first = 1;
	}



	if(fis != fif){
		cout << "Yes" << endl;
		vector<int> when;
		vector<int> before;
		vector<int> after;
		for(int i = 0; i < n; i++){
			if(wh[i] == 0){
				if(st[i] != fis){
					before.push_back(i + 1);
				} else {
					after.push_back(i + 1);
				}
			}
		}
		for(auto i: before){
			cout << i << " ";
		}
		for(auto i: midd){
			cout << i << " ";
		}
		for(auto i: after){
			cout << i << " ";
		}
	} else {
		int oth = -1;
		for(int i = 0; i < midd.size(); i++){
			if(fi[midd[i]] != fis){
				oth = i;
				break;
			}
		}
		vector<int> when;
		vector<int> before;
		vector<int> after;
		for(int i = 0; i < n; i++){
			if(wh[i] == 0){
				if(st[i] != fis){
					before.push_back(i + 1);
				} else {
					after.push_back(i + 1);
				}
			}
		}
		if(!after.empty() && oth == -1){
			cout << "No" << endl;
			return 0;
		} else {
			if(!after.empty()){
				cout << "Yes" << endl;
				for(auto i: before){
					cout << i << " ";
				}
				for(int i = 0; i < oth; i++){
					cout << midd[i] << " ";
				}
				for(auto i: after){
					cout << i << " ";
				}
				for(int i = oth + 1; i < midd.size(); i++){
					cout << midd[i] << " ";
				}
			} else {
				cout << "Yes" << endl;
				for(auto i: before){
					cout << i << " ";
				}
				for(int i = 0; i < midd.size(); i++){
					cout << midd[i] << " ";
				}

			}
		}	

	}
}








