#include <iostream>
#include <algorithm>
#include <queue>
#include <numeric>
#include <cassert>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

const int INF = 1e9 + 5;

void run() {
    int d;
    cin >> d;
    double p;
    cin >> p;
    auto c = arr<int>(d);
    for (int i = 0; i < d; i++) {
        cin >> c[i];
    }
    auto pr_sq = arr<long long>(d, 0);
    for (int i = 1; i < d; i++) {
        pr_sq[i] = pr_sq[i - 1] + (c[i] - c[i - 1]) * (c[i] - c[i - 1]);
    }
    int pos = 0, neg = 0;
    for (int l = 0; l < d; l++) {
        for (int r = l + 2; r < d; r++) {
            auto na = c[r] - c[l];
            if (na == 0)
                continue;
            int n = r - l;
            auto sq = pr_sq[r] - pr_sq[l];
            bool cur = na * na * (1 + p * p) / (n * p * p) >= sq;
            if (na > 0) {
                pos += cur;
            } else {
                neg += cur;
            }
        }
    }
    cout << pos << ' ' << neg << endl;
}

int main() {
    //ios::sync_with_stdio(false);
    cout.tie(0);
    cout.precision(10);
    cout << fixed;
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++)
        run();
}
