#include <iostream>
#include <algorithm>
#include <queue>
#include <numeric>
#include <cassert>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

const int INF = 1e9 + 5;

void run() {
    int n;
    cin >> n;
    auto a = arr<int>(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    a[n] = 0;
    sort(a, a + n + 1);
    int max_n = 0, min_not_n = INF;
    for (int i = 1; i <= n; i++) {
        max_n = max(max_n, a[i] - a[i - 1]);
    }
    for (int i = 2; i <= n; i++) {
        min_not_n = min(min_not_n, a[i] - a[i - 2]);
    }
    if (max_n < min_not_n) {
        cout << max_n;
    } else {
        cout << 0;
    }
}

int main() {
    //ios::sync_with_stdio(false);
    cout.tie(0);
    cout.precision(10);
    cout << fixed;
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++)
        run();
}
