#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <string>
#include <cmath>
#include <map>
#include <random>
#include <chrono>

using namespace std;

#define pb push_back
#define f first
#define s second
#define pii pair <int, int>
 
typedef long long ll;
typedef long double ld;
typedef vector <int> vi;

const int MAXN = 51;
ll INF = 1e9 + 10;
ll MOD = 1e9 + 7;
ld EPS = 1e-12;

void fastIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll n, k;
ll cnk[MAXN][MAXN], pw[MAXN];

void precalc() {
    cnk[0][0] = 1;
    for (int i = 1; i < MAXN; i++) {
        cnk[i][0] = 1;
        for (int j = 1; j <= i; j++)
            cnk[i][j] = cnk[i - 1][j] + cnk[i - 1][j - 1];
    }
    pw[0] = 1;
    for (int i = 1; i < MAXN; i++)
        pw[i] = pw[i - 1] * (ll)2;
}

ll calc_pals(ll x) {
    if (n % 2 == 0) {
        if (x % 2 == 1)
            return 0;
        return cnk[n / 2][x / 2];
    }
    return cnk[n / 2][x / 2];
}

ll calc(ll x) {
    ll cnt_pals = calc_pals(x);
    //cerr << cnt_pals << endl;
    return cnt_pals + (cnk[n][x] - cnt_pals) / 2;
}

int main() {
    fastIO();
    cin >> n >> k;
    precalc();
    ll ans = 0;
    //cerr << calc(0) << endl;
    for (ll i = 0; i <= n; i++) {
        if (k - i > n)
            continue;
        if (k - i < i)
            break;
        if (i != k - i) {
            ans += calc(i);
            ans += calc(k - i);
        }
        else
            ans += calc(i) * (ll)2;
    }
    cout << ans;


    return 0;
}