//#define FAKE
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <map>
#include <fstream>
 
using namespace std;
 
vector<vector<pair<int, int> > > g;
 
map<int, int> vernum;
vector<int> verval;
vector<int> inc;
 
int get_ver(int x)
{
    if (vernum.count(x))
        return vernum[x];
    vernum[x] = g.size();
    verval.push_back(x);
    inc.push_back(0);
    g.push_back({});
    return g.size() - 1;
}
 
vector<int> eulver;
vector<int> eule;
 
void dfs(int v)
{
    while (g[v].size())
    {
        int u = g[v].back().first;
        int e = g[v].back().second;
        g[v].pop_back();
        dfs(u);
        eule.push_back(e);
        eulver.push_back(v);
    }
}
 
int main()
{
    //ifstream cin("input.txt");
    int n, c;
    cin >> n >> c;
    int C = c;
    bool ok = false;
    bool kek = false;
    get_ver(c);
    vector<pair<int, int> > bad;
    int good_c = 0;
    for (int i = 1; i <= n; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        if (w == 1)
            ok = true;
        if (a == C)
            kek = true;
        if (w == 0)
            bad.push_back({ a, i });
        else
        {
            int v = get_ver(a);
            int u = get_ver(b);
            g[v].push_back({ u, i });
            inc[u]++;
            good_c++;
        }
    }
    if (!ok){
        assert(false);
        cout << (kek ? "No\n" : "Yes\n");
        return 0;
    }
    n = g.size();
    if (n == 1 && bad[0].first == bad.back().first && bad[0].first == c)
    {
        cout << "No";
        return 0;
    }
    int bv = 0;
    int X = -1;
    for (int i = 1; i < n; i++)
        if (g[i].size() != inc[i])
        {
            if (inc[i] != g[i].size() + 1)
            {
                cout << "No";
                return 0;
            }
            X = i;
            bv++;
        }
    if (bv > 1)
    {
        cout << "No";
        return 0;
    }
    if (bv == 1)
    {
        if (g[0].size() != inc[0] + 1)
        {
            cout << "No";
            return 0;
        }
        g[X].push_back({ 0, 0 });
        good_c++;
    }
    dfs(0);
    if (eulver.size() != good_c)
    {
        cout << "No";
        return 0;
    }
    reverse(eulver.begin(), eulver.end());
    reverse(eule.begin(), eule.end());
    vector<bool> vis(n, 0);
    int beg = 0;
    int m = eule.size();
    for (beg = 0; eulver[beg] != 0 || (bv && eule[(beg + m - 1) % m] != 0) ; beg++);
    cout << "Yes\n";
    for (int i = beg; i < m; i++)
    {
        if (!vis[eulver[i]])
        {
            vis[eulver[i]] = 1;
            vector<pair<int, int> > resbad;
            for (auto p : bad)
            {
                if (p.first != verval[eulver[i]])
                    cout << p.second << " ";
                else
                    resbad.push_back(p);
            }
            bad = resbad;
        }
        if (eule[i])
            cout << eule[i] << " ";
    }
    for (int i = 0; i < beg; i++)
    {
        if (!vis[eulver[i]])
        {
            vis[eulver[i]] = 1;
            vector<pair<int, int> > resbad;
            for (auto p : bad)
            {
                if (p.first != verval[eulver[i]])
                    cout << p.second << " ";
                else
                    resbad.push_back(p);
            }
            bad = resbad;
        }
        if (eule[i])
            cout << eule[i] << " ";
    }
    return 0;
}