//
// Created by ahmad on 14.11.2020.
//

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <cmath>

using namespace std;

#define ff first
#define ss second
#define mp(x, y) make_pair(x, y)
#define gt(x, y) get<y>(x)
#define all(x) x.begin(), x.end()

using ll = int64_t;
using ul = uint64_t;
using ld = long double;

ll c[3322];
ll square_pref[3322];
ll chain_pref[3322];
size_t d;
ld p;

ll calc_averege_mul_by_n(size_t l, size_t r) {  // A([l, r]) = c_n - c_0;
  return c[r] - c[l];
}

ll calc_deviation_squared_mul_by_n_squared(
        size_t l,
        size_t r,
        ll averege_mul_by_n) {  // D^2([l, r]) * n^2= sum(c_i - c_{i-1} - A) * n^2
//  ll ans = 0;
//  for (size_t i = l + 1; i <= r; i++) {
//    ans += 2 * c[i]*c[i];
//  }
//  for (size_t i = l + 1; i <= r; i++) {
//    ans -= 2 * c[i] * c[i - 1];
//  }
//  ans += c[l]*c[l] - c[r]*c[r];
//  ans *= (r - l);
//  ans -= averege_mul_by_n * averege_mul_by_n;
//  return ans;
  return (2 * (square_pref[r] - square_pref[l]
               - (chain_pref[r] - chain_pref[l]))
                + c[l]*c[l] - c[r]*c[r]) * (r - l) - averege_mul_by_n * averege_mul_by_n;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin >> d >> p;
  for (size_t i = 0; i < d; i++) {
    cin >> c[i];
  }
  square_pref[0] = c[0] * c[0];
  for (size_t i = 1; i < d; i++) {
    square_pref[i] = square_pref[i - 1] + c[i] * c[i];
  }
  chain_pref[0] = 0;
  for (size_t i = 1; i < d; i++) {
    chain_pref[i] = chain_pref[i - 1] + c[i] * c[i - 1];
  }
  size_t negative_count = 0;
  size_t positive_count = 0;
  for (size_t i = 0; i < d; i++) {
    for (size_t j = 2; i + j < d; j++) {
      ll an = calc_averege_mul_by_n(i, i + j);
      ll dsqnsq = calc_deviation_squared_mul_by_n_squared(i, i + j, an);
      if ((an * an) / p / p >= dsqnsq || dsqnsq == 0) {
        if (an > 0) {
          positive_count++;
        } else if (an < 0) {
          negative_count++;
        }
      }
    }
  }
  cout << positive_count << ' ' << negative_count;
  return 0;
}