#include <iostream>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

constexpr int NMAX = 3000;
constexpr long double eps = 1e-8;
long double c[NMAX];


bool isEqual(long double a) {
    return abs(a) < eps;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int d;
    long double P;
    cin >> d >> P;

    for (int i = 1; i <= d; i++) {
        cin >> c[i];
    }

    long long pos = 0, neg = 0;

    for (int len = 3; len <= d; len++) {
        for (int l = 1; l + len - 1 <= d; l++) {
            int r = l + len - 1;
            long double n = len - 1;
            long double A = (c[r] - c[l]) / n;
            long double D = 0;
            for (int i = l + 1; i <= r; i++) {
                D = D + (c[i] - c[i - 1] - A) * (c[i] - c[i - 1] - A);
            }
            D = sqrt(D/n);
            //cout << A << ' ' << D << '\n';
            if (isEqual(A)) continue;
            if ((A > eps && isEqual(D)) || ((A / D) >= P + eps)) {
                //cout << "pos " <<  l << ' ' << r << ' ' << A << ' ' << D << '\n';
                pos++;
                continue;
            };
            if ((A < -eps && isEqual(D)) || ((A / D) <= -P - eps)) {
                //cout << "neg " << l << ' ' << r << ' ' << A << ' ' << D << '\n';
                neg++;
            }
        }
    }

    cout << pos << ' ' << neg << '\n';

    return 0;
}

