
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>


std::vector<std::vector<long long>> binom;


long long count(long long n, long long k);


long long repeat(long long n, long long k) {
    if (n % 2 == 0) {
        long long res = 0;
        for (int i = 0; i <= k; i++) {
            if (k == 2 * i) {
                res += binom[n / 2][i] * binom[n / 2][i] - binom[n / 2][i];
            } else {
                res += binom[n / 2][i] * binom[n / 2][k - i];
            }
        }
        return res / 2;
    }
    long long res = 0;
    for (int i = 0; i <= k; i++) {
        if (k == 2 * i) {
            res += binom[n / 2][i] * binom[n / 2][i] - binom[n / 2][i];
        } else {
            res += binom[n / 2][i] * binom[n / 2][k - i];
        }
    }
    for (int i = 0; i < k; i++) {
        if (k - 1 == 2 * i) {
            res += binom[n / 2][i] * binom[n / 2][i] - binom[n / 2][i];
        } else {
            res += binom[n / 2][i] * binom[n / 2][k - i - 1];
        }
    }
    return res / 2;
}


long long count(long long n, long long k) {
    if (n == 0) { return 0; }
    if (k == 0) { return 1; }
    long long rep = repeat(n, k);
    return binom[n][k] - rep;
}


long long answer(long long n, long long k) {
    long long res = 0;
    for (int i = 0; i <= k; i++) {
        if (2 * i == k) {
            res += 2 * count(n, i);
            continue;
        }
        res += count(n, i);
    }
    return res;
}



int main() {


    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);


    long long n, k;
    std::cin >> n >> k;

    if (k > n) {
        k = 2 * n - k;
    }

    int size = 100;

    binom.resize(1 + size, std::vector<long long> (1 + size, 0));

    for (int i = 0; i <= size; i++) {
        binom[i][0] = 1;
    }
    binom[0][1] = 0;
    for(int i = 1; i <= size; i++){
        for(int j = 1; j <= i; j++){
            binom[i][j] = binom[i - 1][j - 1] + binom[i - 1][j];
        }
    }


    std::cout << answer(n, k) << '\n';




    return 0;
}