#pragma GCC target("avx2")

#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
// gp_hash_table<int, int>
tree<int, null_type, greater<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

int n, c, start, finish;
map<int, multiset<pair<int, int>>> g, gcopy, f;
map<int, int> deg_in, deg_out;
// g - graph, f - fails

void dfs(int v) {
    //cout << "dfs" sp v nl;
    while (gcopy[v].size()) {
        auto it = gcopy[v].begin();
        int u = it->first;
        gcopy[v].erase(it);
        --deg_out[v];
        --deg_in[u];
        dfs(u);
    }
}

bool check() {
    int odd_a = -1;
    int odd_b = -1;

    for (auto &i: g) {
        int d = deg_out[i.first] - deg_in[i.first];
        if (d != 0) {
            if (d == 1) {
                if (odd_a == -1) {
                    odd_a = i.first;
                } else {
                    return false;
                }
            } else if (d == -1) {
                if (odd_b == -1) {
                    odd_b = i.first;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
    }
    gcopy = map<int, multiset<pair<int, int>>>(g);
    //cout << odd_a sp odd_b nl;
    start = odd_a;
    finish = odd_b;

    if (odd_a != -1 && odd_a != c) {
        //dfs(odd_a);
        return false;
    } else {
        if (odd_a == -1) {
            start = c;
            finish = c;
        }
        dfs(c);
    }

    for (auto &i: gcopy) {
        if (i.second.size() > 0) {
            //cout << "fuck2" sp i.first sp i.second.begin()->first nl;
            return false;
        }
    }
    return true;
}

void solve() {
    cin >> n >> c;

    for (int i = 1; i <= n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        if (c == 1) {
            g[a].insert({b, i});
            ++deg_out[a];
            ++deg_in[b];
            if (!g.count(b)) {
                g[b] = multiset<pair<int, int>>();
            }
        } else {
            f[a].insert({b, i});
        }
    }

    if (!check()) {
        cout << "No" nl;
        return;
    }

    vector<pair<int, int>> st;
    st.reserve(1024);
    st.push_back({start, -1});

    vector<pair<int, int>> path;
    path.reserve(1024);

    if (start != finish) {
        g[finish].insert({start, 1e9});
        //cout << "non-cycle, insert edge" nl;
    }

    while (st.size() > 0) {
        int v = st.back().first;
        int e = st.back().second;
        bool f = false;

        while (g[v].size()) {
            auto it = g[v].begin();
            st.push_back({*it});
            g[v].erase(it);
            f = true;
            break;
        }

        if (!f) {
            st.pop_back();
            path.push_back({v, e});
        }
    }

    reverse(path.begin(), path.end());
    /*if (path[0] == path.back()) {
        path.pop_back();
    }*/

    /*for (auto &i: path) {
        cout << i.first sp i.second nl;
    }*/

    vector<int> ans;
    ans.reserve(1024);
    int last = c;

    int last_fail = -1;
    auto it = f.begin();

    while (it != f.end()) {
        if (it->first != last) {
            for (auto &j: it->second) {
                //cout << it->first sp j.first sp j.second sp "fail" nl;
                ans.push_back(j.second);
            }
            if (last_fail != -1) {
                f.erase(last_fail);
                last_fail = -1;
            }
            last_fail = it->first;
        }
        ++it;
    }

    if (last_fail != -1) {
        f.erase(last_fail);
    }

    for (auto &i: path) {
        //cout << i.first sp i.second nl;

        if (i.second != -1 && i.second != 1e9) {
            ans.push_back(i.second);
            last = i.first;
        } else {
            //cout << "skip this shit" nl;
            //continue;
        }

        int last_fail = -1;
        auto it = f.begin();

        while (it != f.end()) {
            if (it->first != last) {
                for (auto &j: it->second) {
                    //cout << it->first sp j.first sp j.second sp "fail" nl;
                    ans.push_back(j.second);
                }
                if (last_fail != -1) {
                    f.erase(last_fail);
                    last_fail = -1;
                }
                last_fail = it->first;
            }
            ++it;
        }

        if (last_fail != -1) {
            f.erase(last_fail);
        }
    }

    for (auto &i: f) {
        if (i.second.size() > 0) {
            cout << "No" nl;
            return;
        }
    }

    cout << "Yes" nl;

    for (auto &i: ans) {
        cout << i sq;
    }

}
