import org.w3c.dom.ls.LSOutput;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

/**
 * @author Michael Gerasimov
 * start: 14.11.2020
 * @version -
 */
public class ICPC {

    public static void main(String[] args) throws FileNotFoundException {
        FastReader scanner = new FastReader(System.in);
        int NumberOfCharacters = scanner.nextInt();
        int Width = scanner.nextInt();
        int Height = scanner.nextInt();
        int NumberOfSwitches = scanner.nextInt();

        HashSet<Character> Alphabet = new HashSet<>();
        HashMap<Character, String[]> DescriptionOfCharacter = new HashMap<>();

        for (int i = 0; i < NumberOfCharacters; i++) {
            char Letter = scanner.next().charAt(0);
            Alphabet.add(Letter);
            String[] CurrentDescription = new String[Height];
            for (int j = 0; j < Height; j++) {
                CurrentDescription[j] = scanner.next();
            }
            DescriptionOfCharacter.put(Letter, CurrentDescription);
        }

        int max = 0;
        char maxLetter = ' ';
        for (char key: DescriptionOfCharacter.keySet()) {
            for (String str: DescriptionOfCharacter.get(key)) {
                char[] array = str.toCharArray();
                int k = 0;

                int startIndex = 0;
                for (int i = 0; i < array.length; i++) {
                    if (array[i] == array[0]) {
                        startIndex = i;
                    } else {
                        break;
                    }
                }

                char PreviousCharacter = array[0];
                for (int i = startIndex; i < array.length; i++) {
                    if (array[i] != PreviousCharacter) {
                        k++;
                        PreviousCharacter = array[i];
                    }
                }
                if (k > max) {
                    max = k;
                    maxLetter = key;
                }
            }
        }

        max++;
        for (int i = 0; i < NumberOfSwitches / max; i++) {
            System.out.print(maxLetter);
        }
    }

}

class FastReader {
    BufferedReader br;
    StringTokenizer st;

    FastReader(InputStream input) throws FileNotFoundException {
        br = new BufferedReader(new InputStreamReader(input));
    }

    String next() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }
}
/*
.#....##..###.
#.#..#..#.#..#
.#...#....###.
.#...#..#.#...
###...##..#...

 */