#include <iostream>
#include <vector>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <random>

using namespace std;

const int MAXN = 51;

int a[MAXN];
mt19937 rnd(time(NULL));

int n = 50;

void test_init() {
    for (int i = 0; i < n; ++i)
        a[i] = i + 1;
    shuffle(a, a + n, rnd);
}

int cnt_q = 0;

int interactor(int i, int j) {
    cnt_q++;
    i--, j--;
    int res = 0;
    if (a[i] > a[j]) {
        swap(a[i], a[j]);
    }
    bool is_sorted = 1;
    for (int i = 1; i < n; ++i)
        is_sorted &= (a[i] > a[i - 1]);
    if (is_sorted) {
        return 2;
    }
    if (cnt_q == 10000) {
        exit(0);
    }
    return res;
}

int query(int i, int j) {
    int res = 3;
#ifdef LOCALDDD
    res = interactor(i, j);
#else
    cout << i << ' ' << j << endl;
    string s;
    cin >> s;
    if (s == "SWAPPED")
        res = 1;
    else if (s == "STAYED")
        res = 0;
    else
        res = 2;
#endif
    return res;
}

void slow_iter() {
    for (int i = n; i; --i) {
        for (int j = 1; j < i; ++j) {
            int res = query(j, i);
            if (res == 2) {
                exit(0);
            }
        }
    }
}

void fast_iter() {
    for (int i = n; i > 1; --i) {
        int res1 = query(i - 1, i);
        if (res1 == 2) {
            exit(0);
        }
        if (res1 == 1) {
            for (int j = 1; j < i - 1; ++j) {
                int res2 = query(j, i);
                if (res2 == 2) {
                    exit(0);
                }
            }
        }
    }
}

int main() {
#ifdef LOCAL
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n;
    slow_iter();
    while (true) {
        fast_iter();
    }
}
