#include <iostream>
#include <vector>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <random>
#include <cassert>

using namespace std;

const int MAXN = 51;

int a[MAXN];
mt19937 rnd(time(NULL));

int n = 50;

void test_init() {
    for (int i = 0; i < n; ++i)
        a[i] = i + 1;
    shuffle(a, a + n, rnd);
//    reverse(a, a + n);
}

int cnt_q = 0;

int interactor(int i, int j) {
    cnt_q++;
    i--, j--;
    int res = 0;
    if (a[i] > a[j]) {
        swap(a[i], a[j]);
    }
    bool is_sorted = 1;
    for (int i = 1; i < n; ++i)
        is_sorted &= (a[i] > a[i - 1]);
    if (is_sorted) {
        cerr << cnt_q << endl;
        return 2;
    }
    if (cnt_q % (2 * n) == 0) {
        int i = abs((int)rnd()) % n;
        int j = abs((int)rnd()) % n;
        swap(i, j);
    }
    if (cnt_q == 10000) {
        exit(0);
    }
    return res;
}

int query(int i, int j) {
    int res = 3;
#ifdef LOCALDDD
    res = interactor(i, j);
#else
    cout << i << ' ' << j << endl;
    string s;
    cin >> s;
    if (s == "SWAPPED")
        res = 1;
    else if (s == "STAYED")
        res = 0;
    else
        res = 2;
#endif
    if (res == 2) {
        exit(0);
    }
    return res;
}

void iter() {
    for (int i = n; i > 1; --i) {
        int cnt = 0;
        bool flag = 0;
        for (int j = n; j > i + 1; --j) {
            int res = query(j - 1, j);
            cnt++;
            if (res == 1) {
                flag = 1;
                for (int k = 1; k <= j - 2; ++k) {
                    query(k, j - 1);
                    cnt++;
                }
                cnt++;
                int res1 = query(j - 1, j);
                break;
            }
        }
        if (!flag && i < n) {
            for (int j = 1; j <= i; ++j)
                query(j, i + 1), cnt++;
        }
        for (int j = 1; j < i; ++j)
            query(j, i), cnt++;
        while (cnt < 2 * n)
            query(n - 1, n), cnt++;
    }
}

int main() {
#ifdef LOCALDDD
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifndef LOCALDDD
    cin >> n;
#else
    test_init();
#endif
    while (true) {
        iter();
    }
}
