#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>

using namespace std;

int n, c;
std::set<int> V;
map<int, map<int, int>> E;
map<int, map<int, vector<int>>> ind_E, ind_u_E;
map<int, int> deg;
std::map<int, bool> visited;
stack<int> S;

void calculate_deg() {
    for (const auto& e1 : E) {
        int u = e1.first;
        for (const auto& e2 : E[u]) {
            int v = e2.first;
            int d = e2.second;
            deg[u] += d;
            deg[v] += d;
        }
    }
}

void dfs(int u) {
    visited[u] = true;
    for (const auto& e2 : E[u]) {
        int v = e2.first;
        if (!visited[v]) {
            dfs(v);
        }
    }
}

bool checkForEulerPath() {
    int odd_vertex = 0;

    for (const auto v : V) {
        if (deg[v] % 2 == 1) {
            odd_vertex++;
        }

        if (odd_vertex > 2) {
            return false;
        }
    }

    for (const auto v : V) {
        if (deg[v] > 0) {
            dfs(v);
            break;
        }
    }

    for (const auto v : V) {
        if (deg[v] > 0 && !visited[v]) {
            return false;
        }
    }

    return true;
}

void findEulerPath(int v) {
    S.push(v);
    while (!S.empty()) {
        int w = S.top();
        if (!ind_u_E.empty()) {
            for (auto& i1 : ind_u_E) {
                int w1 = i1.first;
                auto& m1 = i1.second;
                if (w1 != w) {
                    for (auto& i2 : m1) {
                        auto &v1 = i2.second;
                        for (const auto ind1 : v1) {
                            cout << ind1 << " ";
                        }
                        v1.clear();
                    }
                }
            }
        }
        bool found_edge = false;
        for (const auto u : V) {
            if (E[w][u]) {
                S.push(u);
                E[w][u]--;
                cout << ind_E[w][u].back() << " ";
                ind_E[w][u].pop_back();
                found_edge = true;
                break;
            }
        }
        if (!found_edge) {
            S.pop();
        }
    }
}

int main() {
    scanf("%d %d", &n, &c);

    for (int i = 0; i < n; i++) {
        int a, b, w;
        scanf("%d %d %d", &a, &b, &w);

        if (w) {
            V.insert(a);
            V.insert(b);
            E[a][b]++;
            ind_E[a][b].push_back(i + 1);
        }
        else {
            ind_u_E[a][b].push_back(i + 1);
        }
    }

    calculate_deg();

    if (deg[c] == 0) {
        if (E.empty()) {
            cout << "Yes" << endl;
            for (int i = 1; i <= n; i++) {
                cout << i << " ";
            }
            cout << endl;
        }
        else {
            cout << "No" << endl;
        }
    }
    else {
        if (deg[c] % 2 && checkForEulerPath()) {
            cout << "Yes" << endl;
            findEulerPath(c);
            cout << endl;
        }
        else {
            cout << "No" << endl;
        }
    }

    return 0;
}
