#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>

using namespace std;

int n, c;
set<int> V;
map<int, map<int, int>> E;
map<int, map<int, vector<int>>> ind_E, ind_u_E;
map<int, int> deg;
map<int, bool> visited;
stack<int> S;
vector<int> ans;

void calculate_deg() {
    for (const auto& e1 : E) {
        int u = e1.first;
        for (const auto& e2 : E[u]) {
            int v = e2.first;
            int d = e2.second;
            deg[u] += d;
            deg[v] += d;
        }
    }
}

void findEulerPath(int v) {
    S.push(v);
    while (!S.empty()) {
        int w = S.top();
        if (!ind_u_E.empty()) {
            for (auto& i1 : ind_u_E) {
                int w1 = i1.first;
                auto& m1 = i1.second;
                if (w1 != w) {
                    for (auto& i2 : m1) {
                        auto &v1 = i2.second;
                        for (const auto ind1 : v1) {
                            ans.push_back(ind1);
                        }
                        v1.clear();
                    }
                }
            }
        }
        while (E[w][w]) {
            E[w][w]--;
            ans.push_back(ind_E[w][w].back());
            ind_E[w][w].pop_back();
        }
        bool found_edge = false;
        for (const auto u : V) {
            if (E[w][u]) {
                S.push(u);
                E[w][u]--;
                ans.push_back(ind_E[w][u].back());
                ind_E[w][u].pop_back();
                found_edge = true;
                break;
            }
        }
        if (!found_edge) {
            return;
        }
    }
}

int main() {
    scanf("%d %d", &n, &c);

    for (int i = 0; i < n; i++) {
        int a, b, w;
        scanf("%d %d %d", &a, &b, &w);

        if (w) {
            V.insert(a);
            V.insert(b);
            E[a][b]++;
            ind_E[a][b].push_back(i + 1);
        }
        else {
            ind_u_E[a][b].push_back(i + 1);
        }
    }

    calculate_deg();

    if (deg[c] == 0) {
        if (E.empty()) {
            bool is_correct = true;
            for (auto& w1 : ind_u_E) {
                is_correct = is_correct && w1.first != c;
            }
            if (is_correct) {
                cout << "Yes" << endl;
                for (int i = 1; i <= n; i++) {
                    cout << i << " ";
                }
                cout << endl;
            }
            else {
                cout << "No" << endl;
            }
        }
        else {
            cout << "No" << endl;
        }
    }
    else {
        findEulerPath(c);
        bool is_correct = true;
        for (auto& w1 : E) {
            for (auto& u1 : w1.second) {
                is_correct = is_correct && u1.second == 0;
            }
        }
        if (is_correct) {
            cout << "Yes" << endl;
            for (auto i : ans) {
                cout << i << " ";
            }
            cout << endl;
        }
        else {
            cout << "No" << endl;
        }
    }

    return 0;
}
